commit cb0bc64c16b3a38cbf0c622830c18ac9ea6e2ffe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Sep 6 17:15:51 2010 +0100

    version: 1.10.0 *release*
    
    /me faints with excitement.

 cairo-version.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 87fad104645c481ab027afbc9fa45c54cacbc9a7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Sep 6 17:14:41 2010 +0100

    NEWS: Sum up 2 years of development for 1.10.0 in 60 lines

 NEWS |   61 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 61 insertions(+)

commit 04623ef9df7274d411a3b7f03129bf43e53e7086
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Sep 6 13:15:55 2010 +0100

    test: Add subsurface-outside-target refs to REFERENCE_IMAGES

 test/Makefile.am |    2 ++
 1 file changed, 2 insertions(+)

commit d5b2c2a12ebea33f4d108d4deec2e9111c8c7e12
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Sep 6 13:10:08 2010 +0100

    test: Rename clip-fill-*-unbounded.image16 ref to match REFERENCE_IMAGES

 test/clip-fill-eo-unbounded.image16.ref.png       |  Bin 0 -> 2887 bytes
 test/clip-fill-eo-unbounded.image16.rgb24.ref.png |  Bin 2887 -> 0 bytes
 test/clip-fill-nz-unbounded.image16.ref.png       |  Bin 0 -> 2887 bytes
 test/clip-fill-nz-unbounded.image16.rgb24.ref.png |  Bin 2887 -> 0 bytes
 4 files changed, 0 insertions(+), 0 deletions(-)

commit cab9682f9dc4c99dcd51ddb66abd756e2ac7a63c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Sep 6 12:24:47 2010 +0100

    check: Ignore the documentation errors.
    
    Currently it is complaining about having documentation for
    unconfigured sections, ignore it for now.

 doc/public/check-doc-coverage.sh |    6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 8127f1f5d52bb716dbd70efe096894f2a542f4a9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Sep 6 12:24:14 2010 +0100

    Bump pixman requirements to 0.18.4 for assorted fixes.

 README       |    2 +-
 configure.ac |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 21a2f90cdef3d592c1d1614852fe3929ed2aa765
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Sep 2 13:19:26 2010 +0100

    check: Make the actual error stand out

 doc/public/check-doc-coverage.sh |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 8258532794d0579f6c1b825b8cfb9c8f7ced4369
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Sep 2 13:15:07 2010 +0100

    Reduce the cairo_device_type_t to only hold the used entries.
    
    This should help clarify the documentation by not mentioning non-existent
    devices and prevent any assumed coupling between surface-type values and
    devices.

 src/cairo.h                              |   49 +++++-------------------------
 util/cairo-gobject/cairo-gobject-enums.c |   24 +++------------
 2 files changed, 12 insertions(+), 61 deletions(-)

commit e3afbc1875d618c6d7e893971372be8f9889fc8b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Sep 2 13:07:53 2010 +0100

    check: Fix for link-time-optimisation

 src/check-def.sh |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a9e055ff481303428cd9684dca826bc3f5d868c5
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Sep 2 14:51:30 2010 +0100

    freelist: Separate freelist inlines from the datatype in headers.
    
    The cairo-freelist-private.h header has a number of static inline
    functions which call hidden functions in libcairo.  This poses
    a problem on Solaris where the native compiler compiles inline
    functions whether they are used or not, thereby adding the
    link time requirements on hidden functions from whatever code
    that includes cairo-freelist-private.h.  Unfortunately the
    boilerplate code includes cairo-private headers and indirectly
    the freelist header, so linking the boilerplate helper library
    fails on Solaris.
    
    This patch separates the structure definitions from the function
    prototypes and static inlines in cairo-freelist-private.h by moving
    the datatypes to a new cairo-freelist-type-private.h.

 src/Makefile.sources              |    1 +
 src/cairo-freelist-private.h      |   28 +------------------
 src/cairo-freelist-type-private.h |   54 +++++++++++++++++++++++++++++++++++++
 src/cairo-xlib-display.c          |    2 +-
 src/cairo-xlib-private.h          |    2 +-
 5 files changed, 58 insertions(+), 29 deletions(-)

commit f5632d641c44a143386ca3b413e90ed3b1a85f89
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Sep 2 13:55:55 2010 +0300

    build: Remove stray backslash.
    
    A stray backslash bwetween two assignment lines apparently
    invokes a GNU make extension for conditional assignments.
    This patch fixes the build when using the native Solaris make.

 src/Makefile.sources |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3a8b8fcc2a8a48cef49211c45723862f9fa8db23
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Sep 1 21:14:40 2010 +0200

    gobject: Fix header defines

 util/cairo-gobject/cairo-gobject.h |   64 ++++++++++++++++++------------------
 1 file changed, 32 insertions(+), 32 deletions(-)

commit 54a651564cdd2510d0a66f6720c4a45733ff3285
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Sep 1 18:47:16 2010 +0200

    build: Work around caching not reevaluating uncached variables
    
    This is a somewhat crude hack to ensure that GOBJECT_CFLAGS/LIBS are
    properly cached.

 configure.ac |    4 ++++
 1 file changed, 4 insertions(+)

commit 28ba78a9716f3c105cdfb5f7519f2435dd9cb271
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Sep 1 18:46:46 2010 +0200

    gobject: Fix pkgconfig file variable
    
    I confused % and $. I blame it on spec files.

 configure.ac |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 61a1835e40d0b6d786951143779077d16ed2486e
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Sep 1 03:17:12 2010 +0200

    subsurface: Fix acquire_source_surface for out-of-bounds surfaces
    
    See subsurface-outside-target test.

 src/cairo-surface-subsurface.c |   41 ++++++++++++++++++++++------------------
 1 file changed, 23 insertions(+), 18 deletions(-)

commit f54c51e75c7abe872127d559e029bf4383439bca
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Sep 1 02:10:51 2010 +0200

    test: Add subsurface-outside-target
    
    This test defines the behavior of subsurfaces when they are created to
    be bigger than their target.

 test/Makefile.sources                         |    1 +
 test/subsurface-outside-target.argb32.ref.png |  Bin 0 -> 2063 bytes
 test/subsurface-outside-target.c              |  178 +++++++++++++++++++++++++
 test/subsurface-outside-target.rgb24.ref.png  |  Bin 0 -> 1648 bytes
 4 files changed, 179 insertions(+)

commit 6eab5ee10c111cf87dcf62e3f639f44cfd1e5cf6
Author: Maarten Bosmans <mkbosmans@gmail.com>
Date:   Sat Aug 28 13:39:21 2010 +0200

    build: prefer libpng14 over older versions
    
    Also move libpng to the front of the list, so that the default
    version of the system is first checked.

 configure.ac |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9f98ec6eb915204d59820cf57d32f347f9933517
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Aug 29 00:05:51 2010 +0300

    device: Refer the user to per-backend docs about devices.
    
    The exact semantics of the device API can't be spelled out
    out in the device API docs since the effects are so tied
    to the specific backend.  To use a particular device in
    practice the user should refer to the backend docs.

 src/cairo-device.c |    6 ++++++
 1 file changed, 6 insertions(+)

commit b0f65054b810d432238ff4986bee3f63e1fc46df
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Aug 29 00:03:07 2010 +0300

    subsurface: Add a note to the docs about usage restrictions.
    
    Make our assumptions about constructed subsurfaces explicit
    while we work out the correct semantics for the edge cases.

 src/cairo-surface-subsurface.c |    7 +++++++
 1 file changed, 7 insertions(+)

commit 92fe2d370d120f4d9bc95e92209d1c1cec7e900b
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Aug 28 17:12:45 2010 +0200

    surface-offset: Use right variable in mask
    
    Use source/mask instead of their copies. The copies only get initialized
    if we actually need to translate things.

 src/cairo-surface-offset.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit df4b23ff74f3d22fb306f59cdba4dce6b0857cd2
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Fri Aug 27 20:26:06 2010 +0300

    subsurface: Fix crash when acquiring a source image.
    
    The code is passing in the extra info received from
    the target surface's acquire_source() method to
    _cairo_surface_get_extents() rather than the acquired
    source surface itself.

 src/cairo-surface-subsurface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2d146867dc4d4e17da2fd1e4776f62aaa999d90f
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Aug 26 14:50:34 2010 +0200

    subsurface: Correct cloning condition
    
    72644c6df2c2da1d77ca10a755dbb44bbd960c0d was using the wrong (inverted)
    condition to check if the subsurface extents are contained in the
    target extents.

 src/cairo-surface-subsurface.c |   10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 72644c6df2c2da1d77ca10a755dbb44bbd960c0d
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Aug 26 14:24:17 2010 +0200

    subsurface: Avoid invalid accesses
    
    Whenever subsurface extents are not contained in the target extents,
    using the source image given by the target (with origin corrected by
    using an appropriate offset in the data pointer) is not a valid
    operation. Fallback to cloning in that case.

 src/cairo-surface-subsurface.c |   12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit df4465bdd11e25a1ed942bc0fc8e7dc5d43f951f
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Aug 26 14:23:04 2010 +0200

    subsurface: Silence compiler warnings
    
    Commit d1c35f5e65d53f6b8b9060455335424ca0f44bd0 introduced two
    unused variable warnings.

 src/cairo-surface-subsurface.c |    2 --
 1 file changed, 2 deletions(-)

commit d1c35f5e65d53f6b8b9060455335424ca0f44bd0
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Aug 26 13:55:02 2010 +0200

    subsurface: Don't clip size to target size
    
    This clipping would modify the origin of the subsurface and then the
    creator has no easy way to figure this out.

 src/cairo-surface-subsurface.c |    3 ---
 1 file changed, 3 deletions(-)

commit 174fb5f16f93887e2f319edd5b46efae3e7e93ad
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Aug 26 13:21:04 2010 +0200

    subsurface: Don't apply device transform twice for source/mask

 src/cairo-surface-offset.c |   12 ------------
 1 file changed, 12 deletions(-)

commit e79acf47a57b60c83d1f9491aac354161986b29b
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Aug 26 12:54:25 2010 +0200

    subsurface: Make CAIRO_SURFACE_TYPE_SUBSURFACE public

 src/cairo-analysis-surface.c    |    2 +-
 src/cairo-image-surface.c       |    2 +-
 src/cairo-pdf-surface.c         |    4 ++--
 src/cairo-ps-surface.c          |    4 ++--
 src/cairo-script-surface.c      |    2 +-
 src/cairo-surface-subsurface.c  |    4 ++--
 src/cairo-types-private.h       |    3 +--
 src/cairo-xcb-surface-render.c  |    4 ++--
 src/cairo-xlib-surface.c        |    2 +-
 src/cairo.h                     |    7 ++++++-
 src/drm/cairo-drm-i915-shader.c |    6 +++---
 src/drm/cairo-drm-i965-shader.c |    6 +++---
 12 files changed, 25 insertions(+), 21 deletions(-)

commit 40459dacb52587cc784faf2635e54797d3989408
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Aug 26 11:45:28 2010 +0200

    subsurface: Don't crash when the device transform isn't integer
    
    Apply the transform before rounding to integer coordinates, so we can
    handle doubles easily.

 src/cairo-surface-subsurface.c |   10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit e19b213e84ab8b8ead5e0c700e5b906590e22aa1
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Aug 26 11:18:29 2010 +0200

    subsurface: Make subsurfaces their own type
    
    Do not try to hide being a subsurface.
    This would cause confusion when users where calling surface-type
    specific getters on subsurfaces.
    
    FIXME: We still need public API to access a subsurface's target though.

 src/cairo-surface-subsurface.c |    1 -
 1 file changed, 1 deletion(-)

commit e65bf64c4a6e2c7ff673449b8459b3150e438e21
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Aug 26 11:17:06 2010 +0200

    subsurface: Properly account for device offsets in the target

 src/cairo-surface-subsurface.c |   10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 8e9c4ea5890a4df3f463e592dc3aa429bb423608
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Aug 11 12:18:53 2010 +0100

    Mark the context as invalid on the final cairo_destroy()
    
    We initialise the context to a non-error state upon creation, but after
    destroy there is a window of opportunity where the object is kept alive
    inside the context pool and the user could mistakenly keep on passing
    the zombie context into cairo functions. As all entry points need to
    check error status, flagging the context as an error object upon the
    final unreference prevents such misuse (until such as time as the
    context is reallocated).

 src/cairo.c |    3 +++
 1 file changed, 3 insertions(+)

commit cd52378ae60ab2075d7e9ec7335e990b2f46059e
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Aug 10 19:38:59 2010 +0200

    test: Update linear-gradient-large ref image
    
    Make linear-gradient-large ref image match xlib gradients (both on nvidia
    and on macosx) and pixman gradients (when patched to compute the linear
    gradients using floating point math).

 test/linear-gradient-large.ref.png |  Bin 3753 -> 4079 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit a7762e3d6570a6981d8fb74ecc6ae30391c39b89
Author: Krzysztof Kosiński <tweenk.pl@gmail.com>
Date:   Tue Aug 10 17:55:03 2010 +0200

    tests: Add linear-gradient-large test
    
    Shows large rounding errors in Pixman when computing gradients. Added as
    a test to Cairo to catch similar issues in other backends.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=29470

 test/Makefile.am                   |    5 +--
 test/Makefile.sources              |    1 +
 test/linear-gradient-large.c       |   67 ++++++++++++++++++++++++++++++++++++
 test/linear-gradient-large.ref.png |  Bin 0 -> 3753 bytes
 4 files changed, 71 insertions(+), 2 deletions(-)

commit 56ea51fdcc273531b5e86b921aad19237a1c9415
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Aug 9 20:23:50 2010 +0200

    Replace insertion sort with mergesort in the scan converter
    
    Insertion sort can take up to O(n^2), mergesort is guaranteed to run
    in O(n*log(n)).
    An example showing bad performance for insertion sort is:
       https://bugs.freedesktop.org/show_bug.cgi?id=28067
    
    The mergesort has been engineered to be fast even when working on
    cases where the insertion sort would have performed well and as
    expected it shows no changes in the benchmark cairo traces.

 src/cairo-tor-scan-converter.c |  138 ++++++++++++++++++++++++++++++----------
 1 file changed, 103 insertions(+), 35 deletions(-)

commit a150371a5d10e03d6c0d781c6fac950a9ac6be18
Author: Nicolaus L Hepler <nlhepler@gmail.com>
Date:   Tue Aug 10 09:34:39 2010 +0200

    ft-font: Make alpha mapping consistent
    
    Vertical RGB mapping previously forced opaque pixels.
    To be consistent with horizontal RGB/BGR and vertical BGR it
    should use an alpha equal to the mid channel (green).

 src/cairo-ft-font.c |    7 -------
 1 file changed, 7 deletions(-)

commit 73470862cbc5895147d5c58ca2647f539e8fe67c
Author: David Schleef <ds@schleef.org>
Date:   Tue Aug 10 02:37:38 2010 +0200

    perf: Fix README to say cairo-perf-micro

 perf/README |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit df8f96423429915ef1648310fce8b5aed0917c0a
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Aug 10 01:24:30 2010 +0200

    build: Fudge the build system some more so it handles extra libs
    
    Add NONPKGCONFIG_EXTRA_LIBS that are only put into the generated pc file
    but not used when linking. This is now used to add -lcairo-gobject to
    the cairo-gobject.pc file.

 build/configure.ac.features          |    3 +++
 configure.ac                         |    2 +-
 src/cairo-features-uninstalled.pc.in |    2 +-
 src/cairo-features.pc.in             |    2 +-
 4 files changed, 6 insertions(+), 3 deletions(-)

commit 01325ad767acf6213135a0bad895de233324f745
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Aug 10 00:11:25 2010 +0200

    gobject: Include the extra library in the pkgconfig file

 configure.ac |    1 +
 1 file changed, 1 insertion(+)

commit 8fb91dc3f6b691f91c322cec4b1d0ee4dbebd69c
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Tue Aug 10 00:53:53 2010 +0300

    script: Fix script backend build.
    
    The flight data recorders were missing an include
    of cairo-tee.h ever since cairo-tee.h became an optional
    backend.

 util/cairo-fdr/fdr.c    |    1 +
 util/cairo-sphinx/fdr.c |    1 +
 2 files changed, 2 insertions(+)

commit 766832364904dbf5b8a67ebc1600d2ec45d2734f
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Aug 9 18:47:13 2010 +0200

    perf: Improve calibration
    
    Make the loops count depend on the actual calibration_loops/calibration_time
    instead of calibration_loops/calibration_max_time.
    This avoids having some tests take much less/more than the wanted time per iteration
    (I was having some tests taking about 1 second, other taking about 7 seconds when
    the ms_per_iteration was 2000)
    
    Spend 0.5-1 times the time wanted for each iteration in calibration, increase the
    accuracy of loops count. Just making the loops count be the correct ratio doesn't
    guarantee that the iteration time is accurate. By actually measuring iteration
    times until it gets greater than 1/4 of the wanted time, the total sum is bound
    to be <= the wanted iteration time and last calibration time is between 1/4 and
    1/2 of the wanted time, so it should give a very accurate loop count.

 perf/cairo-perf-micro.c |   17 ++++++++---------
 1 file changed, 8 insertions(+), 9 deletions(-)

commit 046b642db0782ab5e2a5c82988b21e05afe8e716
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 16:30:59 2010 +0300

    os2: Restore surface type checking in the get_extents method.

 src/cairo-os2-surface.c |   10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 78bdd87b7545f8e85632ac301a69da145727fcec
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 16:22:26 2010 +0300

    os2: Fix clipping to bounds when blitting pixels.
    
    The bounds checks on the rectangle to blit were done
    after converting target/source to inclusive/noninclusive
    coordinates rather than before, potentially causing an
    off-by-one in the sizes, since the same logic was applied
    to both inclusive and non-inclusive coordinates.  This
    patch enforces bounds up front.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-surface.c |   62 +++++++++++++++++++++--------------------------
 1 file changed, 27 insertions(+), 35 deletions(-)

commit d0284687b32161212d6bc52309e2d5bb516dc3e8
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 03:53:24 2010 +0300

    os2: Tweak an inline declaration.
    
    C99 and cairo prefers "static inline <return type>" rather
    than "static <return type> inline".
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cb30340064a2ff24dc408e185c5a309a14f6c78c
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 03:33:10 2010 +0300

    os2: Consolidate error paths of cairo_os2_surface_create().
    
    Use a single code path to release the resources acquired
    for a surface that's been partially constructed, rather than
    have multiple error exits which each release the resources
    acquired so far.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-surface.c |  120 +++++++++++++++++++++++------------------------
 1 file changed, 60 insertions(+), 60 deletions(-)

commit 66e3d650fe90754c811195c75579ac7a3512b7be
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 03:12:12 2010 +0300

    os2: Document ownership of OS/2 objects passed to surfaces.
    
    Clarify the documentation for cairo_os2_surface_create()
    and cairo_os2_surface_set_hwnd() to note that the ownership
    of the presentation space and window respectively
    remains with the caller.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-surface.c |   23 ++++++++++++-----------
 1 file changed, 12 insertions(+), 11 deletions(-)

commit 01525271544d5b88f87027e470fa85038d59bf8d
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 03:08:21 2010 +0300

    os2: Don't fake an Anchor Block when one isn't needed.
    
    The code was being tricky about passing in a HAB to
    DevOpenDC() even though one isn't needed at all under
    OS/2.  Pass in NULL instead.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-surface.c |   16 +++-------------
 1 file changed, 3 insertions(+), 13 deletions(-)

commit 883d9725e0f844e7d5cc4c50c75a812b5435702b
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 03:01:56 2010 +0300

    os2: Fix buffer allocator behaviour on arithmetic overflow.
    
    On arithmetic overflow the buffer allocator would attempt
    to allocate zero bytes instead of failing the allocation.
    Depending on the implementation of the underlying allocator
    being proxied, this may result in an allocation of a zero
    length buffer, causing all kinds of grief.  This patch
    causes arithmetic overflows to explicitly fail the allocation.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-surface.c |   54 ++++++++++++++++++++---------------------------
 1 file changed, 23 insertions(+), 31 deletions(-)

commit b54037828c5b338b2f1dcbe48201225b258c1e1e
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 02:40:20 2010 +0300

    os2: Fix blitting 24 bpp pixel data.
    
    There's a format mismatch between cairo's pixel formats
    and OS/2 24 bpp data: the individual pixels in OS/2 take
    only three bytes per pixel, but there needs to be padding
    between lines to make the start of a line always be aligned
    at a DWORD boundary.
    
    This patch fixes the format conversion code to include
    the required padding between rows.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html

 src/cairo-os2-private.h |    1 +
 src/cairo-os2-surface.c |  116 +++++++++++++++++++++++++++--------------------
 2 files changed, 68 insertions(+), 49 deletions(-)

commit 5aadecb3ac03d379c2c8113566fa8062843df42e
Author: Rich Walsh <DragText@E-vertise.Com>
Date:   Sat Aug 7 02:30:01 2010 +0300

    os2: New API to create surfaces without a persistent HPS.
    
    It's not always necessary to create a presentation space (HPS) for
    surface tied to a window, as the user may have one already.  This patch
    introduces three new functions to create a surface without an HPS
    and let the user manage an HPS associated with the surface.
    
    Thread "OS/2 surface fixes" on cairo-l:
    http://lists.cairographics.org/archives/cairo/2010-July/020343.html
    
    Mozilla Bugzilla:
    https://bugzilla.mozilla.org/show_bug.cgi?id=557159

 src/cairo-os2-surface.c |  142 ++++++++++++++++++++++++++++++++++++++++++++++-
 src/cairo-os2.h         |   14 +++++
 2 files changed, 153 insertions(+), 3 deletions(-)

commit 9669faa936fe38da3615d7831e423befa5ecdfad
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Aug 8 17:23:05 2010 +0200

    gl: Handle errors from _cairo_gl_gradient_render()
    
    Thanks Andrea for finding this.

 src/cairo-gl-gradient.c |    9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit e31b56e020df806aa6180cd2efa0a34e55e5adaf
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Aug 8 14:45:24 2010 +0200

    configure: Fix gobject handling
    
    1) Explicitly depend on glib, too.
    2) Don't link gobject into libcairo proper (thanks Joonas for noticing).

 configure.ac |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ae2b7b13cd5fdeaee44496056bb99f497346e262
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Aug 4 14:22:23 2010 +0200

    pattern: Simplify degenerate linear pattern to solid colors
    
    Degenerate linear patterns are considered clear if they have
    EXTEND_NONE, the average of the first and the last stop if they are
    EXTEND_PAD, the weighted average of the stops (based on the size of
    the interpolation range in which they are active, just like integrating
    over the whole interpolation range and taking the average) if they are
    EXTEND_REPEAT or EXTEND_REFLECT.
    
    Fixes degenerate-linear-gradient

 src/cairo-pattern.c                     |  119 ++++++++++++++++++++++++++++++-
 test/degenerate-linear-gradient.ref.png |  Bin 232 -> 322 bytes
 2 files changed, 117 insertions(+), 2 deletions(-)

commit d54a5a9fc90857448954d6cbe725d4665efa3d45
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Aug 4 14:16:34 2010 +0200

    pattern: Add gradient degeneracy testing functions
    
    Introduce two new (private) functions for testing the degeneracy of linear
    and radial gradients and use them instead of verbose (and error-prone) tests.

 src/cairo-pattern.c |   21 +++++++++++++++++----
 1 file changed, 17 insertions(+), 4 deletions(-)

commit 63434bc43819e2c7d4db568e82f5a9a7dfb0418d
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Aug 4 14:22:01 2010 +0200

    gstate: Correct comment

 src/cairo-gstate.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 28cd511fb974f886ae65e588413afcfc220a1a7c
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sat Aug 7 22:55:46 2010 +0200

    Correct color stops comparison function
    
    Two clear stops with different "underlying" colors must be considered
    different, since when interpolated with non-clear colors they will
    produce different results.

 src/cairo-color.c |   25 ++++---------------------
 1 file changed, 4 insertions(+), 21 deletions(-)

commit f71a618bd2604c8f0beaf4816a38a54f6f271bd9
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sat Aug 7 21:32:09 2010 +0200

    Fix configuration if gobject is absent
    
    Autodetect gobject and only use it if present.
    Its absence is not to be considered a failure since it's not required.

 build/Makefile.win32.features |    2 +-
 configure.ac                  |    2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 661f4859cdbc0394ed0a9db34ced0f4e2bbe78ff
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Aug 7 20:05:42 2010 +0200

    Add cairo-gobject library
    
    This library is supposed to contain GType declarations for Cairo types.
    It is also meant to support gobject-introspection binding creation.

 boilerplate/Makefile.win32.features        |   12 +
 build/Makefile.win32.features              |    1 +
 build/Makefile.win32.features-h            |    3 +
 configure.ac                               |   10 +
 src/Makefile.win32.features                |   16 +
 util/Makefile.am                           |    4 +
 util/cairo-gobject/Makefile.am             |   15 +
 util/cairo-gobject/cairo-gobject-enums.c   |  519 ++++++++++++++++++++++++++++
 util/cairo-gobject/cairo-gobject-structs.c |   87 +++++
 util/cairo-gobject/cairo-gobject.h         |  186 ++++++++++
 10 files changed, 853 insertions(+)

commit fc4e8f036326da1839ec5320eba60823e7efc2db
Author: Søren Sandmann Pedersen <ssp@redhat.com>
Date:   Sat Aug 7 12:10:49 2010 -0400

    Update documentation to reflect that rgb565 is no longer deprecated.

 src/cairo.h |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit de606af5d673df193fc07fbd047ba2cec82d2f1c
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jul 27 18:04:36 2010 +0200

    quartz: improve backend detection
    
    Quartz previously crashed with NULL backends and didn't check for
    the backend type when getting a CGContext from a quartz surface,
    returning meaningless data for subsurfaces.

 src/cairo-quartz-surface.c |   24 +++++++++++++++---------
 1 file changed, 15 insertions(+), 9 deletions(-)

commit 056ce165c4377e9cf93fd7a06b6b0d5d4d98cb8c
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jul 27 18:50:55 2010 +0200

    quartz: fix solid masking fallback
    
    Falling back when painting would ignore the alpha value (which is
    needed to have the correct mask opacity).
    _cairo_quartz_surface_paint_cg doesn't fallback, so the usual mask
    fallback path is now taken, as expected.

 src/cairo-quartz-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bdeade14ea86fb5f3ff17accd71711d2c40b1b33
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Jul 28 19:33:53 2010 +0200

    quartz: fix stroking with unbounded operators
    
    Self-intersecting strokes were drawn incorrectly when an unbounded
    operator was used, since the fixup operation also cleared the
    intersection.
    
    Fixes clip-stroke-unbounded.

 src/cairo-quartz-surface.c |   14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit 8f38d2aa29bc0d69690cbf542c4a2b497b7a0c0a
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jul 29 10:45:59 2010 +0200

    test: improve clip-*-unbounded tests
    
    Merge clip-*-unbounded tests and add self-intersections to the paths
    that are drawn. This exposes a bug in the unbounded fixup code in quartz.
    
    Signed-off-by: Chris Wilson <chris@chris-wilson.co.uk>

 test/Makefile.am                                   |   35 ++--
 test/Makefile.sources                              |    3 +-
 test/clip-draw-unbounded.c                         |  184 ++++++++++++++++++++
 test/clip-fill-eo-unbounded.argb32.ref.png         |  Bin 0 -> 3668 bytes
 test/clip-fill-eo-unbounded.image16.rgb24.ref.png  |  Bin 0 -> 2887 bytes
 test/clip-fill-eo-unbounded.quartz.argb32.ref.png  |  Bin 0 -> 3366 bytes
 test/clip-fill-eo-unbounded.quartz.rgb24.ref.png   |  Bin 0 -> 3061 bytes
 test/clip-fill-eo-unbounded.rgb24.ref.png          |  Bin 0 -> 3201 bytes
 test/clip-fill-eo-unbounded.svg12.rgb24.xfail.png  |  Bin 0 -> 3636 bytes
 ...p-fill-eo-unbounded.xlib-fallback.rgb24.ref.png |  Bin 0 -> 3208 bytes
 test/clip-fill-eo-unbounded.xlib.argb32.ref.png    |  Bin 0 -> 3693 bytes
 test/clip-fill-eo-unbounded.xlib.rgb24.ref.png     |  Bin 0 -> 3198 bytes
 test/clip-fill-nz-unbounded.argb32.ref.png         |  Bin 0 -> 3668 bytes
 test/clip-fill-nz-unbounded.image16.rgb24.ref.png  |  Bin 0 -> 2887 bytes
 test/clip-fill-nz-unbounded.quartz.argb32.ref.png  |  Bin 0 -> 3366 bytes
 test/clip-fill-nz-unbounded.quartz.rgb24.ref.png   |  Bin 0 -> 3061 bytes
 test/clip-fill-nz-unbounded.rgb24.ref.png          |  Bin 0 -> 3201 bytes
 test/clip-fill-nz-unbounded.svg12.rgb24.xfail.png  |  Bin 0 -> 3636 bytes
 ...p-fill-nz-unbounded.xlib-fallback.rgb24.ref.png |  Bin 0 -> 3208 bytes
 test/clip-fill-nz-unbounded.xlib.argb32.ref.png    |  Bin 0 -> 3693 bytes
 test/clip-fill-nz-unbounded.xlib.rgb24.ref.png     |  Bin 0 -> 3198 bytes
 test/clip-fill-unbounded.argb32.ref.png            |  Bin 1607 -> 0 bytes
 test/clip-fill-unbounded.c                         |  105 -----------
 test/clip-fill-unbounded.image16.ref.png           |  Bin 1204 -> 0 bytes
 test/clip-fill-unbounded.pdf.argb32.ref.png        |  Bin 1244 -> 0 bytes
 test/clip-fill-unbounded.ps.argb32.xfail.png       |  Bin 1244 -> 0 bytes
 test/clip-fill-unbounded.quartz.argb32.ref.png     |  Bin 1436 -> 0 bytes
 test/clip-fill-unbounded.quartz.rgb24.ref.png      |  Bin 1368 -> 0 bytes
 test/clip-fill-unbounded.rgb24.ref.png             |  Bin 1304 -> 0 bytes
 test/clip-fill-unbounded.svg12.argb32.xfail.png    |  Bin 1601 -> 0 bytes
 test/clip-fill-unbounded.svg12.rgb24.xfail.png     |  Bin 1601 -> 0 bytes
 ...clip-fill-unbounded.xlib-fallback.rgb24.ref.png |  Bin 1438 -> 0 bytes
 test/clip-fill-unbounded.xlib.argb32.ref.png       |  Bin 1759 -> 0 bytes
 test/clip-fill-unbounded.xlib.rgb24.ref.png        |  Bin 1430 -> 0 bytes
 test/clip-stroke-unbounded.argb32.ref.png          |  Bin 1694 -> 3545 bytes
 test/clip-stroke-unbounded.c                       |  102 -----------
 test/clip-stroke-unbounded.image16.ref.png         |  Bin 1255 -> 0 bytes
 test/clip-stroke-unbounded.image16.rgb24.ref.png   |  Bin 0 -> 2778 bytes
 test/clip-stroke-unbounded.pdf.argb32.xfail.png    |  Bin 1351 -> 0 bytes
 test/clip-stroke-unbounded.ps.argb32.ref.png       |  Bin 1351 -> 0 bytes
 test/clip-stroke-unbounded.quartz.argb32.ref.png   |  Bin 1493 -> 3362 bytes
 test/clip-stroke-unbounded.quartz.rgb24.ref.png    |  Bin 1356 -> 3061 bytes
 test/clip-stroke-unbounded.rgb24.ref.png           |  Bin 1372 -> 3063 bytes
 test/clip-stroke-unbounded.svg12.argb32.xfail.png  |  Bin 1697 -> 0 bytes
 test/clip-stroke-unbounded.svg12.rgb24.xfail.png   |  Bin 1697 -> 3569 bytes
 ...ip-stroke-unbounded.xlib-fallback.rgb24.ref.png |  Bin 1437 -> 3123 bytes
 test/clip-stroke-unbounded.xlib.argb32.ref.png     |  Bin 1785 -> 3620 bytes
 test/clip-stroke-unbounded.xlib.rgb24.ref.png      |  Bin 1442 -> 3109 bytes
 48 files changed, 204 insertions(+), 225 deletions(-)

commit 142df6f9638e10d0712e092d902f7670965a88f9
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 30 22:04:44 2010 +0200

    configure: Disable xml backend by default
    
    We don't want to enable it by default when nobody uses it.

 boilerplate/Makefile.win32.features |    2 +-
 build/Makefile.win32.features       |    2 +-
 configure.ac                        |    2 +-
 src/Makefile.win32.features         |    2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit 9f33f8453b4949cfdc63169d3acd7238f89379c2
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 30 21:48:14 2010 +0200

    configure: Disable tee backend by default
    
    We don't want to enable it by default when nobody uses it.

 boilerplate/Makefile.win32.features |    4 +++-
 build/Makefile.win32.features       |    1 +
 build/Makefile.win32.features-h     |    2 ++
 configure.ac                        |    2 +-
 src/Makefile.win32.features         |    8 +++++++-
 src/cairo-surface.c                 |    4 ++++
 test/api-special-cases.c            |    6 ++++++
 7 files changed, 24 insertions(+), 3 deletions(-)

commit 9f4d677e2a6dd0bfbbbe20de39f92177bfdfc0e8
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 30 22:15:55 2010 +0200

    tee: Move definitions into separate header

 src/Makefile.sources     |    6 +++--
 src/cairo-tee-surface.c  |    2 ++
 src/cairo-tee.h          |   66 ++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo.h              |   17 ------------
 test/api-special-cases.c |    3 +++
 5 files changed, 75 insertions(+), 19 deletions(-)

commit 14639e6b8525ada2cb93abb1d70dde827b7bf9e0
Author: Kristian Høgsberg <krh@bitplanet.net>
Date:   Thu Jun 17 18:29:48 2010 -0400

    egl: Use EGL_KHR_surfaceless_opengl extension when available
    
    This lets us avoid creating a throwaway pbuffer just to make the
    context current.

 src/cairo-egl-context.c |   58 +++++++++++++++++++++++++++++++----------------
 1 file changed, 38 insertions(+), 20 deletions(-)

commit b6fd673d37e1c8962d15c0e0e59322a2002fc399
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 26 13:15:38 2010 +0100

    version: 1.9.15 post-snapshot bump

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ed8c6f42540f03a62fd64ad83b7c397528092232
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 26 12:53:44 2010 +0100

    version: 1.9.14 snapshot

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 81094cf4622302ebaa9b3f328f5d2a56a1c07a64
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 26 12:52:56 2010 +0100

    NEWS: 1.9.14

 NEWS |   27 +++++++++++++++++++++++++++
 1 file changed, 27 insertions(+)

commit c1fcbd0322f86327ddd89c2eef2facbc74045629
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Jul 26 11:21:48 2010 +0200

    quartz: fix REFLECT radial gradients
    
    The interpolation range of repeating radial gradients can safely be
    reflected around any integer (previously 0), but for reflect-extended
    radial gradients can only be reflected around odd integers if the
    appearance is to be the same, thus reflecting around 1 is correct for both.
    
    Fixes radial-gradient.

 src/cairo-quartz-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3898e46d1de19848efeddb442dcf7f7663530256
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 23 09:41:48 2010 +0100

    image: Compensate mask origins for glyph clipping
    
    Fixes the regression in bitmap-font and large-font pointed out by Andrea
    Canciani since ef067933.

 src/cairo-image-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 53fcfc781eeee949abc03cf90048a2228f7e0a63
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Wed Jul 21 22:39:40 2010 +0300

    build: Typos in comments.
    
    Fix inline "dnl" strings left over from a string
    substitution "--" -> "dnl".

 build/configure.ac.pthread |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit fd1e731c9d0af307ebde4d888866c95bd6ebe66d
Author: Hib Eris <hib@hiberis.nl>
Date:   Wed Jul 21 22:34:05 2010 +0300

    build: Fix pthread detection code when there isn't one.
    
    The code was testing the output variable $use_pthread rather than
    the input variable $enable_pthread when checking that pthreads
    were actually found when requested.

 build/configure.ac.pthread |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 108b1c7825116ed3f93aa57384bbd3290cdc9181
Author: Karl Tomlinson <karlt+@karlt.net>
Date:   Sat Jul 17 13:08:53 2010 +1200

    clip: consider gstate target extents in _cairo_gstate_copy_clip_rectangle_list
    
    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=29125
    
    To be consistent with _cairo_gstate_clip_extents, the context's clip
    should be intersected with the target surface extents (instead of only
    using them when there is no clip).
    
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>

 src/cairo-clip.c   |   72 +++++++++++++++++++---------------------------------
 src/cairo-gstate.c |   14 +++++++++-
 test/get-clip.c    |   16 ++++++++++++
 3 files changed, 55 insertions(+), 47 deletions(-)

commit b79ea8a6cab8bd28aebecf6e1e8229d5ac017264
Author: Karl Tomlinson <karlt+@karlt.net>
Date:   Sat Jul 17 11:46:25 2010 +1200

    clip: consider all_clipped in _cairo_clip_get_extents
    
    If the gstate clip in _cairo_gstate_int_clip_extents() has all_clipped
    set (and path NULL), then it returns the gstate target extents instead of
    an empty rectangle.  If the target is infinite, then it says the clip is
    unbounded.
    
    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=29124
    Tested-by test/get-clip
    
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>

 src/cairo-clip.c |    5 +++++
 test/get-clip.c  |    5 ++++-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit 6a5115901381fe9c81a8a311e267c2a00e2a1d04
Author: Karl Tomlinson <karlt+@karlt.net>
Date:   Sat Jul 17 10:47:42 2010 +1200

    test: return CAIRO_TEST_FAILURE from get-clip preamble on failure
    
    https://bugs.freedesktop.org/show_bug.cgi?id=29120

 test/get-clip.c |    5 +++++
 1 file changed, 5 insertions(+)

commit f2fa15680ec3ac95cb68d4957557f06561a7dc55
Author: Karl Tomlinson <karlt+@karlt.net>
Date:   Sat Jul 17 10:39:50 2010 +1200

    clip: return empty clip from _cairo_clip_copy_rectangle_list when all_clipped
    
    Fixes https://bugs.freedesktop.org/show_bug.cgi?id=29122
    Tested by test/get-clip
    
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>

 src/cairo-clip.c |    5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 33ac2035876aeb9215ca0bdaaeea5265fcee61f8
Author: Karl Tomlinson <karlt+@karlt.net>
Date:   Sat Jul 17 10:13:22 2010 +1200

    test: use the surface size expected in get-clip phase "No clip set"
    
    https://bugs.freedesktop.org/show_bug.cgi?id=29121

 test/get-clip.c |    8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit bac5c28a18af5d43c96f0b64d1c7235da3f02779
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jul 17 10:09:14 2010 +0100

    boilerplate: Offset the xlib window
    
    An idea courtesy of Benjamin Otte is to stress the drivers a bit more by
    not rendering to 0,0. Under various circumstances rendering to a Window
    is mapped onto the Screen root Window with a collection of offsets and
    clips by X. It is easy for the driver to make a mistake and misrender...

 boilerplate/cairo-boilerplate-xlib.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 51b0c21f02a8f0f5d7f44da05e49d7f8f3bf8bc7
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 16 19:49:53 2010 +0200

    build: Add explicit dependcy to cxx lib
    
    Otherwise the build will fail because it doesn't add the dependency
    manually.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=29114

 boilerplate/Makefile.am |    3 +++
 src/Makefile.am         |    2 +-
 2 files changed, 4 insertions(+), 1 deletion(-)

commit 6b92d5a0f9fce28f99b07177454da00f984fdb43
Author: Oleg Romashin <romaxa@gmail.com>
Date:   Fri Jul 16 09:47:23 2010 +0100

    qt: Use native glyph rendering.
    
    Remove the hack of using the xlib surface to do glyph rendering and use
    the new interface introduced with Qt4.7, or else fallback to image
    rendering with freetype.
    
    Reviewed-by: Chris Wilson <chris@chris-wilson.co.uk>
    [2 files changed, 35 insertions(+), 140 deletions(-) \o/]

 src/cairo-qt-surface.cpp |  169 ++++++++++------------------------------------
 src/cairo-xlib-surface.c |    6 --
 2 files changed, 35 insertions(+), 140 deletions(-)

commit f53f072a223c3fbdeba315f5cba755cba498e121
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 18:53:29 2010 +0100

    clip: Do the NULL check before the dereference.
    
    Breakage introduced in the commit earlier today.

 src/cairo-clip.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ef0679333da881bd83b0bb4db546ea9c68f81f89
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 16:07:27 2010 +0100

    image: Manually clip against bounds when rendering directly
    
    This is path is slightly peculiar in that it explicitly avoid the
    intermediate mask and the geometry is not pre-clipped.
    
    This in conjunction with the previous commit fixes:
    
      Clip doesn't work for text
      https://bugs.freedesktop.org/show_bug.cgi?id=29008
    
    which is captured in test/partial-clip-text.

 src/cairo-image-surface.c |   23 +++++++++++++++++++----
 1 file changed, 19 insertions(+), 4 deletions(-)

commit 679e5a600bd7dae6cbde83070fb1f7355f8025a7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 16:06:32 2010 +0100

    Differentiate between reducing clip to composite extents and a rectangle
    
    This is required for handling glyphs when rendering directly to the
    surface.

 src/cairo-clip-private.h         |    4 ++++
 src/cairo-clip.c                 |   22 +++++++++++++++-------
 src/cairo-gl-surface.c           |    4 ++--
 src/cairo-image-surface.c        |   10 +++++-----
 src/cairo-surface-fallback.c     |   10 +++++-----
 src/cairo-xcb-surface-render.c   |   10 +++++-----
 src/drm/cairo-drm-i915-glyphs.c  |    2 +-
 src/drm/cairo-drm-i915-surface.c |    8 ++++----
 src/drm/cairo-drm-i965-glyphs.c  |    2 +-
 src/drm/cairo-drm-i965-surface.c |    8 ++++----
 10 files changed, 46 insertions(+), 34 deletions(-)

commit 8546a877889bfafc056c867bc9aea25e9fdcdef0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 16:27:29 2010 +0100

    test: Add partial-clip-text
    
    This exercises a bug found by Igor Nikitin:
    
      https://bugs.freedesktop.org/show_bug.cgi?id=29008

 test/Makefile.am                   |    3 +++
 test/Makefile.sources              |    1 +
 test/partial-clip-text.c           |   50 ++++++++++++++++++++++++++++++++++++
 test/partial-clip-text.ps.ref.png  |  Bin 0 -> 107 bytes
 test/partial-clip-text.ref.png     |  Bin 0 -> 175 bytes
 test/partial-clip-text.svg.ref.png |  Bin 0 -> 173 bytes
 6 files changed, 54 insertions(+)

commit 53ee897449dca497d6a3d6dc90b87fea8027cc44
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 12:37:31 2010 +0100

    version: Post-snapshot bump to 1.9.13

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit aa4cd8287f47b4538e765e1b48dcbac19813a8a2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 12:12:12 2010 +0100

    version: 1.9.12 snapshot

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 53b129dd8aecf4e2bd8b7d2cd27b91370c6705e9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 12:11:42 2010 +0100

    NEWS for 1.9.12.

 NEWS |   56 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 56 insertions(+)

commit 01380f3a56b28a388d2876780f33516ecd16ee16
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 11:49:53 2010 +0100

    test: Missing REFERENCE_IMAGES

 test/Makefile.am |    3 +++
 1 file changed, 3 insertions(+)

commit 459b8ae660eb49a87ffb9da31f305718a2b4f11f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jul 12 11:05:57 2010 +0100

    Make distcheck happy.

 src/cairo-fontconfig-private.h |    2 ++
 src/cairo-skia.h               |    2 +-
 src/glew/GL/glew.h             |    2 ++
 src/glew/GL/glxew.h            |    2 ++
 test/api-special-cases.c       |    5 +++--
 5 files changed, 10 insertions(+), 3 deletions(-)

commit d56b1718025f8b2354b5b1eb99af41df70a6c590
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Jul 12 10:36:24 2010 +0200

    test: Add halo quartz reference images
    
    When quartz-font is enabled, halo and halo-transform fonts have a
    different shape.

 test/halo-transform.quartz.ref.png |  Bin 0 -> 14360 bytes
 test/halo.quartz.ref.png           |  Bin 0 -> 8601 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 9107895789fc721ee6ea2ccb2ce3ab99fb978caa
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Jul 12 11:03:15 2010 +0300

    test: Add comments explaining the bug in bug-seams.
    
    Where two rasterization methods meet, havoc occurs.

 test/bug-seams.c |   22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)

commit 0152db263b9b12547fadb5d080913fcbb696d34e
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Jul 12 10:36:00 2010 +0300

    build: Sync up autogenerated win32 build files.

 boilerplate/Makefile.win32.features |    9 +++++++++
 build/Makefile.win32.features       |    1 +
 build/Makefile.win32.features-h     |    3 +++
 src/Makefile.win32.features         |    9 +++++++++
 4 files changed, 22 insertions(+)

commit 06ffb7df716652baba96960cd59e1a59f4bd1ac1
Author: Eric Anholt <eric@anholt.net>
Date:   Sat Jul 10 14:19:50 2010 -0700

    gl: Only use a mat3 for the transformation for gradients coordinates.
    
    No point in passing in a column of zeroes that we multiply by zero, or
    the row that we drop on the floor.  We could do even better by just
    passing in a 3x2, at the expense of adding a language version
    dependency (or just pass in 2 vectors).
    
    No significant performance difference.

 src/cairo-gl-shaders.c |   28 +++++++++++++---------------
 1 file changed, 13 insertions(+), 15 deletions(-)

commit 1e7485f8e5b6fd9b26f06838d8e7a35e073c394b
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Mon Jul 12 00:23:11 2010 +0300

    trace: Avoid stdbool.h C99ism.
    
    There is no <stdbool.h> on old Solaris without invoking
    c99 mode explicitly.

 util/cairo-trace/trace.c |  184 +++++++++++++++++++++++-----------------------
 1 file changed, 94 insertions(+), 90 deletions(-)

commit 97529a3713d899468fb3ca7a1c3f75a09bd1b215
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Jul 11 23:54:21 2010 +0300

    build: Avoid shifting shell parameters that aren't there.
    
    The shift primitive of the Solaris 9 Bourne shell doesn't like
    it if we try to shift more formal arguments than are there.
    This causes the compare_versions function in autogen.sh to croak when
    the actual and compared versions differ in the number of
    components.

 autogen.sh |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit dd6026b613aa5414a128727995f2a4f79284072a
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Jul 11 20:44:40 2010 +0200

    doc: Make the necessity of flush/mark_dirty more obvious

 src/cairo-surface.c |   32 ++++++++++++++++++++++++++++++++
 1 file changed, 32 insertions(+)

commit 8a1944f45b9c9056088246d4f2e72d60a59fd5c4
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Jul 11 19:11:15 2010 +0200

    check: Allow unprefix type names in the title
    
    Some documentation sections use the type name as the title, and we don't
    want to use that title as a link.

 src/check-doc-syntax.sh |    4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit f0466ecf7db859a80b779b7fb4381e3c9409c39b
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Jul 11 21:57:40 2010 +0300

    build: Fix typo in pthread test program.
    
    Missing a semicolon after pthread_cleanup_push.  Incredibly
    only openbsd 4.5 minded.

 build/configure.ac.pthread |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3f1d7de8e1620ad385930477b63454107dd8ffd3
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Jul 11 17:29:07 2010 +0300

    build: Fix regression provoked by newer autoconf and dodgy configuring.
    
    We're not supposed to be redefining PACKAGE_VERSION, PACKAGE_...
    from the configure generated confdefs.h.  This patch rudely adds
    paper over the problem.  The compiler warnings are a problem for
    us since our checking of various compiler flags assumes that
    no news is good news, and that any warning messages are due
    to the flags under test.  The regression appears when using
    an autoconf >= 2.64, at least, but not with 2.61.
    
    The same issue appears in the pthread test because our conftest
    unconditionally #defines _GNU_SOURCE, but autoconf ends up doing
    that in the confdefs.h.

 build/configure.ac.noversion |   13 ++++++++++++-
 build/configure.ac.pthread   |    2 ++
 2 files changed, 14 insertions(+), 1 deletion(-)

commit fca8977219b857e2e61dd86ac39ae9f40086f306
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Jun 27 03:03:17 2010 +0300

    build: Rework pthread detection.
    
    Use two levels of pthread support: a minimal level used to
    build cairo itself, and a full level to build threaded apps
    which want to use cairo.  The minimal level tries to use
    pthread stubs from libc if possible, but falls back to the
    full level if that's not possible.  We use CFLAGS=-D_REENTRANT
    LIBS=-lpthread to find a real pthread library since that seems
    to work on every unix-like test box we can get our hands on.

 build/ax-pthread.m4           |  283 -----------------------------------------
 build/configure.ac.pthread    |  251 ++++++++++++++++++++++++++++++++++++
 configure.ac                  |   47 +++----
 test/Makefile.am              |   16 +--
 test/cairo-test-trace.c       |   10 +-
 test/cairo-test.c             |    6 +-
 util/cairo-sphinx/Makefile.am |    3 +-
 util/cairo-sphinx/sphinx.c    |    4 +
 util/cairo-trace/Makefile.am  |    4 +-
 9 files changed, 291 insertions(+), 333 deletions(-)

commit 47c35e5e86a3c99fc39afe2e13a7c92d5247ee1e
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Jun 27 01:14:03 2010 +0300

    build: Purge CAIRO_CC_TRY_LINK_FLAG.
    
    Use CAIRO_CC_TRY_FLAG instead in the one place where we used
    CAIRO_CC_TRY_LINK_FLAG and make the build system one macro
    smaller.

 build/aclocal.cairo.m4      |   21 ---------------------
 build/configure.ac.warnings |    2 +-
 2 files changed, 1 insertion(+), 22 deletions(-)

commit d2f5592e0e0d316cfc40ec676ee6e7f4e2a699fb
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Sun Jun 27 01:11:13 2010 +0300

    build: Factor out a more pliable CAIRO_CC_TRY_LINK_WITH_ENV_SILENT.
    
    Introduce a new CAIRO_CC_TRY_LINK_WITH_ENV_SILENT macro for running
    generic link tests with arbitrary CFLAGS/LIBS/LDFLAGS and no muttering
    of autoconf messages.  Rewrite the previous CAIRO_CC_TRY_FLAG in terms
    of it.

 build/aclocal.cairo.m4 |   31 +++++++++++++++++++++++++------
 1 file changed, 25 insertions(+), 6 deletions(-)

commit 120b78ada7eed6424f07a688854657d0c3ad68f8
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Jul 11 18:48:38 2010 +0200

    build: Split boilerplate lib generation into two so's
    
    Same thing as what was previously done for libcairo.so: Build an
    intermediate lib for the (potential) C++ stuff.

 boilerplate/Makefile.am      |   31 ++++++++++++++++++++++++-------
 boilerplate/Makefile.sources |    7 ++-----
 2 files changed, 26 insertions(+), 12 deletions(-)

commit d6362a0d76753cb6f85f0dbd567a3ec7b7b08696
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Jul 11 16:01:44 2010 +0200

    qt: Define cairo-qt's API as C symbols
    
    That way, the C linker doesn't mess up when linking libcairo.so.

 src/cairo-qt.h |   12 ++++--------
 1 file changed, 4 insertions(+), 8 deletions(-)

commit 5d4a4775c8b091b947b52cc8f7e1e48a5eaea007
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun Jul 11 15:41:56 2010 +0200

    build: Fix typo that makes C++ libs not build

 src/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9b9952ab4f64a476bbadfd3e6cf1e66c1137ccd7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jul 10 11:13:07 2010 +0100

    Convert mime data length to use unsigned long
    
    What we want to use is size_t, but we don't want the implied POSIX
    dependency. However, POSIX does say that size_t is an unsigned integer
    that is no longer than a long, so it would appear safe to use an
    unsigned long as a replacement. Safer at least than unsigned int.

 src/cairo-image-info-private.h     |    6 +++---
 src/cairo-image-info.c             |    4 ++--
 src/cairo-output-stream-private.h  |    2 +-
 src/cairo-output-stream.c          |    2 +-
 src/cairo-pdf-surface.c            |   18 +++++++++---------
 src/cairo-png.c                    |    2 +-
 src/cairo-ps-surface.c             |    2 +-
 src/cairo-script-surface.c         |    6 +++---
 src/cairo-surface.c                |    4 ++--
 src/cairo-svg-surface.c            |    6 +++---
 src/cairo-types-private.h          |    2 +-
 src/cairo-win32-printing-surface.c |   10 +++++-----
 src/cairo.h                        |    4 ++--
 util/cairo-trace/trace.c           |    6 +++---
 14 files changed, 37 insertions(+), 37 deletions(-)

commit eb85ab998b606144daf025285968a5d6031b9aa6
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jul 10 10:43:40 2010 +0100

    subsurface: Don't assume we ever own the target.
    
    Andrea pointed out that snapshots can be shared, and so the subsurface
    should not be calling finish even on a snapshot.

 src/cairo-surface-subsurface-private.h |    1 -
 src/cairo-surface-subsurface.c         |   17 ++++++++---------
 2 files changed, 8 insertions(+), 10 deletions(-)

commit 59c83117d77f58e9cb64aaa6b572fab62fb31c6b
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 18:55:11 2010 +0200

    build: Commit new versions of autogenerate Windows build files
    
    The recent commits to the build system changed a bunch of stuff in
    there, so update the files.

 boilerplate/Makefile.win32.features |   92 +++++++++++++++++++++++++++++++----
 build/Makefile.win32.features-h     |    1 -
 src/Makefile.win32.features         |   92 +++++++++++++++++++++++++++++++----
 3 files changed, 164 insertions(+), 21 deletions(-)

commit bf117e4ea7c89dadcb5a358bb47c0f213cc67461
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 18:43:38 2010 +0200

    build: fix glew include
    
    Currently wether internal glew is built is dependant on wether the
    tarball in use was built with internal glew or not. And that's not how
    it should be.

 configure.ac         |    8 ++++----
 src/Makefile.sources |   11 +++++++----
 2 files changed, 11 insertions(+), 8 deletions(-)

commit 0bd704bd1e92b274209aeda6de88c7e75ffa81be
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 17:15:02 2010 +0200

    build: Remove wrong flags from libcairo_cxx.la
    
    They're useful for the final so, but not for an intermediate noinst lib.

 src/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit faceffd5beb4297299175945660522d8f1f5f2cb
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 16:58:18 2010 +0200

    build: copy/paste failure: Don't build libcxx.la

 src/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit dbb386d3c0aa9e7534d333cf3dbcfc2aaeac05d3
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 12:49:10 2010 +0200

    gl: Use unsigned int instead of GLuint
    
    GLuint is not defined in cairo-gl.h. If unsigned int is not compatible
    enough to GLuint, we might consider to use #include <GL/gl.h> instead.

 src/cairo-gl-surface.c |    2 +-
 src/cairo-gl.h         |    3 ++-
 2 files changed, 3 insertions(+), 2 deletions(-)

commit f7fc8569a797356d5e93ad67aae4eca31e6835cd
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 12:29:35 2010 +0200

    build: Fix C++ issues with automake
    
    This is an attempt to fix the broken situation we've been in where
    automake links libcairo.la with c++ because it might potentially maybe
    include C++ files.
    
    Those potential files only exist in Chris' throwaway backends (skia, qt)
    and the BeOS backend, so for 99.99% of cases, these backends are not
    needed and linking with c++ is overkill. Also, no one wants to have
    libcairo.so link to libstdc++.
    
    This patch fixes that in mutliple steps:
    1) Add build infrastructure to distinguish between C and C++ backends.
       This is done by allowing to specify backend_sources as well as
       backend_cxx_sources variables in Makefile.sources.
    2) Optionally build a libcairo_cxx.la noinst library
       This intermediate library is built for C++ backends only and therefor
       linked using c++. It is then linked into the final libcairo.la. This
       does not require c++, so the linking of libcairo.la is done with cc.
    
    This also works around various weirdnesses that the current build system
    exposes, where it assumes cisms when in fact using c++ semantics, like
    not detecting c++ properly or:
    https://bugzilla.redhat.com/show_bug.cgi?id=606523

 build/configure.ac.features |    7 ++++++-
 configure.ac                |   10 ++++++++++
 src/Makefile.am             |   20 +++++++++++++++++++-
 src/Makefile.am.analysis    |    4 ++--
 src/Makefile.sources        |    6 +++---
 5 files changed, 40 insertions(+), 7 deletions(-)

commit df6d49f6eaf334d5a2de8bdd90919278071ab868
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 10:29:30 2010 +0200

    build: Get rid of $(foo_files) Makefile.am variables
    
    They're unused, and less variables make the build system easier to
    understand.

 build/configure.ac.features |    1 -
 src/Makefile.am             |    1 -
 2 files changed, 2 deletions(-)

commit ce530b2802683fe6c5289367ef03018f4081a2da
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 04:24:51 2010 +0200

    doc: Add "@Since: 1.10" tags to device docs

 src/cairo-device.c |   14 ++++++++++++++
 src/cairo.h        |    2 ++
 2 files changed, 16 insertions(+)

commit c1fed693020c96126cdc697ddd22567398369b04
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 04:20:42 2010 +0200

    gl: Remove double ** from some comments
    
    gtk-doc doesn't like that unless it's a real gtk-doc comment.
    And it wasn't.

 src/cairo-gl-composite.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5c73b371ae31f230210987941eec2db49d2e02be
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 04:20:06 2010 +0200

    doc: Document remaining cairo-device functions

 src/cairo-device.c |   32 ++++++++++++++++++++++++++++++++
 1 file changed, 32 insertions(+)

commit 9877c1932a44f7e5300d6fcd99c19748aa5a4828
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 03:52:45 2010 +0200

    doc: Add more documentation for devices
    
    Add general docs and document acquire/release. I'm not happy with the
    documentation yet. In particular, I have 2 issues:
    1) The threading guarantees Cairo provides are missing.
    2) There's no docs on which Cairo functions do acquire devices.
    
    I guess I'll have to fix them later.

 src/cairo-device.c |   86 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 86 insertions(+)

commit 739d6e35fa5632b80b888d6475f2fdb6be6054a6
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 03:04:27 2010 +0200

    doc: Clarify that cairo_surface_get_device() can return NULL

 src/cairo-surface.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 65d0590b041835fb466f4a7073910ef1383d9e77
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 02:23:13 2010 +0200

    doc: Copy docs for standard device APIs
    
    Copied from the surface equivalents

 src/cairo-device.c |   42 ++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 42 insertions(+)

commit 8a08b6fa5288f376688730c66ae9219d01180f42
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 02:21:00 2010 +0200

    doc: Remove the <TITLE> declarations
    
    This information was duplicated. It exists as the "@Title" of the
    SECTION inline documentation already.

 doc/public/cairo-sections.txt |   28 ----------------------------
 1 file changed, 28 deletions(-)

commit 5e76bc6deb9fd4dc7a0f9181d3941ba55ce89c56
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jul 9 01:10:24 2010 +0200

    doc: Add missing region documentation

 src/cairo-region.c |   25 +++++++++++++++++++++++++
 src/cairo.h        |   13 +++++++++++++
 2 files changed, 38 insertions(+)

commit 57da730d286f643c8f68b445907f7cdd1f53e5de
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 23:44:35 2010 +0200

    doc: Fix a syntax issue in quartz-font gtkdoc
    
    A missing empty line caused the long description to be part of
    @See_Also. Ooops.

 src/cairo-quartz-font.c |    1 +
 1 file changed, 1 insertion(+)

commit fb03eba44f1ae7dd76dd3db82bfb55b06b0932ae
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jul 8 20:06:08 2010 +0200

    test: Add quartz functions to api-special-cases test

 test/api-special-cases.c |   19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit 59aab0bdc24838252850034cee36ed756f3c3e2a
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jul 8 20:05:13 2010 +0200

    test: fix typo

 test/api-special-cases.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b870cc030d8e0eb6309695e5a101c802f688cf40
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 13:05:18 2010 +0200

    doc: Move tmpl/ docs to inline docs
    
    I did this manually so I could review the docs at the same time.
    If anyone finds typos or other mistakes I did, please complain to me (or
    better: fix them).

 doc/public/cairo-sections.txt           |    4 +-
 doc/public/tmpl/.gitignore              |    3 -
 doc/public/tmpl/cairo-atsui.sgml        |   21 -
 doc/public/tmpl/cairo-beos.sgml         |   22 -
 doc/public/tmpl/cairo-font-face.sgml    |  116 ------
 doc/public/tmpl/cairo-font-options.sgml |  199 ---------
 doc/public/tmpl/cairo-ft.sgml           |   87 ----
 doc/public/tmpl/cairo-image.sgml        |  127 ------
 doc/public/tmpl/cairo-matrix.sgml       |  169 --------
 doc/public/tmpl/cairo-paths.sgml        |  263 ------------
 doc/public/tmpl/cairo-pattern.sgml      |  350 ----------------
 doc/public/tmpl/cairo-pdf.sgml          |  101 -----
 doc/public/tmpl/cairo-png.sgml          |   96 -----
 doc/public/tmpl/cairo-ps.sgml           |  144 -------
 doc/public/tmpl/cairo-quartz-fonts.sgml |   52 ---
 doc/public/tmpl/cairo-quartz.sgml       |   64 ---
 doc/public/tmpl/cairo-scaled-font.sgml  |  227 -----------
 doc/public/tmpl/cairo-status.sgml       |   98 -----
 doc/public/tmpl/cairo-surface.sgml      |  326 ---------------
 doc/public/tmpl/cairo-svg.sgml          |   91 -----
 doc/public/tmpl/cairo-text.sgml         |  319 ---------------
 doc/public/tmpl/cairo-transforms.sgml   |  132 ------
 doc/public/tmpl/cairo-types.sgml        |   43 --
 doc/public/tmpl/cairo-user-fonts.sgml   |  169 --------
 doc/public/tmpl/cairo-version.sgml      |  205 ----------
 doc/public/tmpl/cairo-win32-fonts.sgml  |  106 -----
 doc/public/tmpl/cairo-win32.sgml        |  101 -----
 doc/public/tmpl/cairo-xcb-xrender.sgml  |   26 --
 doc/public/tmpl/cairo-xcb.sgml          |   26 --
 doc/public/tmpl/cairo-xlib-xrender.sgml |   60 ---
 doc/public/tmpl/cairo-xlib.sgml         |  147 -------
 doc/public/tmpl/cairo.sgml              |  674 -------------------------------
 src/cairo-beos-surface.cpp              |   10 +
 src/cairo-font-face.c                   |   17 +
 src/cairo-font-options.c                |   12 +
 src/cairo-ft-font.c                     |   25 ++
 src/cairo-image-surface.c               |   21 +
 src/cairo-matrix.c                      |   23 ++
 src/cairo-misc.c                        |   20 +
 src/cairo-path.c                        |    9 +
 src/cairo-pattern.c                     |   17 +
 src/cairo-pdf-surface.c                 |   17 +
 src/cairo-png.c                         |   18 +
 src/cairo-ps-surface.c                  |   17 +
 src/cairo-quartz-font.c                 |   17 +
 src/cairo-quartz-surface.c              |   17 +
 src/cairo-scaled-font.c                 |   10 +
 src/cairo-surface.c                     |   47 +++
 src/cairo-svg-surface.c                 |   17 +
 src/cairo-types-private.h               |    8 +
 src/cairo-user-font.c                   |   22 +
 src/cairo-version.c                     |  156 +++++++
 src/cairo-win32-font.c                  |   17 +
 src/cairo-win32-surface.c               |   24 ++
 src/cairo-xcb-surface-render.c          |   13 +
 src/cairo-xcb-surface.c                 |   13 +
 src/cairo-xlib-surface.c                |   40 ++
 src/cairo.c                             |   57 +++
 58 files changed, 666 insertions(+), 4566 deletions(-)

commit 65a1e351330106ee0af9f6f0df06b82954341ee6
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 03:28:05 2010 +0200

    doc: Remove CAIRO_FORMAT_RGB16_565 from hidden symbols list
    
    It's part of the cairo_format_t documentation now.

 doc/public/cairo-sections.txt |    1 -
 1 file changed, 1 deletion(-)

commit e7594aebce6007bfa2027ba2655875db6c036e73
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 03:21:45 2010 +0200

    doc: Fix some consistency issues that confuse gtk-doc

 src/cairo-region.c |   16 +++++++++++++---
 src/cairo.h        |   16 ++++++++++++++--
 2 files changed, 27 insertions(+), 5 deletions(-)

commit da2663a0aa1e3f0a6b2f6ae2e9952ac27dec3f5d
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 03:14:42 2010 +0200

    doc: Add list of new symbol in Cairo 1.10

 doc/public/cairo-docs.xml |    3 +++
 1 file changed, 3 insertions(+)

commit a106aa86a3267b4886f7eabdc4b07bb394e11531
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 03:13:20 2010 +0200

    doc: add --name-space option to gtkdoc-mkdb
    
    This sorts function names in new symbols lists way better.

 doc/public/Makefile.am |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 71d17e4b1f1cb83bc605d72d8419d4bfb824c828
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 02:42:39 2010 +0200

    drm: Fix Makefile for drm_xr
    
    Use cairo_drm_xr_sources/headers for the drm_xr stuff. This makes it
    work correctly in gtk-doc instead of conditionally adding it to
    cairo_drm_sources/headers.

 src/Makefile.sources |   10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit 4b3e488cebeeace02eae1164ed12caa93d7c5847
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 02:42:06 2010 +0200

    skia: Add cairo-skia.h as a public header

 src/Makefile.sources |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2a546286da5fe7203846d99a4a3d732c73e62db5
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 02:20:17 2010 +0200

    doc: Add a section about regions

 doc/public/cairo-docs.xml     |    1 +
 doc/public/cairo-sections.txt |   30 ++++++++++++++++++++++++++++++
 2 files changed, 31 insertions(+)

commit ab1f6d1af7c0e47077013edd58e93fa9fc6f2b5c
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 01:41:27 2010 +0200

    doc: Add missing surface APIs

 doc/public/cairo-sections.txt |    2 ++
 1 file changed, 2 insertions(+)

commit 90bf273a38856d178e90721168b8b076f79fbf38
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 01:39:37 2010 +0200

    doc: Add a section for cairo_device_t

 doc/public/cairo-docs.xml     |    1 +
 doc/public/cairo-sections.txt |   18 ++++++++++++++++++
 2 files changed, 19 insertions(+)

commit 60e4f28d091df8ac6b898448eb52fae9ca920d5d
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 01:39:07 2010 +0200

    doc: Add cairo_in_clip() to cairo_t section

 doc/public/cairo-sections.txt |    1 +
 1 file changed, 1 insertion(+)

commit 6843186b729b20acddccd36184d2c5a7b5525d2e
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 01:38:43 2010 +0200

    doc: Add cairo_rectangle_int_t to the general types list

 doc/public/cairo-sections.txt |    1 +
 1 file changed, 1 insertion(+)

commit c54dff82d3055529b7663dcff7a970cae919a9e0
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 01:33:42 2010 +0200

    glew: The headers are private, not public

 src/Makefile.sources |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4252e3b8f915fc23611f1a667bf7bc1bb6a21dfd
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 01:32:25 2010 +0200

    doc: Add drm and glew to the ignored directories
    
    This reduces the number of unused symbols to a reasonable size. ;)

 doc/public/Makefile.am |    2 ++
 1 file changed, 2 insertions(+)

commit 729d00341c26d46d82359014df97472a469e49a4
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jul 8 13:57:43 2010 +0200

    gl: Fix compile error after rebase failure

 src/cairo-gl-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 292423c73376a7f9b84c9e3e578c242f486e921b
Author: Colin Walters <walters@verbum.org>
Date:   Wed Jul 7 15:46:33 2010 -0400

    Support NOCONFIGURE environment variable
    
    This is taken from gnome-common; it can be convenient for builders
    to separate the autogen from the configure stage.

 autogen.sh |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 9e6c151af810886e94372ac8e4878915059c6c14
Author: Kristian Høgsberg <krh@bitplanet.net>
Date:   Thu Jun 17 18:19:39 2010 -0400

    gl: Add new cairo-gl surface constructor to create surface for texture

 src/cairo-gl-private.h |    2 +
 src/cairo-gl-surface.c |  111 ++++++++++++++++++++++++++++++++++++++++++------
 src/cairo-gl.h         |    4 ++
 3 files changed, 105 insertions(+), 12 deletions(-)

commit 4c91bb9a221bc8e3d65a96365bbd1157b3f4e612
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jul 6 17:27:18 2010 +0200

    region: Add cairo_region_xor() and cairo_region_xor_rectangle()
    
    gdk_region_xor() was a quite often used function in GDK and now that
    GDKe uses cairo regions, it seems like a worthwhile addition to Cairo.

 src/cairo-region.c |   80 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo.h        |    6 ++++
 src/cairoint.h     |    2 ++
 3 files changed, 88 insertions(+)

commit 82de6336d88be43de759b94634e87b9e4a8391b1
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jul 6 00:48:36 2010 +0200

    test: Add note about how to fix failures to api-special-cases

 test/api-special-cases.c |    6 ++++++
 1 file changed, 6 insertions(+)

commit 75f269b14e1e4cdadd8c08566a07b2460ae3364b
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jul 6 00:41:12 2010 +0200

    test: Add documentation to the api-special-cases test
    
    Hopefully people add other backend APIs to the testsuite.

 test/api-special-cases.c |   27 +++++++++++++++++++++++++++
 1 file changed, 27 insertions(+)

commit 398870e64a18f32f1854cb19f64c34e2b1987140
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jul 6 00:21:38 2010 +0200

    xlib: Setters should set finished surfaces into an error status
    
    Caught by api-special-cases test

 src/cairo-xlib-surface.c |   18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit 6e562d1448eb70b7269f8f2f280719aa2aeb3ce7
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jul 6 00:20:57 2010 +0200

    xcb: Setters should set finished surfaces into an error status
    
    Caught by api-special-cases test

 src/cairo-xcb-surface.c |   10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit fa070704966f10e7264778a3ffb401054a68e8f7
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jul 6 00:20:36 2010 +0200

    test: Add xcb and xlib functions to api-special-cases test

 test/api-special-cases.c |   91 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 91 insertions(+)

commit c4068fe9414bad663f77c030ac96fa4b4cba87ba
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 23:14:33 2010 +0200

    test: Add ps, pdf and svg to the api-special-cases test

 test/api-special-cases.c |  103 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 103 insertions(+)

commit 3e008e8ab0a1c5254bd1d8a58c9e9a89846fe7ac
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 23:14:19 2010 +0200

    svg: Set error when extracting from finished surface
    
    Caught by api-special-cases test

 src/cairo-svg-surface.c |   10 ++++++++++
 1 file changed, 10 insertions(+)

commit 2e66cbaee2efc4a8eb2117f945d68e2816349cfe
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 23:10:12 2010 +0200

    ps: Allow specifying if errors on extract_surface should be set
    
    Getters should not set errors on passed in input. So we don't.
    
    Caught by api-special-cases test

 src/cairo-ps-surface.c |   39 ++++++++++++++++++++++-----------------
 1 file changed, 22 insertions(+), 17 deletions(-)

commit f5dfc3ce6eab3bf836f2d7f7cf72d2834c42d72f
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 23:08:08 2010 +0200

    ps: Set error when extracting from finished surface
    
    Caught by api-special-cases test

 src/cairo-ps-surface.c |   10 ++++++++++
 1 file changed, 10 insertions(+)

commit 106357f6e28467f6db02e8d69c4aea459aca781c
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 23:07:24 2010 +0200

    pdf: Set error when extracting from finished surface
    
    Caught by api-special-cases test

 src/cairo-pdf-surface.c |   10 ++++++++++
 1 file changed, 10 insertions(+)

commit 702aa19fdae8bd511c4374f580dde6503afd3341
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:50:44 2010 +0200

    gl: Fail properly when called with finished functions
    
    Caught by api-special-cases test

 src/cairo-gl-surface.c |   12 +++++++++++-
 1 file changed, 11 insertions(+), 1 deletion(-)

commit b87be76bdfcbd329c79a9f11b24d22010ad15dde
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:50:18 2010 +0200

    test: Add gl functions to the tests

 test/api-special-cases.c |   39 ++++++++++++++++++++++++++++++++++++++-
 1 file changed, 38 insertions(+), 1 deletion(-)

commit 448653e7b9938100c3f2e30e026fbc4d9de7d0d5
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:41:43 2010 +0200

    Call _cairo_error() when setting the FINISHED error on surfaces

 src/cairo-surface-subsurface.c |    2 +-
 src/cairo-surface.c            |   12 ++++++------
 2 files changed, 7 insertions(+), 7 deletions(-)

commit 19da8e138d317c1770d8bbd21a49c657d954f126
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:40:54 2010 +0200

    tee: Add proper error handling
    
    Caught by api-special-cases

 src/cairo-tee-surface.c |   15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit a9f30fc1f0c3e50715468b09707477973bf5268b
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:30:55 2010 +0200

    test: Add recording and tee surface functions to api-special-cases

 test/api-special-cases.c |   44 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 44 insertions(+)

commit 41abc0ca37855751ed06051a30c0d866977ed2bd
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:19:05 2010 +0200

    test: add PNG functions

 test/api-special-cases.c |   36 ++++++++++++++++++++++++++++++++++++
 1 file changed, 36 insertions(+)

commit 897eaa3e97f865ad2c28442c26efaf4ba391cf03
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:11:23 2010 +0200

    test: Add a non-error surface check
    
    In that check, we call functions that require a specific surface type
    with surfaces of a different type and check that they don't crash and
    set the correct error.

 test/api-special-cases.c |   36 ++++++++++++++++++++++++++++++++++++
 1 file changed, 36 insertions(+)

commit 986ddf565215dc01065eade46921abe8a4b7912e
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 22:03:42 2010 +0200

    test: add image surface functions to api-special-cases test

 test/api-special-cases.c |   90 +++++++++++++++++++++++++++++++++-------------
 1 file changed, 66 insertions(+), 24 deletions(-)

commit 72878d70ea75be03f47fa9d53f8305e76162054e
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 20:47:19 2010 +0200

    test: Add a new test variant to api-special-cases test
    
    This variant tests a (hopefully) inert error surface.

 test/api-special-cases.c |   35 +++++++++++++++++++++++++++++++++++
 1 file changed, 35 insertions(+)

commit 9de25a0297c141a0776835920168afaa3ca77a87
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 18:33:40 2010 +0200

    configure: remove dolt
    
    libtool should be fast by now

 Makefile.am           |    5 +-
 build/aclocal.dolt.m4 |  178 -------------------------------------------------
 configure.ac          |    1 -
 3 files changed, 2 insertions(+), 182 deletions(-)

commit 6744b78de17930285569da2158a334763e2bd333
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 18:25:31 2010 +0200

    subsurface: Fail if created from a finished surface
    
    Caught by api-special-cases test

 src/cairo-surface-subsurface.c |    2 ++
 1 file changed, 2 insertions(+)

commit 8fd1ecea12f15c2bda710065909a14415ba92bd8
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 18:25:16 2010 +0200

    surface: Fail if set_mime_data() is called on a finished surface
    
    Caught by api-special-cases test

 src/cairo-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit e388ff1ae732970d6166780817ec121cf58ccd0e
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 18:24:23 2010 +0200

    surface: Fail early if create_similar() is called on a finished surface
    
    Caught by api-special-cases test

 src/cairo-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit c1689ef6f27f99c36e1a5f4de658363ca0aad25a
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 18:23:37 2010 +0200

    surface: don't call begin_modification on finished surfaces
    
    Fixes https://bugs.launchpad.net/ubuntu/+source/cairo/+bug/600622
    
    Caught by api-special-cases test

 src/cairo-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit cf0245c1201d4884ff19e881e9c118784fa14884
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 18:17:09 2010 +0200

    tests: Add a testcase that checks APIs work consistently
    
    In particular, it checks that finished and surfaces in an error state do
    not do bad things, like cause crashes.
    So far this test only checks surface APIs, but it should be extended to
    cover all APIs.
    
    Please update this test when new APIs get added.
    
    Motivated by https://bugs.launchpad.net/ubuntu/+source/cairo/+bug/600622

 test/Makefile.sources          |    1 +
 test/api-special-cases.c       |  360 ++++++++++++++++++++++++++++++++++++++++
 test/api-special-cases.ref.png |  Bin 0 -> 95 bytes
 3 files changed, 361 insertions(+)

commit eb63284fc3ae9377003ca312be58ae8f5dbbfdbd
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 00:37:10 2010 +0200

    configure: Use automake silent rules
    
    This replaces shave usage.
    If silent rules are not available, don't use them.

 configure.ac |    1 +
 1 file changed, 1 insertion(+)

commit 68bbb6b4a0a3b9bc923ccf130b1ca4221a5e54bd
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jul 5 00:35:39 2010 +0200

    configure: remove shave

 build/.gitignore       |    2 --
 build/aclocal.shave.m4 |   77 ---------------------------------------------
 build/shave-libtool.in |   69 ----------------------------------------
 build/shave.in         |   82 ------------------------------------------------
 configure.ac           |    4 ---
 5 files changed, 234 deletions(-)

commit 9ce87c67ff64083ec48edfefe83a1df3756c364c
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Jul 3 02:54:55 2010 +0200

    perf: print comment describing backend
    
    Use the descibe string to output information about the backend we're
    testing.

 perf/cairo-perf-trace.c |   31 ++++++++++++++++++++++++++++++-
 1 file changed, 30 insertions(+), 1 deletion(-)

commit fcfe7c67248ea171dc40c0dbd861e489a2df5941
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Jul 3 02:54:28 2010 +0200

    boilerplate: Add describe string
    
    Print the pixman version we're using

 boilerplate/cairo-boilerplate.c |   21 ++++++++++++++++++---
 1 file changed, 18 insertions(+), 3 deletions(-)

commit 0a7135148a634ea6692a4edd83193870a5d526b3
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Jul 3 02:54:08 2010 +0200

    gl: Add describe string

 boilerplate/cairo-boilerplate-glx.c |   29 +++++++++++++++++++++++++----
 1 file changed, 25 insertions(+), 4 deletions(-)

commit a1c4b001a548611b7d77e9280fdb5a82da275830
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 30 18:27:54 2010 +0200

    boilerplate: Add a describe vfunc
    
    This function is supposed to describe the backend in use. The describe
    function is optional - and therefore initialized as NULL everywhere.
    Note:
    It is well known that the xlib backend uses X. What is not known is what
    version the server supports or what graphics card it is running on. That
    is the information the describe vfunc is supposed to provide.

 boilerplate/Makefile.win32.features            |    8 ++++++++
 boilerplate/cairo-boilerplate-directfb.c       |    4 ++--
 boilerplate/cairo-boilerplate-drm.c            |    2 ++
 boilerplate/cairo-boilerplate-egl.c            |    1 +
 boilerplate/cairo-boilerplate-glx.c            |    4 ++++
 boilerplate/cairo-boilerplate-pdf.c            |    4 ++--
 boilerplate/cairo-boilerplate-ps.c             |    8 ++++----
 boilerplate/cairo-boilerplate-quartz.c         |    5 +++--
 boilerplate/cairo-boilerplate-script.c         |    2 +-
 boilerplate/cairo-boilerplate-skia.c           |    4 ++--
 boilerplate/cairo-boilerplate-svg.c            |    8 ++++----
 boilerplate/cairo-boilerplate-test-surfaces.c  |   16 ++++++++--------
 boilerplate/cairo-boilerplate-vg.c             |    4 ++++
 boilerplate/cairo-boilerplate-wgl.c            |    2 ++
 boilerplate/cairo-boilerplate-win32-printing.c |    4 ++--
 boilerplate/cairo-boilerplate-win32.c          |    4 ++--
 boilerplate/cairo-boilerplate-xcb.c            |    7 +++++++
 boilerplate/cairo-boilerplate-xlib.c           |    4 ++++
 boilerplate/cairo-boilerplate.c                |   10 +++++-----
 boilerplate/cairo-boilerplate.h                |    4 ++++
 build/Makefile.win32.features-h                |    1 +
 src/Makefile.win32.features                    |    8 ++++++++
 22 files changed, 80 insertions(+), 34 deletions(-)

commit 4c039b1cdfac5b5d6aa0c38f0779213fd14ec7de
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 2 17:01:12 2010 +0100

    user-font: Check the status before destroying the context

 src/cairo-user-font.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 1f84f5682c6ff246b3d28c75c8731504f31c1ee1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jul 2 13:19:17 2010 +0100

    xlib: Apply translation to image surface upload.
    
    Fixes:
    
      Bug 28888 - cairo_paint with rgb images does not work correctly
      https://bugs.freedesktop.org/show_bug.cgi?id=28888

 src/cairo-xlib-surface.c |   13 ++++++++-----
 1 file changed, 8 insertions(+), 5 deletions(-)

commit d2d6c96c24501d888422ea42d3c90d3c8f3647a0
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 29 09:58:54 2010 +0200

    user-font: correct handling of size 0 text
    
    Text with size 0 has a singular scale matrix, thus requires special
    handling to avoid invalidating the context where it is used.
    
    Fixes pthread-show-text and text-zero-len (they failed with assertion
    when ran using the user font backend).

 src/cairo-matrix.c      |    9 +++++++
 src/cairo-scaled-font.c |    5 ++--
 src/cairo-user-font.c   |   60 ++++++++++++++++++++++++++++-------------------
 src/cairoint.h          |    3 +++
 4 files changed, 50 insertions(+), 27 deletions(-)

commit 6db247e13c6fa61879029b335c6fa649d810c11b
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 29 09:28:04 2010 +0200

    user-font: ignore translation in scale matrix
    
    Currently the translation component of the scaled_font scale matrix
    is applied by gstate and only linear components should be applied in
    font backends.
    
    Fixes font-matrix-translation (when using user-font as font backend).

 src/cairo-user-font.c |    6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 549431e98ed0be17b80f24f0e0c167c7ad632f4f
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Jun 28 22:40:28 2010 +0200

    ft-font: fix typo

 src/cairo-ft-font.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 97a88c5adb08a3181bad1f63a7bbdfe5784b4207
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 28 17:10:59 2010 +0100

    xlib: Compile without fontconfig
    
    Create a cairo-fontconfig-private.h where we can add the missing defines
    in a common location rather than in the body of the code.

 src/Makefile.sources           |    1 +
 src/cairo-fontconfig-private.h |   76 ++++++++++++++++++++++++++++++++++++++++
 src/cairo-ft-font.c            |    5 +--
 src/cairo-surface-subsurface.c |    1 +
 src/cairo-xlib-screen.c        |   20 +----------
 5 files changed, 80 insertions(+), 23 deletions(-)

commit 7d6910014310344e5d16c97ffd1f1c9fbc01b143
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Jun 28 17:12:41 2010 +0200

    quartz: remove unused declarations

 src/cairo-quartz-surface.c |   17 -----------------
 1 file changed, 17 deletions(-)

commit bd4c14b94eeb386b30439929e8e54a5d9b5d5fca
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 24 23:20:41 2010 +0200

    quartz: remove unused os version info
    
    It was previously used to activate a workaround for text transformation
    whenrunning on some os versions. Now the workaround is not needed anymore.

 src/cairo-quartz-surface.c |    7 -------
 1 file changed, 7 deletions(-)

commit aa7e9c43b6381930455a68258dcc3e14dce2b0e4
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 24 14:18:02 2010 +0200

    quartz-font: correct and explain matrix computations
    
    glyph_path was taking into account the translation (which currently
    is already applied in gstate) and the sign of the elements of the
    matrices was not explained.

 src/cairo-quartz-font.c |   13 ++++++-------
 1 file changed, 6 insertions(+), 7 deletions(-)

commit b26f72fef99e9869a62cbb8e44a82837f87cf2c6
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 24 22:34:36 2010 +0200

    quartz: check return status
    
    If the font backend is unable to tell the extents of the operation,
    consider it unbound.

 src/cairo-quartz-surface.c |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 9c0d761bfcdd28d52c83d74f46dd3c709ae0fa69
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 24 15:26:03 2010 +0200

    quartz: improve text transform handling
    
    Use scale instead of manually compositing font_matrix and ctm and
    composite it with the context ctm, so that no workaround for clipping
    is needed anymore.

 src/cairo-quartz-surface.c |   46 ++++++++++++--------------------------------
 1 file changed, 12 insertions(+), 34 deletions(-)

commit 9068b5768b8560fbf095f1c0eecb5c805232f794
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 24 15:15:37 2010 +0200

    quartz-font: silence compiler warnings
    
    Remove an unused function, explicitly ignore or check return values,
    don't define unused variables.

 src/cairo-quartz-font.c |   84 +++++++++++++++++------------------------------
 1 file changed, 30 insertions(+), 54 deletions(-)

commit ca161a585a7ce09cfcd468ea7591c5959077a907
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 26 14:50:57 2010 +0100

    version: 1.9.9
    
    Post-snapshot bump.

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0f1ff0daab7259ec16076f788760da4f35cb0cdc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 26 14:20:25 2010 +0100

    test: Missing ref image.

 test/Makefile.am |    1 +
 1 file changed, 1 insertion(+)

commit 45d1f461ce2d2e3af16a5a90ffd8980bffc5eaa8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 26 14:17:23 2010 +0100

    version: 1.9.10

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7a68a7bfd550b5e4b6635495e7de49fe306fbad4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 26 14:16:27 2010 +0100

    NEWS for 1.9.10 snapshot

 NEWS |   28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)

commit 8df41361196c7ba1b8d272507cc3d523cdcf5632
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 26 09:52:11 2010 +0100

    Regenerate default win32 headers.

 boilerplate/Makefile.win32.features |    8 --------
 build/Makefile.win32.features-h     |    1 -
 src/Makefile.win32.features         |    8 --------
 3 files changed, 17 deletions(-)

commit 1373675ef7602363aeca0d9ec12be79719ea066d
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 25 14:10:12 2010 +0200

    pop-group: Translate existing path properly
    
    This fixes the reverse case of the push_group case fixed a few commits
    ago.

 src/cairo.c |    8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 59076776674e3ae47099f20e1d86064fbd856008
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 25 14:08:49 2010 +0200

    test: improve push-group-path-offset to also catch the pop_group() case
    
    cairo_pop_group() also trasnforms the path wrong, so we use cairo_fill()
    to copy data instead of cairo_paint().
    
    (Also, unbust the testcase.)

 test/push-group-path-offset.c |   45 +++++++++++++++--------------------------
 1 file changed, 16 insertions(+), 29 deletions(-)

commit 2e8571d95ca36f8ad9e20796990cdc0b3f763082
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 25 13:41:22 2010 +0200

    push-group: Fix path translation when pushing a group with device offsets
    
    With the previous code, the parent's device offset wasn't undone before
    applying the new device offset.
    Tested by push-group-path-offset test.

 src/cairo.c |    5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit a9b8d1a94ea624ea8b12a125bdf70c6f248e7ca7
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 25 13:38:40 2010 +0200

    test: Add a new test for a bug with device-offset tests
    
    All the credit for this one goes to make distcheck

 test/Makefile.sources               |    1 +
 test/push-group-path-offset.c       |   90 +++++++++++++++++++++++++++++++++++
 test/push-group-path-offset.ref.png |  Bin 0 -> 186 bytes
 3 files changed, 91 insertions(+)

commit 1099a3515b6a69e2ff360d8e6b1df71e3ea5c213
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 24 17:22:34 2010 +0100

    drm/intel: Fix common off-by-one by rewriting the [XY]MAX macro.
    
    Many rectangles in the command stream are specified as inclusive rects,
    i.e. the max values are (width-1, height-1), which is easy to neglect.

 src/drm/cairo-drm-i915-private.h          |    2 +-
 src/drm/cairo-drm-i915-surface.c          |   24 ++++++------------------
 src/drm/cairo-drm-i965-shader.c           |   12 ++++++------
 src/drm/cairo-drm-intel-command-private.h |    4 ++--
 4 files changed, 15 insertions(+), 27 deletions(-)

commit fb6a00571c818c738d66bc04dc75e79491878f78
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 14 10:19:37 2010 +0100

    drm: _cairo_color_get_content() compilation fixes

 src/drm/cairo-drm-i915-shader.c |    2 +-
 src/drm/cairo-drm-i965-shader.c |    5 +----
 src/drm/cairo-drm-intel.c       |    3 +--
 3 files changed, 3 insertions(+), 7 deletions(-)

commit 42956b46436b9704be7619e1b61ab222923376d0
Author: Zoxc <zoxc32@gmail.com>
Date:   Sun Jun 20 21:07:57 2010 +0000

    build: Added cairo deflate stream as a requirement for the script surface.

 src/Makefile.sources |    3 +++
 1 file changed, 3 insertions(+)

commit b036a09972a19e63a85a4661a457525e2abe4026
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Jun 24 14:59:18 2010 +0300

    whitespace: Fixup formal arguments and tabs in boilerplate/ and perf/.
    
    Ran a script to align the formal parameters of functions and
    collapse spaces to tabs in code.

 boilerplate/cairo-boilerplate-beos.cpp         |   42 +++++-----
 boilerplate/cairo-boilerplate-directfb.c       |   86 ++++++++++----------
 boilerplate/cairo-boilerplate-drm.c            |    2 +-
 boilerplate/cairo-boilerplate-egl.c            |   20 ++---
 boilerplate/cairo-boilerplate-getopt.c         |   12 +--
 boilerplate/cairo-boilerplate-glx.c            |   60 +++++++-------
 boilerplate/cairo-boilerplate-pdf.c            |   24 +++---
 boilerplate/cairo-boilerplate-private.h        |    2 +-
 boilerplate/cairo-boilerplate-ps.c             |   49 ++++++------
 boilerplate/cairo-boilerplate-qt.cpp           |   18 ++---
 boilerplate/cairo-boilerplate-quartz.c         |   18 ++---
 boilerplate/cairo-boilerplate-scaled-font.h    |    2 +-
 boilerplate/cairo-boilerplate-script.c         |   30 +++----
 boilerplate/cairo-boilerplate-skia.c           |   18 ++---
 boilerplate/cairo-boilerplate-svg.c            |   59 +++++++-------
 boilerplate/cairo-boilerplate-system.c         |   10 ++-
 boilerplate/cairo-boilerplate-system.h         |   10 ++-
 boilerplate/cairo-boilerplate-test-surfaces.c  |  100 +++++++++++------------
 boilerplate/cairo-boilerplate-vg.c             |   36 ++++-----
 boilerplate/cairo-boilerplate-wgl.c            |   58 +++++++-------
 boilerplate/cairo-boilerplate-win32-printing.c |   29 +++----
 boilerplate/cairo-boilerplate-win32.c          |   18 ++---
 boilerplate/cairo-boilerplate-xcb.c            |   85 ++++++++++----------
 boilerplate/cairo-boilerplate-xlib.c           |   90 ++++++++++-----------
 boilerplate/cairo-boilerplate.c                |  102 ++++++++++++------------
 boilerplate/cairo-boilerplate.h                |   44 +++++-----
 perf/cairo-perf-chart.c                        |   38 ++++++---
 perf/cairo-perf-compare-backends.c             |   30 ++++---
 perf/cairo-perf-diff-files.c                   |   37 +++++----
 perf/cairo-perf-graph-files.c                  |   73 ++++++++++-------
 perf/cairo-perf-graph-widget.c                 |   60 ++++++++------
 perf/cairo-perf-graph.h                        |    8 +-
 perf/cairo-perf-micro.c                        |   82 ++++++++++---------
 perf/cairo-perf-os2.c                          |   10 +--
 perf/cairo-perf-posix.c                        |   24 +++---
 perf/cairo-perf-print.c                        |    5 +-
 perf/cairo-perf-report.c                       |   62 ++++++++------
 perf/cairo-perf-trace.c                        |   82 ++++++++++---------
 perf/cairo-perf-win32.c                        |    6 +-
 perf/cairo-perf.h                              |   38 ++++-----
 perf/cairo-stats.c                             |   11 +--
 perf/cairo-stats.h                             |    6 +-
 42 files changed, 850 insertions(+), 746 deletions(-)

commit 616e35d1fae703dc118ce503d25d4f57cfd16dfd
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Jun 24 09:44:07 2010 +0300

    boilerplate: Remove the xlib-window target from Renderless builds.
    
    I don't know why _cairo_boilerplate_xlib_window_create_surface()
    is in the Render-only section of the code, but since it is, this
    patch makes the boilerplate at least compile if we don't have
    Render support built in.

 boilerplate/cairo-boilerplate-xlib.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit aed744008dbaab49f28f9c54ad0850074ece5d66
Author: Søren Sandmann Pedersen <sandmann@daimi.au.dk>
Date:   Thu Jun 24 05:38:14 2010 -0400

    test: Fix typo in copyright statement

 test/bug-seams.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5c7e1dd690af21943435676bfac320cfe863cf55
Author: Soeren Sandmann <sandmann@daimi.au.dk>
Date:   Thu Jun 24 10:11:48 2010 +0100

    test: Add an example of seams.
    
    A pair of perfectly conjoint quads should not produce a seam when
    accumulating into a temporary mask. Yet here is an example of where they
    do!

 test/Makefile.am                     |    3 ++
 test/Makefile.sources                |    1 +
 test/bug-seams.c                     |   98 ++++++++++++++++++++++++++++++++++
 test/bug-seams.ref.png               |  Bin 0 -> 1604 bytes
 test/bug-seams.xlib-fallback.ref.png |  Bin 0 -> 2133 bytes
 test/bug-seams.xlib.ref.png          |  Bin 0 -> 1606 bytes
 6 files changed, 102 insertions(+)

commit 413ec4b708a511eb2f3866165a35d3a8d97bd326
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 22 23:19:32 2010 +0200

    gl: Return a surface from _cairo_surface_create_in_error()
    
    On error, surface creation functions should always return a surface
    created with _cairo_surface_create_in_error() instead of a new surface
    in an error state. This simplifies internal code as no refcounting has
    to be done.

 src/cairo-gl-surface.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit a4e292507cf7c2f960d040edd57b56a976c73da6
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 22 22:01:25 2010 +0200

    gl: Propagate surface creation error instead of crashing

 src/cairo-gl-glyphs.c |   22 ++++++++++++++++------
 1 file changed, 16 insertions(+), 6 deletions(-)

commit faa4e6761c8f74a1acaa7ccc5bc8bb23b2f5cdb1
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jun 21 14:01:34 2010 +0200

    egl: Copy glx code to detect the proper surface in acquire

 src/cairo-egl-context.c |    9 +++++++++
 1 file changed, 9 insertions(+)

commit 76a721f7e94fb040f106b200c09c1a7b9ae83d36
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jun 21 13:30:06 2010 +0200

    egl: Remove unused prev_foo usage

 src/cairo-egl-context.c |    7 -------
 1 file changed, 7 deletions(-)

commit b8051ee985ed46c69f5fba1216ead1ebacecfd44
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 19 18:09:27 2010 +0100

    script: Pass the buffer length back to freetype.
    
    After querying the required size, inform the backend of the allocated
    size of the buffer.

 src/cairo-script-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8ac9a9df24eefc5f1125db87eb8eda2e94f54070
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 19 13:23:50 2010 +0100

    xcb: Return the status upon flushing the device.
    
    The vfunc was updated to expect the status return, so supply it.

 src/cairo-xcb-connection.c |    5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 9fffc0e120df8947c34d9e423c69ab66b763d875
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 19 11:15:13 2010 +0100

    xlib: Precise and Imprecise were reversed.
    
    The intention was to switch to imprecise mode by default, using the
    exact rendering mode only upon request.

 src/cairo-xlib-surface.c |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit b322b2e61984c2e9e00fb44343ebe5e423246445
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 19 10:26:05 2010 +0100

    xlib: Perform image uploads inplace.
    
    Under the restrictive conditions where we are doing an untransformed
    contained upload of an image into a matching surface, perform it in
    place. The drivers will attempt to stream such uploads efficiently, far
    more so than our code.

 src/cairo-xlib-surface.c |  112 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 112 insertions(+)

commit c3eb95bf6670bbc06ef908481da95f3504c7dc4d
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 19:26:07 2010 +0200

    egl: Fail properly if no configs are available instead of crashing

 boilerplate/cairo-boilerplate-egl.c |    4 ++++
 1 file changed, 4 insertions(+)

commit 3908d80f57bc0abef47721a5b8b9afd5041118e3
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 16:11:20 2010 +0200

    glx: Remove useless optimization trying to avoid glXMakeCurrent()
    
    The optimization is not performance-relevant. And having less code is
    always a good idea.

 src/cairo-glx-context.c |   19 ++-----------------
 1 file changed, 2 insertions(+), 17 deletions(-)

commit 64f90322f73c37ac5667292949bb45b0279239d9
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 12:40:48 2010 +0200

    gl: Refactor status handling in _cairo_gl_context_release()
    
    Previously, the code returned a status and required the caller to mangle
    this status with his own status. Now, the function takes the previous
    status ass an argument and does the mangling itself.
    
    Also contains fixes for all the callers to actually check the return
    value - which is now rather trivial as it just requires passing through
    the status variable.

 src/cairo-gl-composite.c |    6 ++----
 src/cairo-gl-device.c    |    2 +-
 src/cairo-gl-glyphs.c    |   14 +++++---------
 src/cairo-gl-gradient.c  |    3 ++-
 src/cairo-gl-private.h   |   14 ++++++++------
 src/cairo-gl-surface.c   |   47 ++++++++++++++++++++++++----------------------
 6 files changed, 43 insertions(+), 43 deletions(-)

commit fc3d521c121da237974e486f1b7735009764b441
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 12:23:37 2010 +0200

    gl: Inline the check_error() function

 src/cairo-gl-private.h |   23 +++++++----------------
 1 file changed, 7 insertions(+), 16 deletions(-)

commit 9d7fa289132650261e546b39af2371c262f46d3c
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 12:18:05 2010 +0200

    gl: Don't assert if there used to be a GL error
    
    When acquiring the GL context, do not assert that the GL context is not
    in an error state. Do not even call _cairo_error(). Handling GL errors
    in other code is not Cairo's responsibility.
    
    Instead just clear all previous errors so we don't accidentally set
    surfaces into error states to unrelated errors.

 src/cairo-gl-private.h |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 0f9a8cd18f14b1f23aaefe14db3b5ad07c84cff7
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 12:17:36 2010 +0200

    gl: Add a custom glGetError() function
    
    This function clears all errors and returns the first one that happened.

 src/cairo-gl-private.h |   19 ++++++++++++++++---
 1 file changed, 16 insertions(+), 3 deletions(-)

commit 8048d3aa0a11ab1c054887682b8b2a899a87da0e
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 10:50:21 2010 +0200

    gl: Remove custom fprintf fudging on GL errors
    
    Now that we probably call _cairo_error() on every GL error, there is no
    need to use custom methods to catch those errors. The usual breakpoint
    is enough.

 src/cairo-gl-private.h |    7 +------
 src/cairo-gl-surface.c |   20 --------------------
 2 files changed, 1 insertion(+), 26 deletions(-)

commit f4da5048bf87df0651ec83ca3f1ad6a5af7eb16d
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 10:44:15 2010 +0200

    gl: cairo_warn about return value from cairo_gl_context_release()

 src/cairo-gl-private.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d9179f480a43c7171806e2c33804aaae70a2cfa6
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 18 00:43:09 2010 +0200

    boilerplate: Reinstate glFinish() for wgl
    
    It was accidentally disabled.

 boilerplate/cairo-boilerplate-wgl.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 67e84d61230a2012c18d8bff60e8835aaa57be07
Author: Kristian Høgsberg <krh@bitplanet.net>
Date:   Thu Jun 17 17:38:00 2010 -0400

    egl: Implement acquire and release for EGL backend

 src/cairo-egl-context.c |   46 +++++++++++++++++++++++++++++++++++++---------
 1 file changed, 37 insertions(+), 9 deletions(-)

commit 7ab9ce1b9130dcd63b2b2b2516b77ef1ae531144
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 17 15:47:04 2010 +0100

    image: Make a local copy of the trap coordinates as the boxes alias.
    
    As we transform the array of trapezoids into an array of boxes in-place,
    we must take local copies of the coordinates before writing into the
    boxes otherwise we may inadvertently modify the trapezoidal coordinates.
    
    Fixes test/a1-bug.

 src/cairo-image-surface.c |   15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

commit f2645fa361003636d1da6ca38c3b61fef1b1ce4d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 17 15:38:53 2010 +0100

    test: Add a1-bug
    
    Capture a bug report from "cairouser" where a1 rasterisation is now
    broken.

 test/Makefile.am            |    3 +++
 test/Makefile.sources       |    1 +
 test/a1-bug.c               |   61 +++++++++++++++++++++++++++++++++++++++++++
 test/a1-bug.image16.ref.png |  Bin 0 -> 3329 bytes
 test/a1-bug.ref.png         |  Bin 0 -> 3736 bytes
 test/a1-bug.xlib.ref.png    |  Bin 0 -> 3362 bytes
 6 files changed, 65 insertions(+)

commit 800e977c2ea1e097c4b7332b18a5fc03089603c1
Author: M Joonas Pihlaja <jpihlaja@cc.helsinki.fi>
Date:   Thu Jun 17 14:27:13 2010 +0300

    perf: Allow comparing perf reports with only one difference.
    
    The cairo-perf-diff-files tool would ignore perf reports with
    just one test for no apparent reason.  The traces take so long
    that it's useful to be able to compare runs with just one trace.

 perf/cairo-perf-diff-files.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 29b8cfd2b6cf590fcfe64e5ba5b4479c2748ac06
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 17 10:11:31 2010 +0100

    test/halo: Remove copied code.
    
    How did that get there? I obviously ran the test to generate the output,
    so where did it spring as it is the old version of the function?
    
    From 16364768d79570e7201a87f0a985c65acaff5560.
    
    Mysteries will never cease.

 test/halo.c |   36 ------------------------------------
 1 file changed, 36 deletions(-)

commit a9a22649e2ffa1cd3720c8555dc3c6aff2040e3d
Author: Zoxc <zoxc32@gmail.com>
Date:   Wed Jun 16 21:33:30 2010 +0200

    wgl: Only reset GL context on the dummy window.
    
    This changes the WGL context destruction code to only reset the GL
    context for the dummy window, since doing it on <nothing> is an
    invalid operation.

 src/cairo-wgl-context.c |    6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit ca35e09ece5107c3ebc9f111d4a3d96d69aa3d03
Author: Zoxc <zoxc32@gmail.com>
Date:   Mon Jun 14 20:34:52 2010 +0200

    gl: Added wgl boilerplate and moved the glx and egl boilerplates into their own files.

 boilerplate/Makefile.sources        |    4 +-
 boilerplate/Makefile.win32.features |    8 +
 boilerplate/cairo-boilerplate-egl.c |  141 ++++++++++
 boilerplate/cairo-boilerplate-gl.c  |  492 -----------------------------------
 boilerplate/cairo-boilerplate-glx.c |  401 ++++++++++++++++++++++++++++
 boilerplate/cairo-boilerplate-wgl.c |  236 +++++++++++++++++
 build/Makefile.win32.features-h     |    1 +
 src/Makefile.win32.features         |    8 +
 8 files changed, 798 insertions(+), 493 deletions(-)

commit 2af3262895d74492a0f856f049d1524a527257bb
Author: Zoxc <zoxc32@gmail.com>
Date:   Mon Jun 14 20:33:17 2010 +0200

    wgl: Renamed hwnd field to wnd.

 src/cairo-wgl-context.c |   12 ++++++------
 1 file changed, 6 insertions(+), 6 deletions(-)

commit 7a023a62f7517ad0d54f4d59c99909fadcc05e82
Author: Nicolaus L Helper <nlhepler@gmail.com>
Date:   Thu Jun 17 08:56:30 2010 +0100

    ft,fc,xlib: LCD filtering patch.
    
    This adds internal API to retrieve the LCD filtering parameters from
    fontconfig, or as set on the Screen, and feed them to FreeType when
    rendering the glyph.
    
    References:
      Bug 10301 - LCD filtering patch
      https://bugs.freedesktop.org/show_bug.cgi?id=10301
    
    Tested-by: Brandon Wright <bearoso@gmail.com>
    Forward-ported-by: Robert Hooker <sarvatt@gmail.cm>
    
    ickle: The API is clearly not ready for public consumption, the enum are
    poorly named, however this stands by itself as enabling system wide
    properties.

 src/cairo-font-options.c  |   51 +++-
 src/cairo-ft-font.c       |  675 ++++++++++++++++++++++++++++++++-------------
 src/cairo-surface.c       |    1 +
 src/cairo-types-private.h |   25 ++
 src/cairo-xlib-screen.c   |   28 ++
 src/cairoint.h            |    7 +
 6 files changed, 597 insertions(+), 190 deletions(-)

commit 36b4b0631cc220d01c411b596a4eef839338cd7c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 17 08:50:31 2010 +0100

    image: Use consistent rounding modes for a1 rasterisation.
    
    When checking if the traps are equivalent to a set of rectangles, we
    need to use the same rounding mode as when converting the traps to a set
    of boxes and then filling them. Failure to do leads to a situation where
    (-127,-128) was thought to be equivalent to (0,0) but we attempted to
    fill from 0 to -1 instead.
    
    References:
      http://lists.cairographics.org/archives/cairo/2010-June/020115.html

 src/cairo-image-surface.c |   58 +++++++++++++++++++++++++++------------------
 1 file changed, 35 insertions(+), 23 deletions(-)

commit 3306bcb1d91265d60c460aa64d3ee4a4acb430a1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 17 08:47:48 2010 +0100

    fixed: Refactor code to use more inlines and less duplication of logic.
    
    This also has the side-effect of fixing the types in the problematic
    functions which hid Andrea's true fix for the unsigned FRAC_MASK.

 src/cairo-fixed-private.h |   18 +++++++++++++++---
 1 file changed, 15 insertions(+), 3 deletions(-)

commit c0dee7964c4394b7963041f246855fd3b01f4ebb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 16 18:49:58 2010 +0100

    test: Add a1-rasterisation
    
    Check the rounding criteria when rasterising.

 test/Makefile.am                         |    2 +
 test/Makefile.sources                    |    1 +
 test/a1-rasterisation-rectangles.ref.png |  Bin 0 -> 1729 bytes
 test/a1-rasterisation-triangles.ref.png  |  Bin 0 -> 1729 bytes
 test/a1-rasterisation.c                  |  101 ++++++++++++++++++++++++++++++
 5 files changed, 104 insertions(+)

commit 16364768d79570e7201a87f0a985c65acaff5560
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 16 15:09:22 2010 +0100

    test/halo: Transformation seems key to the bug...

 test/halo.c |   36 ++++++++++++++++++++++++++++++++++++
 1 file changed, 36 insertions(+)

commit cb28e0bfeb47a72f14ee42f161ebf6b5eb61e76b
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 17 08:42:39 2010 +0200

    test: correct options in getopt call
    
    'k' was missing and 't' was present but unhandled. Options have been
    reordered according to the "USAGE" ordering.

 test/cairo-test-runner.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3cd07559328b60e3da85debb805cb4a3fc4abc22
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Jun 16 22:54:08 2010 +0200

    correct rounding computation
    
    cairo_fixed_integer_round[_down] were adding an unsigned mask value
    before shifting its result, causing the shift to be computed as
    logical (unsigned) right shift, thus producing incorrect values for
    negative inputs. Making the mask value signed fixes this issue.
    
    Bug report by cu:
    http://lists.cairographics.org/archives/cairo/2010-June/020115.html

 src/cairo-fixed-private.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8689d75caaa9c6ee42976873d21684fa9f48834f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 16 15:09:22 2010 +0100

    test/halo: Transformation seems key to the bug...
    
    Only it is actually transformation of the result that is required in
    order to magnify the effect to a detectable level.

 test/Makefile.am                    |    5 +++
 test/halo-transform.image16.ref.png |  Bin 0 -> 10983 bytes
 test/halo-transform.ps.ref.png      |  Bin 0 -> 8691 bytes
 test/halo-transform.ref.png         |  Bin 0 -> 15086 bytes
 test/halo-transform.xlib.ref.png    |  Bin 0 -> 15346 bytes
 test/halo.c                         |   64 +++++++++++++++++++++++++++++++++--
 test/halo.image16.ref.png           |  Bin 5328 -> 6172 bytes
 test/halo.ps.ref.png                |  Bin 0 -> 5220 bytes
 test/halo.ref.png                   |  Bin 7524 -> 8839 bytes
 test/halo.xlib.ref.png              |  Bin 7404 -> 8835 bytes
 10 files changed, 67 insertions(+), 2 deletions(-)

commit 71936a1f414807a51c68de111362c2d5499bdfa7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 15 21:36:15 2010 +0100

    test/aliasing: Add a few more colour combinations.
    
    In particular, compare red against its inverse, cyan. Etc.

 test/aliasing.c               |    6 +++++-
 test/aliasing.image16.ref.png |  Bin 20810 -> 97251 bytes
 test/aliasing.ref.png         |  Bin 22980 -> 104672 bytes
 test/aliasing.xlib.ref.png    |  Bin 24018 -> 104315 bytes
 4 files changed, 5 insertions(+), 1 deletion(-)

commit e2220a1f3a7b483e615f5bb993a014d20b0f788a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 15 11:45:54 2010 +0100

    configure: Try an alternate name for system glew.

 configure.ac |   10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit 25ec0c1e9b5af2ba68200b79b252de5c1b371d0a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 15 10:59:01 2010 +0100

    build: Enable system GLEW on non-UNIX platforms

 configure.ac |   12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 52624446636bb5941ca2180afa2c0be275414cec
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jun 15 10:40:36 2010 +0100

    glew: Define NULL

 src/glew/glew.c |    4 ++++
 1 file changed, 4 insertions(+)

commit 56d06b088b9c355ca76a38191717a8e03aa5f59a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 14 22:58:38 2010 +0100

    test: Add an aliasing test case.
    
    Just a simple test in drawing neighbouring edges and looking for the
    effects of aliasing.

 test/Makefile.am              |    3 ++
 test/Makefile.sources         |    1 +
 test/aliasing.c               |   98 +++++++++++++++++++++++++++++++++++++++++
 test/aliasing.image16.ref.png |  Bin 0 -> 20810 bytes
 test/aliasing.ref.png         |  Bin 0 -> 22980 bytes
 test/aliasing.xlib.ref.png    |  Bin 0 -> 24018 bytes
 6 files changed, 102 insertions(+)

commit 4b39f02bf7e8b4921518db4a2d8564514cb323a9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 14 20:38:26 2010 +0100

    test: Add halo
    
    halo uses text_path + stroke + (fill | show_text)  to generate a "halo"
    around the string. This is to try to replicate a bug described by Ian
    Britten in the PDF backend where the rendering of the show_text looked
    distorted compared to the stroke.

 test/Makefile.am          |    3 ++
 test/Makefile.sources     |    1 +
 test/halo.c               |   98 +++++++++++++++++++++++++++++++++++++++++++++
 test/halo.image16.ref.png |  Bin 0 -> 5328 bytes
 test/halo.ref.png         |  Bin 0 -> 7524 bytes
 test/halo.xlib.ref.png    |  Bin 0 -> 7404 bytes
 6 files changed, 102 insertions(+)

commit 072a200ec502bf5ac3e62702e6f14ed18171b1e0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Jun 14 16:05:14 2010 +0100

    build: Add wgl to Makefile.sources and regenerate features.

 boilerplate/Makefile.win32.features |   10 ++++++++++
 build/Makefile.win32.features       |    1 +
 build/Makefile.win32.features-h     |    3 +++
 src/Makefile.sources                |    6 ++++--
 src/Makefile.win32.features         |   14 ++++++++++++++
 5 files changed, 32 insertions(+), 2 deletions(-)

commit 4a0bd91ff77c8afddde6d09495bc9ca7242f953d
Author: Dmitri Vorobiev <dmitri.vorobiev@movial.com>
Date:   Mon Jun 14 16:40:39 2010 +0300

    scaled-font: fine-tune caching
    
    This patch implements the ideas outlined by Behdad Esfahbod in the following
    mailing list message:
    
    http://lists.cairographics.org/archives/cairo/2010-June/020065.html
    
    Specifically, two things have been adjusted. First, the size of the look-up
    table was reduced to 64. Second, cache codepath is now bypassed for strings
    that are shorter than 16, not only for one-character strings. This allowed
    us to reduce the LUT initialization overhead while still retaining the
    advantage of caching for common-case string sizes.
    
    We have experimented with different LUT sizes, and it came out that the size
    of 64 is the best one in view of speed, at least for our language-neutral
    benchmark, which generated random strings of printable ASCII characters.
    
    Below is a table presenting benchmark results for different values of LUT
    size:
    
    ===============================================================================
     Benchmark		| [1]	| [2]	| [3]	| [4]	| [5]	| [6]	| [7]
    ===============================================================================
    8px text, 1 chars	| 0.41	| 0.41	| 0	| 0.41	| 0	| 0.41	| 0
    8px text, 10 chars	| 2.13	| 2.21	| 3.76	| 2.19	| 2.82	| 2.09	| -1.88
    8px text, 20 chars	| 2.97	| 3.04	| 2.36	| 3.01	| 1.35	| 2.98	| 0.34
    12px text, 1 chars	| 0.94	| 0.94	| 0	| 0.95	| 1.06	| 0.94	| 0
    12px text, 10 chars	| 4.73	| 4.89	| 3.38	| 4.9	| 3.59	| 4.82	| 1.9
    12px text, 20 chars	| 6.32	| 6.42	| 1.58	| 6.46	| 2.22	| 6.32	| 0
    16px text, 1 chars	| 1.75	| 1.76	| 0.57	| 1.77	| 1.14	| 1.76	| 0.57
    16px text, 10 chars	| 8.13	| 8.45	| 3.94	| 8.43	| 3.69	| 8.44	| 3.81
    16px text, 20 chars	| 10.41	| 10.69	| 2.69	| 10.64	| 2.21	| 10.65	| 2.31
    24px text, 1 chars	| 3.3	| 3.3	| 0	| 3.32	| 0.61	| 3.3	| 0
    24px text, 10 chars	| 14.68	| 14.97	| 1.98	| 14.97	| 1.98	| 14.87	| 1.29
    24px text, 20 chars	| 17.93	| 18.01	| 0.45	| 18.06	| 0.73	| 17.81	| -0.67
    96px text, 1 chars	| 23.65	| 23.38	| -1.14	| 23.74	| 0.38	| 23.65	| 0
    96px text, 5 chars	| 50.52	| 51.34	| 1.62	| 51.48	| 1.9	| 51.41	| 1.76
    96px text, 10 chars	| 57.5	| 58.11	| 1.06	| 58.27	| 1.34	| 58.04	| 0.94
    ===============================================================================
    
    [1]: Git head, Mpix/s
    [2]: {GLYPH_LUT_SIZE = 32, CACHING_THRESHOLD = 16}
    [3]: Gain of {32, 16} w.r.t. Git head
    [4]: {GLYPH_LUT_SIZE = 64, CACHING_THRESHOLD = 16}
    [5]: Gain of {64, 16} w.r.t. Git head
    [6]: {GLYPH_LUT_SIZE = 128, CACHING_THRESHOLD = 16}
    [7]: Gain of {128, 16} w.r.t. Git head
    
    The benchmark itself can be found from this mailing list message:
    
    http://lists.cairographics.org/archives/cairo/2010-June/020064.html

 src/cairo-scaled-font.c |   61 ++++++++++++++++++++++++++++++++++-------------
 1 file changed, 45 insertions(+), 16 deletions(-)

commit 505a0456d2498112155db7e7f275a14dc98f643e
Author: Zoxc <zoxc32@gmail.com>
Date:   Mon Jun 14 01:20:54 2010 +0200

    gl: Added WGL context and surface.

 build/configure.ac.features |    1 +
 configure.ac                |    9 ++
 src/cairo-gl.h              |   16 +++
 src/cairo-wgl-context.c     |  253 +++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 279 insertions(+)

commit fd6c38b9e006feefa20ce4f54d3108dad51c828d
Author: Zoxc <zoxc32@gmail.com>
Date:   Mon Jun 14 01:04:10 2010 +0200

    win32: Fixed compile errors in Windows backend.

 src/cairo-win32-printing-surface.c |    9 ++++-----
 src/cairo-win32-surface.c          |    4 ++--
 2 files changed, 6 insertions(+), 7 deletions(-)

commit 5f10139cd92383c657e328ffad41874c4f668551
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jun 13 12:33:10 2010 +0100

    NEWS: A couple more tweaks
    
    I only spotted these in the release announcement.

 NEWS |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 4932aaa3173799c8f3ac30e4c9a594c20c83a121
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jun 13 12:02:53 2010 +0100

    version: 1.9.9
    
    Post-snapshot bump.

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3a20b10cd0d94406fbd5fe3bb3d4820a95364537
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jun 13 10:27:03 2010 +0100

    version: 1.9.8
    
    Snapshot time!

 cairo-version.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b612a230865a1a62f9cdcb051de9b57b509646b2
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sun Jun 13 12:29:24 2010 +0200

    test: update quartz ref images in makefile

 test/Makefile.am |  143 +++++++++++++++++++++++++++++++++++++++++-------------
 1 file changed, 109 insertions(+), 34 deletions(-)

commit 0693af2328606a4c7e4c888d2a1cd346e6bef405
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jun 13 10:22:37 2010 +0100

    test: Move all output below test/output/
    
    make distcheck complains of remanents being left under test/ after a
    clean, notably the files used to check the capabilities of a similar
    surface and the fallback-resolution output.

 test/cairo-test.c          |   53 +++++++++++++++++++++++++-------------------
 test/fallback-resolution.c |   30 +++++++++++++++++++++----
 2 files changed, 56 insertions(+), 27 deletions(-)

commit ffc3a39c95e918fa2fcd14c1b1063b9a9acceebf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 20:04:36 2010 +0100

    NEWS: Minor tweaks.

 NEWS |   46 +++++++++++++++++++++++-----------------------
 1 file changed, 23 insertions(+), 23 deletions(-)

commit b6e16b8d2950cdadf2e2b14b0e7502d4a9ebdc09
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sat Jun 12 10:33:35 2010 +0200

    test: quartz ref image refresh

 test/a1-image-sample.quartz.xfail.png                         |  Bin 0 -> 972 bytes
 test/a1-mask-sample.quartz.xfail.png                          |  Bin 0 -> 972 bytes
 test/a1-traps-sample.quartz.xfail.png                         |  Bin 0 -> 122 bytes
 test/big-line.quartz.ref.png                                  |  Bin 0 -> 993 bytes
 test/caps-joins-curve.quartz.ref.png                          |  Bin 0 -> 5199 bytes
 test/clear.quartz.argb32.ref.png                              |  Bin 0 -> 691 bytes
 test/clear.quartz.rgb24.ref.png                               |  Bin 0 -> 606 bytes
 test/clip-disjoint.quartz.ref.png                             |  Bin 0 -> 5476 bytes
 test/clip-fill-rule.quartz.rgb24.ref.png                      |  Bin 0 -> 363 bytes
 test/clip-fill-unbounded.quartz.argb32.ref.png                |  Bin 0 -> 1436 bytes
 test/clip-fill-unbounded.quartz.rgb24.ref.png                 |  Bin 0 -> 1368 bytes
 test/clip-fill.quartz.ref.png                                 |  Bin 0 -> 875 bytes
 test/clip-group-shapes-circles.quartz.ref.png                 |  Bin 0 -> 1518 bytes
 test/clip-nesting.quartz.argb32.ref.png                       |  Bin 0 -> 1048 bytes
 test/clip-nesting.quartz.ref.png                              |  Bin 1067 -> 0 bytes
 test/clip-nesting.quartz.rgb24.ref.png                        |  Bin 956 -> 937 bytes
 test/clip-operator.quartz.argb32.ref.png                      |  Bin 0 -> 9586 bytes
 test/clip-operator.quartz.ref.png                             |  Bin 9539 -> 0 bytes
 test/clip-operator.quartz.rgb24.ref.png                       |  Bin 4412 -> 4104 bytes
 test/clip-push-group.quartz.ref.png                           |  Bin 203 -> 166 bytes
 test/clip-shape.quartz.ref.png                                |  Bin 0 -> 3229 bytes
 test/clip-stroke-unbounded.quartz.argb32.ref.png              |  Bin 0 -> 1493 bytes
 test/clip-stroke-unbounded.quartz.rgb24.ref.png               |  Bin 0 -> 1356 bytes
 test/clip-stroke.quartz.ref.png                               |  Bin 0 -> 1305 bytes
 test/clip-text.quartz.ref.png                                 |  Bin 0 -> 854 bytes
 test/clip-twice.quartz.argb32.ref.png                         |  Bin 0 -> 1171 bytes
 test/clip-twice.quartz.ref.png                                |  Bin 1171 -> 0 bytes
 test/clip-twice.quartz.rgb24.ref.png                          |  Bin 1111 -> 1095 bytes
 test/clipped-group.quartz.ref.png                             |  Bin 0 -> 308 bytes
 test/culled-glyphs.quartz.ref.png                             |  Bin 0 -> 493 bytes
 test/dash-caps-joins.quartz.ref.png                           |  Bin 4727 -> 0 bytes
 test/dash-caps-joins.quartz.xfail.png                         |  Bin 0 -> 4446 bytes
 test/dash-curve.quartz.ref.png                                |  Bin 47965 -> 0 bytes
 test/dash-curve.quartz.xfail.png                              |  Bin 0 -> 42238 bytes
 test/dash-scale.quartz.ref.png                                |  Bin 8079 -> 7614 bytes
 test/dash-state.quartz.ref.png                                |  Bin 8698 -> 0 bytes
 test/dash-state.quartz.xfail.png                              |  Bin 0 -> 6957 bytes
 test/degenerate-arc.quartz.ref.png                            |  Bin 0 -> 552 bytes
 test/degenerate-curve-to.quartz.ref.png                       |  Bin 0 -> 247 bytes
 test/degenerate-dash.quartz.xfail.png                         |  Bin 0 -> 1560 bytes
 test/degenerate-path.quartz.argb32.xfail.png                  |  Bin 0 -> 200 bytes
 test/degenerate-path.quartz.ref.png                           |  Bin 232 -> 0 bytes
 test/degenerate-path.quartz.rgb24.ref.png                     |  Bin 198 -> 0 bytes
 test/degenerate-path.quartz.rgb24.xfail.png                   |  Bin 0 -> 172 bytes
 test/degenerate-pen.quartz.ref.png                            |  Bin 1144 -> 0 bytes
 test/degenerate-rel-curve-to.quartz.ref.png                   |  Bin 0 -> 246 bytes
 test/extend-pad-border.quartz.ref.png                         |  Bin 0 -> 432 bytes
 test/extend-pad-similar.quartz.xfail.png                      |  Bin 0 -> 270 bytes
 test/extend-pad.quartz.xfail.png                              |  Bin 0 -> 270 bytes
 test/fill-alpha-pattern.quartz.ref.png                        |  Bin 0 -> 7943 bytes
 test/fill-alpha.quartz.ref.png                                |  Bin 0 -> 2704 bytes
 test/fill-and-stroke-alpha-add.quartz.ref.png                 |  Bin 603 -> 542 bytes
 test/fill-and-stroke-alpha.quartz.ref.png                     |  Bin 550 -> 0 bytes
 test/fill-and-stroke.quartz.argb32.ref.png                    |  Bin 0 -> 273 bytes
 test/fill-and-stroke.quartz.ref.png                           |  Bin 286 -> 0 bytes
 test/fill-and-stroke.quartz.rgb24.ref.png                     |  Bin 264 -> 249 bytes
 test/fill-degenerate-sort-order.quartz.argb32.ref.png         |  Bin 0 -> 2451 bytes
 test/fill-degenerate-sort-order.quartz.ref.png                |  Bin 2470 -> 0 bytes
 test/fill-degenerate-sort-order.quartz.rgb24.ref.png          |  Bin 2098 -> 2079 bytes
 test/fill-image.quartz.ref.png                                |  Bin 0 -> 1297 bytes
 test/fill-rule.quartz.argb32.ref.png                          |  Bin 0 -> 2060 bytes
 test/fill-rule.quartz.ref.png                                 |  Bin 2079 -> 0 bytes
 test/fill-rule.quartz.rgb24.ref.png                           |  Bin 1790 -> 1771 bytes
 test/filter-bilinear-extents.quartz.xfail.png                 |  Bin 0 -> 308 bytes
 test/filter-nearest-offset.quartz.xfail.png                   |  Bin 0 -> 2130 bytes
 test/filter-nearest-transformed.quartz.xfail.png              |  Bin 0 -> 534 bytes
 test/finer-grained-fallbacks.quartz.argb32.ref.png            |  Bin 0 -> 988 bytes
 test/finer-grained-fallbacks.quartz.rgb24.ref.png             |  Bin 0 -> 763 bytes
 test/font-matrix-translation.quartz.ref.png                   |  Bin 1090 -> 996 bytes
 test/ft-show-glyphs-table.quartz.xfail.png                    |  Bin 0 -> 827 bytes
 test/ft-text-vertical-layout-type1.quartz.xfail.png           |  Bin 0 -> 3635 bytes
 test/ft-text-vertical-layout-type3.quartz.ref.png             |  Bin 0 -> 3573 bytes
 test/glyph-cache-pressure.quartz.ref.png                      |  Bin 3654 -> 3284 bytes
 test/gradient-constant-alpha.quartz.argb32.ref.png            |  Bin 0 -> 214 bytes
 test/group-unaligned.quartz.ref.png                           |  Bin 0 -> 363 bytes
 test/huge-radial.quartz.ref.png                               |  Bin 0 -> 84690 bytes
 test/inverse-text.quartz.ref.png                              |  Bin 0 -> 2565 bytes
 test/joins.quartz.ref.png                                     |  Bin 0 -> 5833 bytes
 test/leaky-dash.quartz.ref.png                                |  Bin 241 -> 195 bytes
 test/leaky-dashed-rectangle.quartz.ref.png                    |  Bin 0 -> 339 bytes
 test/leaky-dashed-stroke.quartz.ref.png                       |  Bin 0 -> 9229 bytes
 test/line-width-scale.quartz.ref.png                          |  Bin 6434 -> 5623 bytes
 test/linear-gradient-reflect.quartz.ref.png                   |  Bin 878 -> 780 bytes
 test/linear-gradient-subset.quartz.ref.png                    |  Bin 0 -> 887 bytes
 test/linear-gradient.quartz.ref.png                           |  Bin 1164 -> 1060 bytes
 test/long-dashed-lines.quartz.ref.png                         |  Bin 2313 -> 2068 bytes
 test/mask-alpha.quartz.argb32.ref.png                         |  Bin 641 -> 622 bytes
 test/mask-transformed-image.quartz.ref.png                    |  Bin 0 -> 3909 bytes
 test/mask-transformed-similar.quartz.ref.png                  |  Bin 0 -> 3909 bytes
 test/mask.quartz.argb32.ref.png                               |  Bin 0 -> 10575 bytes
 test/mask.quartz.ref.png                                      |  Bin 10682 -> 0 bytes
 test/mask.quartz.rgb24.ref.png                                |  Bin 8418 -> 8354 bytes
 test/new-sub-path.quartz.ref.png                              |  Bin 383 -> 370 bytes
 test/new-sub-path.quartz.rgb24.ref.png                        |  Bin 357 -> 0 bytes
 test/operator-clear.quartz.argb32.ref.png                     |  Bin 0 -> 1228 bytes
 test/operator-clear.quartz.ref.png                            |  Bin 1459 -> 0 bytes
 test/operator-clear.quartz.rgb24.ref.png                      |  Bin 1293 -> 1096 bytes
 test/operator-source.quartz.argb32.ref.png                    |  Bin 0 -> 4754 bytes
 test/operator-source.quartz.ref.png                           |  Bin 4637 -> 0 bytes
 test/operator-source.quartz.rgb24.ref.png                     |  Bin 3533 -> 3535 bytes
 test/over-above-source.quartz.argb32.ref.png                  |  Bin 0 -> 511 bytes
 test/over-above-source.quartz.ref.png                         |  Bin 530 -> 0 bytes
 test/over-above-source.quartz.rgb24.ref.png                   |  Bin 456 -> 437 bytes
 test/over-around-source.quartz.argb32.ref.png                 |  Bin 0 -> 593 bytes
 test/over-around-source.quartz.ref.png                        |  Bin 612 -> 0 bytes
 test/over-around-source.quartz.rgb24.ref.png                  |  Bin 491 -> 0 bytes
 test/over-between-source.quartz.argb32.ref.png                |  Bin 0 -> 551 bytes
 test/over-between-source.quartz.ref.png                       |  Bin 570 -> 0 bytes
 test/over-between-source.quartz.rgb24.ref.png                 |  Bin 467 -> 0 bytes
 test/path-append.quartz.ref.png                               |  Bin 0 -> 6395 bytes
 test/pthread-same-source.quartz.xfail.png                     |  Bin 0 -> 957 bytes
 test/pthread-show-text.quartz.ref.png                         |  Bin 0 -> 42996 bytes
 test/push-group-color.quartz.ref.png                          |  Bin 0 -> 3127 bytes
 test/push-group.quartz.argb32.ref.png                         |  Bin 0 -> 3932 bytes
 test/push-group.quartz.rgb24.ref.png                          |  Bin 0 -> 3659 bytes
 test/radial-gradient.quartz.ref.png                           |  Bin 92334 -> 0 bytes
 test/random-intersections-curves-eo.quartz.ref.png            |  Bin 0 -> 326366 bytes
 test/random-intersections-curves-nz.quartz.ref.png            |  Bin 0 -> 324940 bytes
 test/random-intersections-eo.quartz.ref.png                   |  Bin 197778 -> 179179 bytes
 test/random-intersections-nonzero.quartz.ref.png              |  Bin 0 -> 180871 bytes
 test/recording-surface-pattern.quartz.argb32.ref.png          |  Bin 0 -> 4570 bytes
 test/recording-surface-pattern.quartz.ref.png                 |  Bin 4572 -> 0 bytes
 test/recording-surface-pattern.quartz.rgb24.ref.png           |  Bin 4063 -> 4058 bytes
 test/rectilinear-dash.quartz.xfail.png                        |  Bin 0 -> 494 bytes
 test/rectilinear-stroke.quartz.xfail.png                      |  Bin 0 -> 209 bytes
 test/reflected-stroke.quartz.ref.png                          |  Bin 5293 -> 0 bytes
 test/rel-path.quartz.ref.png                                  |  Bin 212 -> 0 bytes
 test/rel-path.quartz.rgb24.ref.png                            |  Bin 228 -> 0 bytes
 test/rotate-image-surface-paint.quartz.ref.png                |  Bin 257 -> 356 bytes
 test/rotated-clip.quartz.ref.png                              |  Bin 0 -> 3923 bytes
 test/rounded-rectangle-fill.quartz.ref.png                    |  Bin 0 -> 684 bytes
 test/scale-offset-image.quartz.ref.png                        |  Bin 0 -> 9054 bytes
 test/scale-offset-similar.quartz.ref.png                      |  Bin 0 -> 9054 bytes
 test/select-font-face.quartz.ref.png                          |  Bin 2970 -> 2645 bytes
 test/self-intersecting.quartz.xfail.png                       |  Bin 0 -> 233 bytes
 test/show-text-current-point.quartz.ref.png                   |  Bin 3093 -> 2773 bytes
 test/smask-fill.quartz.ref.png                                |  Bin 0 -> 2076 bytes
 test/smask-mask.quartz.ref.png                                |  Bin 0 -> 3357 bytes
 test/smask-paint.quartz.ref.png                               |  Bin 0 -> 3499 bytes
 test/smask-stroke.quartz.ref.png                              |  Bin 0 -> 1697 bytes
 test/smask-text.quartz.ref.png                                |  Bin 0 -> 1904 bytes
 test/smask.quartz.ref.png                                     |  Bin 0 -> 4067 bytes
 test/source-clip-scale.quartz.ref.png                         |  Bin 148 -> 126 bytes
 test/spline-decomposition.quartz.xfail.png                    |  Bin 0 -> 19560 bytes
 test/stroke-ctm-caps.quartz.ref.png                           |  Bin 1109 -> 899 bytes
 test/stroke-image.quartz.ref.png                              |  Bin 1802 -> 1350 bytes
 test/subsurface-pad.quartz.xfail.png                          |  Bin 0 -> 197 bytes
 test/surface-pattern-big-scale-down.quartz.ref.png            |  Bin 0 -> 258 bytes
 test/surface-pattern-operator.quartz.argb32.xfail.png         |  Bin 0 -> 5917 bytes
 test/surface-pattern-operator.quartz.rgb24.xfail.png          |  Bin 0 -> 2546 bytes
 test/surface-pattern-scale-down-extend-none.quartz.ref.png    |  Bin 0 -> 391 bytes
 test/surface-pattern-scale-down-extend-pad.quartz.xfail.png   |  Bin 0 -> 397 bytes
 test/surface-pattern-scale-down-extend-reflect.quartz.ref.png |  Bin 0 -> 475 bytes
 test/surface-pattern-scale-down-extend-repeat.quartz.ref.png  |  Bin 0 -> 397 bytes
 test/surface-pattern-scale-down.quartz.ref.png                |  Bin 3188 -> 2276 bytes
 test/surface-pattern-scale-up.quartz.xfail.png                |  Bin 0 -> 3294 bytes
 test/surface-pattern.quartz.xfail.png                         |  Bin 0 -> 9216 bytes
 test/text-antialias-gray.quartz.ref.png                       |  Bin 1041 -> 956 bytes
 test/text-antialias-none.quartz.ref.png                       |  Bin 300 -> 270 bytes
 test/text-antialias-subpixel.quartz.ref.png                   |  Bin 1065 -> 949 bytes
 test/text-glyph-range.quartz.ref.png                          |  Bin 0 -> 2191 bytes
 test/text-pattern.quartz.argb32.ref.png                       |  Bin 0 -> 2148 bytes
 test/text-pattern.quartz.ref.png                              |  Bin 2158 -> 0 bytes
 test/text-pattern.quartz.rgb24.ref.png                        |  Bin 1874 -> 1867 bytes
 test/text-rotate.quartz.ref.png                               |  Bin 17820 -> 16655 bytes
 test/trap-clip.quartz.argb32.ref.png                          |  Bin 0 -> 6060 bytes
 test/trap-clip.quartz.ref.png                                 |  Bin 6041 -> 0 bytes
 test/trap-clip.quartz.rgb24.ref.png                           |  Bin 5385 -> 5694 bytes
 test/unantialiased-shapes.quartz.ref.png                      |  Bin 4394 -> 3868 bytes
 test/unbounded-operator.quartz.ref.png                        |  Bin 4066 -> 0 bytes
 test/unbounded-operator.quartz.rgb24.ref.png                  |  Bin 1918 -> 0 bytes
 test/user-font-proxy.quartz.ref.png                           |  Bin 0 -> 19795 bytes
 test/user-font-rescale.quartz.ref.png                         |  Bin 0 -> 15982 bytes
 test/user-font.quartz.ref.png                                 |  Bin 0 -> 5960 bytes
 test/xcomposite-projection.quartz.ref.png                     |  Bin 0 -> 639 bytes
 175 files changed, 0 insertions(+), 0 deletions(-)

commit 0d5a15f23812575c80db44ca23075293cc0dbfad
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 20:00:24 2010 +0100

    check: Disable running cairo-perf-micro
    
    Since this takes days to run now and should not find any bugs that are
    not covered by the test-suite it seems like a pointless exercise.
    Especially as I am trying to make a release!

 perf/Makefile.am |   15 ++++-----------
 1 file changed, 4 insertions(+), 11 deletions(-)

commit e9fb39daee9ef3f80e4aedbda68027b36ce94fe3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 19:40:42 2010 +0100

    NEWS: take two.

 NEWS |   81 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 75 insertions(+), 6 deletions(-)

commit 62899e5e23a798bb3e9b60c9e793555e973b7823
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 18:51:31 2010 +0100

    NEWS: Boring stub for 1.9.10.

 NEWS |   19 +++++++++++++++++++
 1 file changed, 19 insertions(+)

commit fc372b1d9dea1ed4cb4229eaaad62a2d8e112a03
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 16:50:30 2010 +0100

    test: Missing ref images

 test/Makefile.am                       |    8 ++++----
 test/coverage-triangles.xlib.xfail.png |  Bin 0 -> 15859 bytes
 2 files changed, 4 insertions(+), 4 deletions(-)

commit 8737bc8b17ff0c437bb57df018bb7c540a394a7c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 16:49:46 2010 +0100

    gl: start returning the failure status aftern an invalid GL op.

 src/cairo-gl-composite.c |    1 +
 src/cairo-gl-device.c    |   26 +++++++++++++++++++-------
 src/cairo-gl-glyphs.c    |   10 +++++++---
 src/cairo-gl-private.h   |   45 ++++++++++++++++++++++++++++++++++-----------
 src/cairo-gl-surface.c   |   40 +++++++++++++++++++++++++---------------
 5 files changed, 86 insertions(+), 36 deletions(-)

commit 5b2f90bf532184e46829de4b2e2f9d0b10c1ff81
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 16:49:11 2010 +0100

    test: Forgotten ref image.

 test/clipped-group.xlib-fallback.ref.png |  Bin 0 -> 344 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit cdd6f11716e3fbe579d68161caec220c7852fdff
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 15:44:29 2010 +0100

    test: Record the expected failure mode for partial-coverage-intersecting-quads
    
    As the diagonals of the quad intersect below the limits of Cairo's fixed
    point, we fail to take heed of the intersection.

 test/Makefile.am                                   |    1 +
 test/partial-coverage-intersecting-quads.xfail.png |  Bin 0 -> 262 bytes
 2 files changed, 1 insertion(+)

commit 3d72b4aa70d106b5da093e6405c7e3890fa343cf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 15:32:31 2010 +0100

    test/coverage: The comment was still wrong.
    
    Writing comments is hard. I give in.

 test/coverage.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e6d1b3a8ce0b516aed7715b57d9ca5ab4fad6c2f
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sat Jun 12 16:22:54 2010 +0200

    test: update font family name
    
    Update the name of the test font family to DejaVu, so that backends
    unable to rely on fontconfig to match font names can find the correct
    font anyway.

 test/README       |   10 +++++-----
 test/cairo-test.h |    2 +-
 2 files changed, 6 insertions(+), 6 deletions(-)

commit 3cb882d01b53cb3cec9be62d678dd4ef7ea2c1fd
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sat Jun 12 16:20:37 2010 +0200

    test: make test font family a define
    
    In order to make it easier to change the test font family, add it
    as a define in the global header and always reference the macro in
    the tests.

 test/cairo-test.h                    |    2 ++
 test/clip-all.c                      |    2 +-
 test/clip-empty-save.c               |    2 +-
 test/clip-empty.c                    |    2 +-
 test/clip-operator.c                 |    2 +-
 test/font-face-get-type.c            |    2 +-
 test/font-matrix-translation.c       |    2 +-
 test/ft-show-glyphs-positioning.c    |    2 +-
 test/ft-show-glyphs-table.c          |    2 +-
 test/ft-text-antialias-none.c        |    2 +-
 test/ft-text-vertical-layout-type3.c |    2 +-
 test/get-path-extents.c              |    2 +-
 test/glyph-cache-pressure.c          |    2 +-
 test/inverse-text.c                  |    6 +++---
 test/large-font.c                    |    2 +-
 test/operator-clear.c                |    2 +-
 test/operator-source.c               |    2 +-
 test/overlapping-glyphs.c            |    2 +-
 test/pdf-features.c                  |    2 +-
 test/ps-features.c                   |    2 +-
 test/select-font-face.c              |    6 +++---
 test/select-font-no-show-text.c      |    2 +-
 test/show-text-current-point.c       |    2 +-
 test/smask-text.c                    |    2 +-
 test/smask.c                         |    2 +-
 test/text-antialias-gray.c           |    2 +-
 test/text-antialias-none.c           |    2 +-
 test/text-antialias-subpixel.c       |    2 +-
 test/text-glyph-range.c              |    2 +-
 test/text-pattern.c                  |    2 +-
 test/text-rotate.c                   |    2 +-
 test/text-transform.c                |    2 +-
 test/text-zero-len.c                 |    2 +-
 test/unbounded-operator.c            |    2 +-
 test/user-font-rescale.c             |    6 +++---
 35 files changed, 42 insertions(+), 40 deletions(-)

commit b1e4df928fb59ee295830d5c0fa26330714f88f2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 15:28:28 2010 +0100

    test/coverage: Refine comments
    
    Joonas didn't like me putting incorrect labels in my comments. Said they
    were misleading and worse than useless. Harsh.

 test/coverage.c |   20 +++++++++++++-------
 1 file changed, 13 insertions(+), 7 deletions(-)

commit 968374b6335199cbf02c8c4733537388da2a45f5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 15:14:17 2010 +0100

    test/coverage: Add a comment describing the column_triangle geometry()

 test/coverage.c |   20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 299263f8c912d3468d51ed22bcb6ab96275709f0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 13:48:12 2010 +0100

    test: Disable tests that are too slow to run by default.
    
    Introduce a slow mode [-s] to the runner, and add "slow" to the
    requirements for the very long running tests like the coverage stress
    tests.

 test/cairo-test-runner.c |   17 +++++++++++++++--
 test/coverage.c          |   12 ++++++------
 test/half-coverage.c     |    4 ++--
 test/mask-glyphs.c       |    2 +-
 test/partial-coverage.c  |   16 ++++++++--------
 5 files changed, 32 insertions(+), 19 deletions(-)

commit 53139261c7ba1a4cc0b869cb48c136b0362a3b0c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 13:40:17 2010 +0100

    test: Use exact matching on test names by default.
    
    Specifying individual tests to run is more common than using a group
    chosen from a keyword, so change the default matching mode and introduce
    '-k' to select by keyword.

 test/cairo-test-runner.c |   45 ++++++++++++++++++++++-----------------------
 1 file changed, 22 insertions(+), 23 deletions(-)

commit 97288b0859bae6cea1e3bff84b632e00f1d10917
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 13:34:27 2010 +0100

    test: More minute geometry exercised by partial-coverage.
    
    Moving beyond the capabilities of cairo...

 test/Makefile.am                                   |    2 +
 test/partial-coverage-intersecting-quads.ref.png   |  Bin 0 -> 189 bytes
 ...partial-coverage-intersecting-triangles.ref.png |  Bin 0 -> 202 bytes
 test/partial-coverage.c                            |  131 ++++++++++++++++++++
 4 files changed, 133 insertions(+)

commit 4e3ef57bc892b0b046c486390adc7164a1de64de
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 13:18:42 2010 +0100

    test: More coverage coverage.
    
    A couple of different shapes that aim to test the tessellation side of
    the rasterisers more... And worryingly there does seem to be an
    unexpected systematic error.

 test/Makefile.am                                   |    8 +
 test/coverage-column-triangles.ref.png             |  Bin 0 -> 208 bytes
 test/coverage-column-triangles.xlib.xfail.png      |  Bin 0 -> 12745 bytes
 test/coverage-intersecting-quads.ref.png           |  Bin 0 -> 253 bytes
 test/coverage-intersecting-quads.xlib.xfail.png    |  Bin 0 -> 15296 bytes
 test/coverage-intersecting-triangles.ref.png       |  Bin 0 -> 209 bytes
 .../coverage-intersecting-triangles.xlib.xfail.png |  Bin 0 -> 16728 bytes
 test/coverage-row-triangles.ref.png                |  Bin 0 -> 208 bytes
 test/coverage-row-triangles.xlib.xfail.png         |  Bin 0 -> 12671 bytes
 test/coverage.c                                    |  249 +++++++++++++++++++-
 10 files changed, 251 insertions(+), 6 deletions(-)

commit 9b7cc7641b691a3b9e3d5edd51053c9a095d9c5a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Jun 12 10:41:09 2010 +0100

    cairo: Create error objects for cairo_t
    
    Perform an early check for error status and prevent creation of a full
    object. This means that we do not pass down error objects to the
    initialisation routines and so can survive without paranoia inside the
    library. It also has brings consistency that like the other
    constructors, no object is created in error and we can skip the
    cairo_destroy() if we choose (and we don't waste one of the precious
    zero-alloc context slots.
    
    Fixes crash in test/a8-mask introduced by 1a544361e845.

 src/cairo-debug.c              |    2 ++
 src/cairo-mutex-list-private.h |    1 +
 src/cairo.c                    |   76 ++++++++++++++++++++++++++++++++++------
 src/cairoint.h                 |    3 ++
 4 files changed, 71 insertions(+), 11 deletions(-)

commit 9b6617a3b3b31d52e6646400b16ec56c754bfebd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 21:58:34 2010 +0100

    image: Apply component alpha to composite masks.
    
    If we need to pattern requires component alpha, then we must take a
    copy of the image and enable component alpha for pixman.
    
    Fixes test/text-antialias-subpixel on xlib-fallback -- i.e. we will
    finally render subpixel antialiased text on ancient XServers.

 src/cairo-image-surface.c |   40 ++++++++++++++++++++++++----------------
 1 file changed, 24 insertions(+), 16 deletions(-)

commit 7440fc07f77b112b00957f5459129dba23a5683f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 21:29:02 2010 +0100

    test: xlib ref image refresh

 test/Makefile.am                                   |   26 ++++++++++++++------
 ...clip-fill-unbounded.xlib-fallback.rgb24.ref.png |  Bin 1429 -> 1438 bytes
 test/clip-fill-unbounded.xlib.argb32.ref.png       |  Bin 1758 -> 1759 bytes
 test/clip-fill-unbounded.xlib.rgb24.ref.png        |  Bin 1426 -> 1430 bytes
 test/clip-group-shapes-circles.xlib.ref.png        |  Bin 0 -> 1534 bytes
 ...-group-shapes-unaligned-rectangles.xlib.ref.png |  Bin 0 -> 431 bytes
 ...ip-stroke-unbounded.xlib-fallback.rgb24.ref.png |  Bin 1429 -> 1437 bytes
 test/clip-stroke-unbounded.xlib.argb32.ref.png     |  Bin 1792 -> 1785 bytes
 test/clip-stroke-unbounded.xlib.rgb24.ref.png      |  Bin 1426 -> 1442 bytes
 test/clip-stroke.xlib-fallback.ref.png             |  Bin 1490 -> 1491 bytes
 test/clip-stroke.xlib.ref.png                      |  Bin 1490 -> 1491 bytes
 test/clipped-group.xlib.ref.png                    |  Bin 0 -> 289 bytes
 test/coverage-rectangles.xlib.xfail.png            |  Bin 0 -> 15981 bytes
 test/finer-grained-fallbacks.xlib-fallback.ref.png |  Bin 0 -> 919 bytes
 test/finer-grained-fallbacks.xlib.ref.png          |  Bin 1111 -> 1110 bytes
 test/finer-grained-fallbacks.xlib.rgb24.ref.png    |  Bin 1114 -> 856 bytes
 test/ft-text-vertical-layout-type1.xlib.ref.png    |  Bin 3639 -> 3625 bytes
 test/ft-text-vertical-layout-type3.xlib.ref.png    |  Bin 3605 -> 3597 bytes
 test/leaky-dashed-rectangle.xlib.ref.png           |  Bin 347 -> 344 bytes
 test/linear-gradient-subset.xlib.ref.png           |  Bin 0 -> 782 bytes
 test/pthread-show-text.xlib-fallback.ref.png       |  Bin 0 -> 42073 bytes
 ...m-intersections-curves-nz.xlib-fallback.ref.png |  Bin 264288 -> 264277 bytes
 test/random-intersections-curves-nz.xlib.ref.png   |  Bin 264288 -> 264277 bytes
 test/recording-surface-pattern.xlib.argb32.ref.png |  Bin 0 -> 3055 bytes
 test/recording-surface-pattern.xlib.rgb24.ref.png  |  Bin 0 -> 3124 bytes
 test/scale-offset-image.xlib-fallback.xfail.png    |  Bin 8706 -> 8686 bytes
 test/scale-offset-image.xlib.ref.png               |  Bin 0 -> 9136 bytes
 test/scale-offset-image.xlib.xfail.png             |  Bin 9132 -> 0 bytes
 test/scale-offset-similar.xlib-fallback.xfail.png  |  Bin 8706 -> 8686 bytes
 test/scale-offset-similar.xlib.xfail.png           |  Bin 8696 -> 8698 bytes
 test/self-intersecting.xlib.ref.png                |  Bin 252 -> 208 bytes
 test/smask-text.xlib-fallback.ref.png              |  Bin 0 -> 1874 bytes
 test/smask.xlib-fallback.ref.png                   |  Bin 0 -> 3423 bytes
 test/subsurface.xlib.ref.png                       |  Bin 0 -> 1782 bytes
 test/text-rotate.xlib-fallback.ref.png             |  Bin 0 -> 16592 bytes
 35 files changed, 19 insertions(+), 7 deletions(-)

commit a049889c64131b170b66ed8906309f6adee80fa5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 21:26:26 2010 +0100

    pattern: Remove incorrect optimisations from _cairo_pattern_aquire_surface()
    
    Safe reduction of patterns is performed in gstate, so not only are the
    extra checks in _cairo_pattern_acquire_surface redundant there are also
    unsafe. Simply remove them.
    
    Fixes test/radial-gradient-extend [xlib-fallback]

 src/cairo-pattern.c |  110 ++++++++-------------------------------------------
 1 file changed, 17 insertions(+), 93 deletions(-)

commit 00bc1d1578dc2640db64315270b00073697fb9fa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 20:31:29 2010 +0100

    pattern: Remove extraordinary _cairo_pattern_fini_snapshot().
    
    Miraculously the circular references from self-copy have disappeared and
    the forced finish within _cairo_pattern_fini_snapshot() now quite
    explosive. By replacing them with an ordinary _cairo_pattern_fini() the
    crash from test/smask-image-mask disappear along and valgrind remains
    happy.
    
    Fixes test/smask-image-mask and similar.

 src/cairo-pattern.c           |   17 -----------------
 src/cairo-recording-surface.c |   24 ++++++++++++------------
 src/cairoint.h                |    3 ---
 3 files changed, 12 insertions(+), 32 deletions(-)

commit 1098e203dc21529f138bfabfa7558f61b8427ea0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 18:07:28 2010 +0100

    test: pdf ref image refresh

 test/Makefile.am                                     |   11 +++++++++++
 test/clear-source.pdf.xfail.png                      |  Bin 0 -> 974 bytes
 test/clip-fill-unbounded.pdf.argb32.ref.png          |  Bin 0 -> 1244 bytes
 test/clip-stroke-unbounded.pdf.argb32.xfail.png      |  Bin 0 -> 1351 bytes
 test/clip-unbounded.pdf.argb32.xfail.png             |  Bin 0 -> 95 bytes
 test/clip-unbounded.pdf.rgb24.xfail.png              |  Bin 0 -> 95 bytes
 test/filter-nearest-offset.pdf.xfail.png             |  Bin 2152 -> 4522 bytes
 test/filter-nearest-transformed.pdf.xfail.png        |  Bin 532 -> 532 bytes
 test/pthread-show-text.pdf.ref.png                   |  Bin 0 -> 47015 bytes
 test/radial-gradient-source.pdf.argb32.ref.png       |  Bin 0 -> 235290 bytes
 test/rotate-image-surface-paint.pdf.xfail.png        |  Bin 358 -> 442 bytes
 test/scale-source-surface-paint.pdf.argb32.xfail.png |  Bin 0 -> 157 bytes
 test/scale-source-surface-paint.pdf.rgb24.xfail.png  |  Bin 0 -> 152 bytes
 test/surface-pattern-operator.pdf.argb32.xfail.png   |  Bin 0 -> 5485 bytes
 test/surface-pattern-operator.pdf.rgb24.xfail.png    |  Bin 0 -> 2095 bytes
 15 files changed, 11 insertions(+)

commit 1c91d019c54afde0edb022312491b086588ce6c4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 17:47:08 2010 +0100

    test: ps ref image refresh.
    
    Update to gs-8.71 and some additional reference images for the new tests.

 test/Makefile.am                                   |  116 +++++++++++---------
 test/README                                        |    2 +-
 test/big-line.ps.ref.png                           |  Bin 0 -> 946 bytes
 test/bug-bo-rectangular.ps.xfail.png               |  Bin 0 -> 945 bytes
 test/caps-joins-curve.ps.ref.png                   |  Bin 3728 -> 3715 bytes
 test/caps-joins.ps.ref.png                         |  Bin 2282 -> 2268 bytes
 test/caps-sub-paths.ps.ref.png                     |  Bin 0 -> 163 bytes
 test/caps.ps.ref.png                               |  Bin 1466 -> 1478 bytes
 test/clear-source.ps.xfail.png                     |  Bin 0 -> 552 bytes
 test/clip-disjoint.ps.ref.png                      |  Bin 0 -> 4680 bytes
 test/clip-fill-rule.ps.argb32.ref.png              |  Bin 0 -> 251 bytes
 test/clip-fill-rule.ps.rgb24.ref.png               |  Bin 0 -> 234 bytes
 test/clip-fill-rule.ps2.argb32.ref.png             |  Bin 310 -> 0 bytes
 test/clip-fill-rule.ps2.rgb24.ref.png              |  Bin 302 -> 0 bytes
 test/clip-fill-rule.ps3.argb32.ref.png             |  Bin 310 -> 0 bytes
 test/clip-fill-rule.ps3.rgb24.ref.png              |  Bin 302 -> 0 bytes
 test/clip-fill-unbounded.ps.argb32.xfail.png       |  Bin 0 -> 1244 bytes
 test/clip-image.ps.ref.png                         |  Bin 0 -> 2498 bytes
 test/clip-nesting.ps.argb32.ref.png                |  Bin 0 -> 441 bytes
 test/clip-nesting.ps.rgb24.ref.png                 |  Bin 0 -> 492 bytes
 test/clip-nesting.ps2.argb32.ref.png               |  Bin 651 -> 0 bytes
 test/clip-nesting.ps2.rgb24.ref.png                |  Bin 636 -> 0 bytes
 test/clip-nesting.ps3.argb32.ref.png               |  Bin 651 -> 0 bytes
 test/clip-nesting.ps3.rgb24.ref.png                |  Bin 636 -> 0 bytes
 test/clip-push-group.ps.ref.png                    |  Bin 0 -> 120 bytes
 test/clip-push-group.ps2.argb32.ref.png            |  Bin 179 -> 0 bytes
 test/clip-push-group.ps2.rgb24.ref.png             |  Bin 179 -> 0 bytes
 test/clip-push-group.ps3.argb32.ref.png            |  Bin 179 -> 0 bytes
 test/clip-push-group.ps3.rgb24.ref.png             |  Bin 179 -> 0 bytes
 test/clip-stroke-unbounded.ps.argb32.ref.png       |  Bin 0 -> 1351 bytes
 test/clip-stroke.ps.xfail.png                      |  Bin 0 -> 662 bytes
 test/clip-twice.ps.argb32.ref.png                  |  Bin 0 -> 492 bytes
 test/clip-twice.ps.rgb24.ref.png                   |  Bin 0 -> 409 bytes
 test/clip-twice.ps2.argb32.ref.png                 |  Bin 575 -> 0 bytes
 test/clip-twice.ps2.rgb24.ref.png                  |  Bin 541 -> 0 bytes
 test/clip-twice.ps3.argb32.ref.png                 |  Bin 575 -> 0 bytes
 test/clip-twice.ps3.rgb24.ref.png                  |  Bin 541 -> 0 bytes
 test/clipped-group.ps2.ref.png                     |  Bin 343 -> 214 bytes
 test/clipped-group.ps3.ref.png                     |  Bin 343 -> 214 bytes
 test/copy-path.ps.ref.png                          |  Bin 0 -> 379 bytes
 test/copy-path.ps2.ref.png                         |  Bin 474 -> 0 bytes
 test/copy-path.ps3.ref.png                         |  Bin 474 -> 0 bytes
 test/dash-caps-joins.ps.ref.png                    |  Bin 0 -> 3669 bytes
 test/dash-caps-joins.ps2.argb32.ref.png            |  Bin 3870 -> 0 bytes
 test/dash-caps-joins.ps2.rgb24.ref.png             |  Bin 3870 -> 0 bytes
 test/dash-caps-joins.ps3.argb32.ref.png            |  Bin 3870 -> 0 bytes
 test/dash-caps-joins.ps3.rgb24.ref.png             |  Bin 3870 -> 0 bytes
 test/dash-curve.ps2.ref.png                        |  Bin 27293 -> 24355 bytes
 test/dash-curve.ps3.ref.png                        |  Bin 27293 -> 24355 bytes
 test/dash-infinite-loop.ps.ref.png                 |  Bin 0 -> 617 bytes
 test/dash-scale.ps.ref.png                         |  Bin 0 -> 5965 bytes
 test/dash-scale.ps2.argb32.ref.png                 |  Bin 6318 -> 0 bytes
 test/dash-scale.ps2.rgb24.ref.png                  |  Bin 6316 -> 0 bytes
 test/dash-scale.ps3.argb32.ref.png                 |  Bin 6318 -> 0 bytes
 test/dash-scale.ps3.rgb24.ref.png                  |  Bin 6316 -> 0 bytes
 test/dash-state.ps2.ref.png                        |  Bin 10219 -> 8740 bytes
 test/dash-state.ps3.ref.png                        |  Bin 10219 -> 8740 bytes
 test/degenerate-arc.ps2.ref.png                    |  Bin 585 -> 509 bytes
 test/degenerate-arc.ps3.ref.png                    |  Bin 585 -> 509 bytes
 test/degenerate-curve-to.ps.xfail.png              |  Bin 202 -> 221 bytes
 test/degenerate-dash.ps.xfail.png                  |  Bin 1835 -> 1837 bytes
 test/degenerate-path.ps.argb32.xfail.png           |  Bin 236 -> 234 bytes
 test/degenerate-path.ps.rgb24.xfail.png            |  Bin 186 -> 184 bytes
 test/degenerate-pen.ps.ref.png                     |  Bin 0 -> 759 bytes
 test/degenerate-pen.ps2.ref.png                    |  Bin 865 -> 0 bytes
 test/degenerate-pen.ps3.ref.png                    |  Bin 865 -> 0 bytes
 test/degenerate-rel-curve-to.ps.ref.png            |  Bin 0 -> 225 bytes
 test/degenerate-rel-curve-to.ps.xfail.png          |  Bin 202 -> 0 bytes
 test/fill-and-stroke.ps.argb32.ref.png             |  Bin 0 -> 257 bytes
 test/fill-and-stroke.ps.rgb24.ref.png              |  Bin 0 -> 225 bytes
 test/fill-and-stroke.ps2.argb32.ref.png            |  Bin 310 -> 0 bytes
 test/fill-and-stroke.ps2.rgb24.ref.png             |  Bin 319 -> 0 bytes
 test/fill-and-stroke.ps3.argb32.ref.png            |  Bin 310 -> 0 bytes
 test/fill-and-stroke.ps3.rgb24.ref.png             |  Bin 319 -> 0 bytes
 .../fill-degenerate-sort-order.ps.argb32.xfail.png |  Bin 1901 -> 1903 bytes
 test/fill-degenerate-sort-order.ps.rgb24.xfail.png |  Bin 1645 -> 1638 bytes
 test/fill-image.ps.ref.png                         |  Bin 1799 -> 1645 bytes
 test/fill-rule.ps2.argb32.ref.png                  |  Bin 2253 -> 1878 bytes
 test/fill-rule.ps2.rgb24.ref.png                   |  Bin 2031 -> 1524 bytes
 test/fill-rule.ps3.argb32.ref.png                  |  Bin 2253 -> 1878 bytes
 test/fill-rule.ps3.rgb24.ref.png                   |  Bin 2031 -> 1524 bytes
 test/finer-grained-fallbacks.ps2.argb32.ref.png    |  Bin 1173 -> 1168 bytes
 test/finer-grained-fallbacks.ps2.rgb24.ref.png     |  Bin 1154 -> 936 bytes
 test/finer-grained-fallbacks.ps3.argb32.ref.png    |  Bin 1173 -> 1168 bytes
 test/finer-grained-fallbacks.ps3.rgb24.ref.png     |  Bin 1154 -> 936 bytes
 test/ft-text-vertical-layout-type1.ps.ref.png      |  Bin 1634 -> 2088 bytes
 test/ft-text-vertical-layout-type3.ps.ref.png      |  Bin 1636 -> 2134 bytes
 test/group-unaligned.ps.ref.png                    |  Bin 332 -> 321 bytes
 test/group-unaligned.ps.rgb24.xfail.png            |  Bin 0 -> 371 bytes
 test/implicit-close.ps.ref.png                     |  Bin 0 -> 252 bytes
 test/joins.ps.ref.png                              |  Bin 5496 -> 4230 bytes
 test/leaky-dashed-rectangle.ps.ref.png             |  Bin 444 -> 358 bytes
 test/leaky-dashed-stroke.ps.ref.png                |  Bin 0 -> 5293 bytes
 test/leaky-dashed-stroke.ps2.ref.png               |  Bin 5511 -> 0 bytes
 test/leaky-dashed-stroke.ps3.ref.png               |  Bin 5511 -> 0 bytes
 test/leaky-polygon.ps.ref.png                      |  Bin 0 -> 289 bytes
 test/leaky-polygon.ps2.ref.png                     |  Bin 354 -> 0 bytes
 test/leaky-polygon.ps3.ref.png                     |  Bin 354 -> 0 bytes
 test/line-width-scale.ps2.ref.png                  |  Bin 3911 -> 3431 bytes
 test/line-width-scale.ps3.ref.png                  |  Bin 3911 -> 3431 bytes
 test/linear-gradient-subset.ps3.ref.png            |  Bin 0 -> 619 bytes
 test/long-dashed-lines.ps2.ref.png                 |  Bin 1516 -> 1329 bytes
 test/long-dashed-lines.ps3.ref.png                 |  Bin 1516 -> 1329 bytes
 test/new-sub-path.ps2.argb32.ref.png               |  Bin 556 -> 398 bytes
 test/new-sub-path.ps3.argb32.ref.png               |  Bin 556 -> 398 bytes
 test/operator-alpha-alpha.ps.xfail.png             |  Bin 1338 -> 3429 bytes
 test/over-around-source.ps2.argb32.ref.png         |  Bin 522 -> 508 bytes
 test/over-around-source.ps3.argb32.ref.png         |  Bin 522 -> 508 bytes
 test/over-below-source.ps2.argb32.ref.png          |  Bin 503 -> 368 bytes
 test/over-below-source.ps2.rgb24.ref.png           |  Bin 0 -> 362 bytes
 test/over-below-source.ps3.argb32.ref.png          |  Bin 503 -> 368 bytes
 test/over-below-source.ps3.rgb24.ref.png           |  Bin 0 -> 362 bytes
 test/path-append.ps.ref.png                        |  Bin 4516 -> 4525 bytes
 test/pixman-rotate.ps.argb32.ref.png               |  Bin 0 -> 355 bytes
 test/push-group-color.ps3.ref.png                  |  Bin 0 -> 2561 bytes
 test/random-intersections-curves-eo.ps.ref.png     |  Bin 151676 -> 151668 bytes
 test/random-intersections-curves-nz.ps.ref.png     |  Bin 134732 -> 134746 bytes
 test/random-intersections-eo.ps.ref.png            |  Bin 78806 -> 78037 bytes
 test/random-intersections-nonzero.ps.ref.png       |  Bin 77299 -> 76450 bytes
 test/recording-surface-pattern.ps.argb32.ref.png   |  Bin 0 -> 3064 bytes
 test/recording-surface-pattern.ps.rgb24.ref.png    |  Bin 0 -> 3147 bytes
 test/recording-surface-pattern.ps2.argb32.ref.png  |  Bin 3257 -> 0 bytes
 test/recording-surface-pattern.ps2.rgb24.ref.png   |  Bin 3873 -> 0 bytes
 test/recording-surface-pattern.ps3.argb32.ref.png  |  Bin 3257 -> 0 bytes
 test/recording-surface-pattern.ps3.rgb24.ref.png   |  Bin 3873 -> 0 bytes
 test/reflected-stroke.ps.ref.png                   |  Bin 0 -> 3368 bytes
 test/reflected-stroke.ps2.ref.png                  |  Bin 3898 -> 0 bytes
 test/reflected-stroke.ps3.ref.png                  |  Bin 3898 -> 0 bytes
 test/rounded-rectangle-fill.ps.ref.png             |  Bin 0 -> 551 bytes
 test/rounded-rectangle-stroke.ps.ref.png           |  Bin 0 -> 568 bytes
 test/scale-offset-image.ps.ref.png                 |  Bin 7289 -> 7697 bytes
 test/spline-decomposition.ps.ref.png               |  Bin 9028 -> 8939 bytes
 test/stroke-image.ps.ref.png                       |  Bin 1641 -> 1682 bytes
 test/subsurface.ps.ref.png                         |  Bin 0 -> 1651 bytes
 test/surface-pattern-big-scale-down.ps.ref.png     |  Bin 0 -> 235 bytes
 test/surface-pattern-big-scale-down.ps.xfail.png   |  Bin 238 -> 0 bytes
 test/text-glyph-range.ps.ref.png                   |  Bin 0 -> 1253 bytes
 test/text-glyph-range.ps2.ref.png                  |  Bin 1389 -> 0 bytes
 test/text-glyph-range.ps3.ref.png                  |  Bin 1389 -> 0 bytes
 test/text-rotate.ps.ref.png                        |  Bin 0 -> 8765 bytes
 test/text-rotate.ps2.ref.png                       |  Bin 6851 -> 0 bytes
 test/text-rotate.ps3.ref.png                       |  Bin 6851 -> 0 bytes
 test/text-transform.ps.ref.png                     |  Bin 0 -> 3430 bytes
 test/text-transform.ps2.ref.png                    |  Bin 4154 -> 0 bytes
 test/text-transform.ps3.ref.png                    |  Bin 4154 -> 0 bytes
 test/trap-clip.ps2.argb32.ref.png                  |  Bin 4849 -> 4839 bytes
 test/trap-clip.ps2.rgb24.ref.png                   |  Bin 5617 -> 4729 bytes
 test/trap-clip.ps3.argb32.ref.png                  |  Bin 5591 -> 4751 bytes
 test/trap-clip.ps3.rgb24.ref.png                   |  Bin 5512 -> 4553 bytes
 test/twin.ps.ref.png                               |  Bin 2142 -> 2136 bytes
 test/user-font-proxy.ps.ref.png                    |  Bin 7766 -> 7837 bytes
 test/user-font-rescale.ps.ref.png                  |  Bin 0 -> 6781 bytes
 test/user-font-rescale.ps2.ref.png                 |  Bin 8041 -> 0 bytes
 test/user-font-rescale.ps3.ref.png                 |  Bin 8041 -> 0 bytes
 test/xlib-expose-event.ps.ref.png                  |  Bin 0 -> 39035 bytes
 155 files changed, 65 insertions(+), 53 deletions(-)

commit 1a544361e845e4881990624a597f9dc2b82d1c73
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 16:04:41 2010 +0100

    gstate: Update cached matrix state after device transform changes on the target
    
    Commit 8d67186cb291cb877e52b987e2ac18c2a1175a57 caches whether the device
    transform is identity on context creation. However, the api is quite lax
    and allows the user to modify the device transform *after* he has
    started to use the surface in a context, as apparently WebKit does.
    Since this is not the only instance where we may need to invalidate
    caches if the user modifies state, introduce a simple mechanism for
    hooking into notifications of property changes.
    
    Fixes test/clip-device-offset.

 src/Makefile.sources        |    1 +
 src/cairo-gstate-private.h  |    3 +++
 src/cairo-gstate.c          |   28 ++++++++++++++++++++----
 src/cairo-observer.c        |   50 +++++++++++++++++++++++++++++++++++++++++++
 src/cairo-surface-private.h |    1 +
 src/cairo-surface.c         |    6 ++++++
 src/cairo-types-private.h   |    6 ++++++
 src/cairoint.h              |    5 +++++
 8 files changed, 96 insertions(+), 4 deletions(-)

commit f74b11415a1f7682dd50c222baa8815ef93681dc
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 14:06:15 2010 +0100

    test: Use a group to render PDF correctly using poppler.
    
    In order to support blend modes, we need to use a clear background
    whilst rendering the PDF, which inspired the use of DEST_OVER to avoid
    having to render to an intermediate surface. However, the adjunct of
    using subpixel text means that we cannot simply using the alpha channel
    as the sole mask and so need to render to an intermediate and paint it
    over an opaque background.

 test/any2ppm.c |    9 ++++++---
 test/pdf2png.c |    9 ++++++---
 2 files changed, 12 insertions(+), 6 deletions(-)

commit 7f227ec8d3f981dbbf2ca1914bf7fd29d9cdfd05
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 12:54:15 2010 +0100

    Revert "test/pdf2png: Don't use DEST_OVER as poppler starts using subpixel text."
    
    This reverts commit 506b2ebe714d61a64972b607a42a55e48d1c722a.
    
    We have conflicting requirements here. In order to support extended
    blend modes correctly we need to use DEST_OVER, at the expense of
    supporting subpixel text. More thought required.

 test/any2ppm.c |    9 +++++----
 test/pdf2png.c |   10 +++++-----
 2 files changed, 10 insertions(+), 9 deletions(-)

commit c761e0c5bb55e8869521ad5b4a2447ea9abcb4d1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 12:40:36 2010 +0100

    test: Restrict the coverage tests to raster targets.
    
    Typo inside the requirements failed to prevent the tests running on the
    vector backends.

 test/coverage.c         |    4 ++--
 test/half-coverage.c    |    4 ++--
 test/partial-coverage.c |   18 +++++++++---------
 3 files changed, 13 insertions(+), 13 deletions(-)

commit b49c944fe4abb9f3c70fac02a71061bf8d07259a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 12:38:17 2010 +0100

    test: Add a convenience script to disable the screensaver when testing
    
    If the screensaver activates, it can cause failures when attempting to
    render into an xlib window, so inhibit if we know how.

 test/Makefile.am             |    2 +-
 test/run-cairo-test-suite.sh |   18 ++++++++++++++++++
 2 files changed, 19 insertions(+), 1 deletion(-)

commit 4e4724d48c63d0cd4ec507ce72dcc55fb6e5f584
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 12:19:56 2010 +0100

    gl: make check insists "cairoint.h" is first.

 src/cairo-gl-gradient.c |    5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 4edbcf1b1d046c9c626a0c0ad10d3c71f17984f2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 12:17:19 2010 +0100

    color: Mark _cairo_color_get_content() as private.

 src/cairoint.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 506b2ebe714d61a64972b607a42a55e48d1c722a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 12:04:39 2010 +0100

    test/pdf2png: Don't use DEST_OVER as poppler starts using subpixel text.
    
    Using DEST_OVER in this form to paint the background white fails in the
    presence of subpixel geometry (particular text), so remove the hack and
    simply paint the background white prior to passing the surface to
    poppler. KISS.

 test/any2ppm.c |    9 ++++-----
 test/pdf2png.c |   10 +++++-----
 2 files changed, 9 insertions(+), 10 deletions(-)

commit edb73b6dcf1adce40d6c10c492e3f78556e22b85
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 11:16:42 2010 +0100

    xlib: Adjust trapezoid precision based on antialias.
    
    Render supports two modes of precision when rendering trapezoids.
    Precise specifies points sampling on a 15x17 grid, ala pixman. Imprecise
    allows the driver more freedom in the methods used, which may be more
    amenable to acceleration. Choose to use the imprecise mode by default,
    but still allow users to force the more rigidly specified precision by
    changing the antialias mode.

 src/cairo-xlib-surface-private.h |    1 +
 src/cairo-xlib-surface.c         |   31 +++++++++++++++++++++++++++++++
 2 files changed, 32 insertions(+)

commit 290749bdb5c634c030db81722214661c34344403
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 10:59:17 2010 +0100

    polygon: Reorder conditionals based on likelihood.
    
    The vast majority of edges will be unclipped, so process those first.

 src/cairo-polygon.c |   30 +++++++++++++++---------------
 1 file changed, 15 insertions(+), 15 deletions(-)

commit 55037bfb2454a671332d961e061c712ab5471580
Author: Karl Tomlinson <karlt+@karlt.net>
Date:   Fri Jun 11 10:35:43 2010 +0100

    xlib: Find matching Visual for XRenderFormat
    
    Not only is this useful for users to know which Visual matches any
    particular Cairo surface, it should also close a few obscure bugs of not
    converting images correctly on upload.
    
    Fixes:
    
      Bug 28492 - cairo_xlib_surface_create_with_xrender_format does not
                  create visual for resulting surface
      https://bugs.freedesktop.org/show_bug.cgi?id=28492
    
      Mozilla Bug 567065 - Try to create offscreen Xlib surface from existing
                           visual if possible
      https://bugzilla.mozilla.org/show_bug.cgi?id=567065
    
      Mozilla Bug 445250 - cairo_draw_with_xlib should provide a non-NULL visual
                           to callback
      https://bugzilla.mozilla.org/show_bug.cgi?id=445250
    
    Reported-by: Oleg Romashin <romaxa@gmail.com>

 src/cairo-xlib-surface.c |   74 ++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 65 insertions(+), 9 deletions(-)

commit cf426bce8ebd3aff5d50c6a54bbd731132b3d312
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 10:05:09 2010 +0100

    test: Add a simple coverage test.
    
    This test case should be much clearer than half-coverage over what it
    purports to actually test. In each pixel, it draws a single geometric
    primitive that coverages a known percentage of the pixel and then we
    measure how close the rasterisers are to that ideal.

 test/Makefile.am                 |    2 +
 test/Makefile.sources            |    1 +
 test/coverage-rectangles.ref.png |  Bin 0 -> 259 bytes
 test/coverage-triangles.ref.png  |  Bin 0 -> 253 bytes
 test/coverage.c                  |  135 ++++++++++++++++++++++++++++++++++++++
 5 files changed, 138 insertions(+)

commit bd3d9ef3d1dbc5364e79e6afb47d9e124cb61ca4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 09:12:16 2010 +0100

    test: Distinguish tests that throw an error from a normal fail.
    
    Hitting an error in a test case is almost as bad as crashing, and the
    severity may be lost amidst "normal" failures. So introduce a new class
    of ERROR so that we can immediately spot these during a test run, and
    appropriately log them afterwards.

 test/cairo-test-runner.c |   89 ++++++++++++++++++++++++++++++++++++++++++++--
 test/cairo-test.c        |   20 ++++++++++-
 test/cairo-test.h        |    1 +
 3 files changed, 107 insertions(+), 3 deletions(-)

commit eeafeebd2ec8ad8a9e7053aaaa0f845b58563b3b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jun 11 09:06:20 2010 +0100

    path: Exponentially grow buffer based on populated points and ops.
    
    Instead of simply doubling the buffer size every time we overflow a point
    or an op, enlarge the buffer to fit twice the number of used points and
    ops.  We expect paths to be fairly consistent in the mix of operations,
    and this allows the buffer size to tune itself to actual usage and reduce
    wastage.

 src/cairo-path-fixed-private.h |    3 ++-
 src/cairo-path-fixed.c         |   39 +++++++++++++++++++--------------------
 2 files changed, 21 insertions(+), 21 deletions(-)

commit b0056a86b4f6c92fa7eb89baf8483a46979c8cf1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 10 18:27:22 2010 +0100

    test: Exercise partial coverage some more.
    
    Add some overlapping triangles (coarse enough for them to be resolved
    using Cairo's 24.8 fixed point without loss of precision) to exercise
    handling of overlapping subpixel geometry.

 test/Makefile.am                                   |    4 +
 ...tial-coverage-overlap-half-triangles-eo.ref.png |  Bin 0 -> 189 bytes
 ...partial-coverage-overlap-half-triangles.ref.png |  Bin 0 -> 189 bytes
 ...overage-overlap-three-quarter-triangles.ref.png |  Bin 0 -> 186 bytes
 ...artial-coverage-three-quarter-reference.ref.png |  Bin 0 -> 186 bytes
 test/partial-coverage.c                            |  284 ++++++++++++++++++--
 6 files changed, 269 insertions(+), 19 deletions(-)

commit 836f6166597eaa687b10e5f26fe71e099c434aa1
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Jun 9 19:09:22 2010 +0200

    gl: support single stop gradients

 src/cairo-gl-gradient-private.h |    2 +-
 src/cairo-gl-gradient.c         |    3 +--
 2 files changed, 2 insertions(+), 3 deletions(-)

commit d17e2c5e23eac302b7463a08205088147da1172a
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 10 10:52:16 2010 +0200

    ps: support single stop gradients

 src/cairo-ps-surface.c |    9 ++++-----
 1 file changed, 4 insertions(+), 5 deletions(-)

commit eb7fc351156bd66921ac3b3ffbd1fba6ba743ffb
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu Jun 10 10:51:50 2010 +0200

    pdf: support single stop gradients

 src/cairo-pdf-surface.c |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e2660a0eac5f6081bf052db16b8bd85c814d19d8
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Jun 9 16:59:29 2010 +0200

    pattern: improve single stop gradients handling
    
    None-extended single stop gradients are now explicitly made clear.

 src/cairo-pattern.c |    9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit 7a024bc206aae790c7357be83474126037335ab1
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Jun 9 17:59:47 2010 +0200

    test: exercise ps crash with single stop gradients
    
    PS crashes only when using the source operator, as it will otherwise
    fallback to rasterization of the gradients.

 test/linear-gradient-one-stop.argb32.ref.png |  Bin 0 -> 225 bytes
 test/linear-gradient-one-stop.c              |    2 +-
 test/linear-gradient-one-stop.ref.png        |  Bin 344 -> 0 bytes
 test/linear-gradient-one-stop.rgb24.ref.png  |  Bin 0 -> 174 bytes
 test/radial-gradient-one-stop.argb32.ref.png |  Bin 0 -> 1392 bytes
 test/radial-gradient-one-stop.c              |    2 +-
 test/radial-gradient-one-stop.ref.png        |  Bin 1422 -> 0 bytes
 test/radial-gradient-one-stop.rgb24.ref.png  |  Bin 0 -> 1153 bytes
 8 files changed, 2 insertions(+), 2 deletions(-)

commit a0f8cfe64660c0043db15f9b9cbf1298bf1838d1
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 8 17:04:00 2010 +0200

    pattern: improve degenerate gradients handling
    
    Degenerate radial gradients are now considered clear.

 src/cairo-pattern.c |   35 +++++++++++++++++++++++++----------
 1 file changed, 25 insertions(+), 10 deletions(-)

commit bccd89b4177b5f5bd05def9bee5f0927a9f25e4a
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 8 15:45:09 2010 +0200

    gstate: correct optimizations
    
    Gradient were previously hand-optimized (without properly checking
    for extend modes). By properly using _cairo_pattern functions we
    avoid code duplication and bugs.
    
    Fixes linear-gradient-extend, radial-gradient-extend.

 src/cairo-gstate.c |   85 +++++++++++-----------------------------------------
 1 file changed, 17 insertions(+), 68 deletions(-)

commit 06c6207ad4205f211be70e324c6d32ea7d28dca8
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 1 19:40:14 2010 +0200

    pattern: add gradient_is_solid function
    
    It contains in a single place the logic needed to check if a gradient
    pattern is solid (within a specified region).

 src/cairo-pattern.c |   53 +++++++++++++++++++++++++++++++++++++++++++++++++++
 src/cairoint.h      |    5 +++++
 2 files changed, 58 insertions(+)

commit 561625ee3bd2732457eaaf28937edf557ee7661d
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 1 19:39:02 2010 +0200

    pattern: improve clear/opaque check functions
    
    _cairo_pattern_is_opaque was missing some checks about the extend type.
    Conversely _cairo_pattern_is_clear was being too strict about gradients.

 src/cairo-pattern.c |  112 +++++++++++++++++++++++++++++++++++++++++++++++----
 src/cairoint.h      |    4 ++
 2 files changed, 108 insertions(+), 8 deletions(-)

commit baaf312e047a9bea6f54e63cd6534c2ed7448523
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Apr 19 09:53:00 2010 +0200

    pattern: remove content field from solid patterns
    
    The content field in solid patterns had ill-defined semantic (or no
    semantic at all), thus it can be removed.

 src/cairo-color.c          |   16 ++++++++++++++++
 src/cairo-gl-surface.c     |    2 +-
 src/cairo-gstate.c         |   14 +++++---------
 src/cairo-pattern.c        |   37 ++++++++++---------------------------
 src/cairo-script-surface.c |    9 +++------
 src/cairo-surface.c        |    4 ++--
 src/cairo-types-private.h  |    1 -
 src/cairo-xlib-surface.c   |    6 +++---
 src/cairo.c                |    4 ++--
 src/cairoint.h             |    9 +++++----
 10 files changed, 47 insertions(+), 55 deletions(-)

commit 7461947eb1a5f002a5931303843a5a2deca0e383
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Apr 19 09:51:26 2010 +0200

    surface: remove content argument from is_similar
    
    The content argument was basically unuses.
    
    Xlib change extracted from ickle's wip/compositor branch.

 src/cairo-directfb-surface.c |    2 +-
 src/cairo-pattern.c          |    5 ++---
 src/cairo-surface.c          |    5 ++---
 src/cairo-win32-surface.c    |    3 +--
 src/cairo-xlib-surface.c     |   30 ++----------------------------
 src/cairoint.h               |    6 ++----
 6 files changed, 10 insertions(+), 41 deletions(-)

commit ef5f9b5c61750207947587173d21b46e2d299f33
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 10 14:13:53 2010 +0100

    test: Update partial coverage.
    
    Gah, no wonder the output looked wrong for the triangles, they only
    covered half the pixel. So separate triangles into two cases.

 test/Makefile.am                             |    2 +
 test/partial-coverage-half-reference.ref.png |  Bin 0 -> 189 bytes
 test/partial-coverage-half-triangles.ref.png |  Bin 0 -> 189 bytes
 test/partial-coverage.c                      |   98 ++++++++++++++++++++++++--
 4 files changed, 96 insertions(+), 4 deletions(-)

commit 8d67186cb291cb877e52b987e2ac18c2a1175a57
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 10 11:36:58 2010 +0100

    gstate: Track whether the combination of ctm * device is identity.
    
    In the fairly common condition that both the ctm and the device
    transforms are identity, the function overhead of calling the matrix
    multiplication on the point overwhelmingly dominates.

 src/cairo-clip.c           |    1 +
 src/cairo-gstate-private.h |  310 ++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-gstate.c         |   18 ++-
 src/cairoint.h             |  295 -----------------------------------------
 4 files changed, 327 insertions(+), 297 deletions(-)

commit 1349728d1ef63ed562a3fd0ee3c0a89aaba77616
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 10 11:26:12 2010 +0100

    test: Add partial coverage.
    
    Another experiment in measuring consistency of rasterisation stratagems
    across the backends.

 test/Makefile.am                         |    3 +
 test/Makefile.sources                    |    1 +
 test/partial-coverage-rectangles.ref.png |  Bin 0 -> 202 bytes
 test/partial-coverage-reference.ref.png  |  Bin 0 -> 202 bytes
 test/partial-coverage-triangles.ref.png  |  Bin 0 -> 202 bytes
 test/partial-coverage.c                  |  213 ++++++++++++++++++++++++++++++
 6 files changed, 217 insertions(+)

commit 486118361ad0c2e68fa9f6b44ddb10e84d237eca
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jun 10 11:28:26 2010 +0100

    test: Fix half-coverage colouration.
    
    Hmm, red over red makes the test pointless. The test still remains of
    highly dubious quality, as it primarily serves as a rendercheck more
    than a test of Cairo. The best hope for this test is that it inspires a
    better one.
    
    And incorporate the notes made by Joonas.

 test/half-coverage.c |   28 +++++++++++++++++++++++++++-
 1 file changed, 27 insertions(+), 1 deletion(-)

commit 5cb764850f7c405085739647bac2809045e7cdf3
Author: Dmitri Vorobiev <dmitri.vorobiev@movial.com>
Date:   Wed Jun 9 19:20:27 2010 +0300

    scaled-font: optimize cairo_scaled_font_text_to_glyphs()
    
    This patch serves two purposes. First, it factors out the heavy part
    of the cairo_scaled_font_text_to_glyphs() routine thus allowing GCC
    to better optimize the cache cleanup loop. Keeping the look-up table
    indices in a separate array speeds up array initialization even further.
    
    Second, this patch introduces a shortcut for the case when the string
    to be rendered consists of a single character. In this case, caching is
    not necessary at all.
    
    We have a benchmark that uses Cairo to render a large amount of random
    strings of consisting of printable ASCII characters. Below are Oprofile
    results collected while running this benchmark. It is easy to see that
    the heavy part becomes noticeably lighter.
    
    Before:
    
    Profiling through timer interrupt
    samples  %        app name                 symbol name
    198755   13.5580  libcairo.so.2.10907.0    cairo_scaled_font_text_to_glyphs
    88580     6.0424  libcairo.so.2.10907.0    _cairo_scaled_glyph_lookup
    81127     5.5340  libcairo.so.2.10907.0    _cairo_hash_table_lookup
    68186     4.6513  libcairo.so.2.10907.0    cairo_scaled_font_glyph_extents
    47145     3.2160  libcairo.so.2.10907.0    _composite_glyphs_via_mask
    46327     3.1602  libcairo.so.2.10907.0    _cairo_scaled_font_glyph_device_extents
    44817     3.0572  libcairo.so.2.10907.0    _composite_glyphs
    40431     2.7580  libcairo.so.2.10907.0    .plt
    
    After (note that cairo_scaled_font_text_to_glyphs_internal_single() was inlined):
    
    Profiling through timer interrupt
    samples  %        app name                 symbol name
    107264    7.6406  libcairo.so.2.10907.0    cairo_scaled_font_text_to_glyphs_internal_multiple
    87888     6.2604  libcairo.so.2.10907.0    _cairo_scaled_glyph_lookup
    79011     5.6281  libcairo.so.2.10907.0    _cairo_hash_table_lookup
    71723     5.1090  libcairo.so.2.10907.0    cairo_scaled_font_glyph_extents
    48084     3.4251  libcairo.so.2.10907.0    _composite_glyphs_via_mask
    46636     3.3220  libcairo.so.2.10907.0    _cairo_scaled_font_glyph_device_extents
    44740     3.1869  libcairo.so.2.10907.0    _composite_glyphs
    42472     3.0254  libc-2.8.so              _int_malloc
    39194     2.7919  libcairo.so.2.10907.0    _cairo_gstate_transform_glyphs_to_backend
    38614     2.7506  libcairo.so.2.10907.0    .plt
    37063     2.6401  libcairo.so.2.10907.0    _cairo_ft_ucs4_to_index
    36856     2.6253  libc-2.8.so              random
    36376     2.5911  libcairo.so.2.10907.0    _cairo_scaled_glyphs_equal
    34545     2.4607  libcairo.so.2.10907.0    cairo_matrix_transform_point
    31690     2.2573  libc-2.8.so              malloc
    29395     2.0939  libcairo.so.2.10907.0    _cairo_matrix_is_identity
    26142     1.8621  libcairo.so.2.10907.0    _cairo_utf8_to_ucs4
    24406     1.7385  libc-2.8.so              free
    24059     1.7138  libcairo.so.2.10907.0    cairo_scaled_font_text_to_glyphs
    
    [ickle: slightly amended for stylistic consistency.]

 src/cairo-scaled-font.c |  168 ++++++++++++++++++++++++++++++++---------------
 1 file changed, 114 insertions(+), 54 deletions(-)

commit c43399fa68696aa62599fb71752850dd46c15c82
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Wed Jun 9 17:53:09 2010 +0200

    gl: fix compilation on MacOS X
    
    MacOS X uses different defines to avoid multiple inclusion of GL
    header files. Adding them to glew.h fixes the compilation when GL is
    enabled.

 src/glew/GL/glew.h |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 6eb5f859f1d38783dc43541e7e87b0c5f91691d8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 9 10:40:32 2010 +0100

    bo: And disable DEBUG_TRAPS again.
    
    Meh. I'm going back to bed. Thanks Joonas for catching this.

 src/cairo-bentley-ottmann.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 85af0ec37456b4eb47c39326b24370a9ccc43092
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 9 10:33:29 2010 +0100

    test: Add half-coverage to exercise the rasteriser with subpixel geometry.

 test/Makefile.sources |    1 +
 test/half-coverage.c  |  129 +++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 130 insertions(+)

commit 56c081bdc6d29df932e6993109586ff275d8de12
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jun 9 10:33:01 2010 +0100

    bo: Fix debugging for changes in internal traps api.

 src/cairo-bentley-ottmann.c |   10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

commit a946d39555136adc4eff3b68a62ba37f6d9a6299
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 8 21:09:51 2010 +0200

    gl: Add support for clip regions to the span renderer
    
    Clip surface support is still missing, but i suppose that'd need a tiny
    bit more code...

 src/cairo-gl-surface.c |   16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit f61b3f25aff454800a9d6013012d41633139d896
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 8 12:03:36 2010 +0200

    gl: Add an assertion that we always have a texture
    
    When painting, the sources must be textures and not windows, and we did
    that wrong previously. This assertion makes sure that never happens
    again.

 src/cairo-gl-composite.c |    1 +
 1 file changed, 1 insertion(+)

commit c6c9a24a1df1826cab78bd8ef1c5a1074bafa0d7
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 8 04:11:33 2010 +0200

    gl: Use CAIRO_COLOR_BLACK
    
    ... instead of creating black on our own - and wrong, too.

 src/cairo-gl-surface.c |    8 +-------
 1 file changed, 1 insertion(+), 7 deletions(-)

commit 19bc6793d1d9b209d5a03a727288504b1e71f7c4
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 8 04:00:02 2010 +0200

    gl: Only clone texture surfaces
    
    Using non-texture surfaces as source or mask will fail, so we need to
    fallback.
    Caught by the subsurface-modify-child test.

 src/cairo-gl-surface.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 44483d843e4fe1f5db5cf213f76913d683265bb4
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 8 03:59:10 2010 +0200

    gl: Fix argument order
    
    oops...

 src/cairo-gl-surface.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 72bf1a536775138d79787729994ec9cfe2193be7
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue Jun 8 01:50:12 2010 +0200

    Update my copyright notices to preferred version
    
    No more copyright headers containing my name.

 test/clear-source.c          |   35 ++++++++++++++++++-----------------
 test/clip-fill-no-op.c       |   35 ++++++++++++++++++-----------------
 test/clip-stroke-no-op.c     |   35 ++++++++++++++++++-----------------
 test/pthread-same-source.c   |   35 ++++++++++++++++++-----------------
 test/pthread-similar.c       |   35 ++++++++++++++++++-----------------
 test/xcomposite-projection.c |   35 ++++++++++++++++++-----------------
 test/zero-mask.c             |   35 ++++++++++++++++++-----------------
 7 files changed, 126 insertions(+), 119 deletions(-)

commit 10d95c7020ca94903d474beb9c8ede89c186cbe3
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 8 20:48:25 2010 +0200

    test: add/update reference images
    
    Add missing reference images and update one-stop references according
    to current subset policy (outside the defined range, the gradient
    is clear).

 test/degenerate-linear-gradient.ref.png |  Bin 0 -> 232 bytes
 test/degenerate-radial-gradient.ref.png |  Bin 0 -> 428 bytes
 test/linear-gradient-one-stop.ref.png   |  Bin 468 -> 344 bytes
 test/radial-gradient-one-stop.ref.png   |  Bin 3772 -> 1422 bytes
 4 files changed, 0 insertions(+), 0 deletions(-)

commit dd0f8872711d9896416cca2027f578f7d58d228f
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Mon Jun 7 17:34:12 2010 +0200

    test: fix typo

 test/linear-gradient-extend.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9b88b5dce5327cbd13ea05de949c502fe41f91f7
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Tue Jun 8 10:45:06 2010 +0200

    test: add degenerate gradient and single stop tests
    
    Add tests for degeneratate linear gradients (with start point equal
    to the end point), degenerate radial gradients (start radius and end
    radius equal to zero, same start and end circle) and gradients (both
    linear and radial) with just a single stop.

 test/Makefile.sources                 |    6 +-
 test/degenerate-linear-gradient.c     |   81 +++++++++++++++++++++++++
 test/degenerate-radial-gradient.c     |   93 ++++++++++++++++++++++++++++
 test/linear-gradient-one-stop.c       |   90 +++++++++++++++++++++++++++
 test/linear-gradient-one-stop.ref.png |  Bin 0 -> 468 bytes
 test/radial-gradient-one-stop.c       |  107 +++++++++++++++++++++++++++++++++
 test/radial-gradient-one-stop.ref.png |  Bin 0 -> 3772 bytes
 7 files changed, 376 insertions(+), 1 deletion(-)

commit 7d8359721b581845260c0442a174e48b061484a7
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jun 7 16:46:46 2010 +0200

    gl: Fix span renderer doing bad stuff for CLEAR and SOURCE
    
    SOURCE will fallback now, CLEAR is identical to DEST_OUT with white.

 src/cairo-gl-surface.c |    7 +++++++
 1 file changed, 7 insertions(+)

commit ef8fd1355ea03b8566ef31642b32133d3543e4e8
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon Jun 7 15:03:37 2010 +0200

    gl: Fix span renderer for unbounded spans
    
    The span renderer used to not output rects for the top and bottom rows
    when they didn't contain any spans.

 src/cairo-gl-surface.c |   72 ++++++++++++++++++++++++++++++++----------------
 1 file changed, 49 insertions(+), 23 deletions(-)

commit 1d11af083f5368c88032a33ff40d0e21c139db18
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Jun 5 15:22:44 2010 +0200

    gl: Add a simple spans renderer for stroke/fill
    
    It's very simple as clipped polygons or ANTIALIAS_NONE still return
    UNSUPPORTED. Also, no optimizations are done, so even pixel-aligned
    rectangles use the full span rendering.
    
    Still, there are no performance regressions in the benchmark traces and
    firefox-talos-svg and swfdec-giant-steps both got ~15% faster.

 src/cairo-gl-surface.c |  178 +++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 175 insertions(+), 3 deletions(-)

commit 550335efeddf813c1bec493513254fdbd34a9ace
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Jun 5 15:19:44 2010 +0200

    Remove _cairo_surface_composite_trapezoids_as_polygon()
    
    The function computed the composite rectangles wrong and was only used
    in a gl fallback anyway. So instead of trying to fix it, just remove it
    and make sure gl doesn't fallback.

 src/cairo-gl-surface.c    |   14 ---------
 src/cairo-spans-private.h |   12 --------
 src/cairo-spans.c         |   75 ---------------------------------------------
 src/cairoint.h            |   12 --------
 4 files changed, 113 deletions(-)

commit 1e003fce8f7239aaf4608747d63287e0c715ee51
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat Jun 5 14:58:32 2010 +0200

    gl: Fix vertex size changes not causing updates of the operands
    
    Check vertex size stays identical when setting up vertices.

 src/cairo-gl-composite.c |   17 ++++++++++-------
 1 file changed, 10 insertions(+), 7 deletions(-)

commit 39143400ddd0d4e63a72ce91c423f764e466e405
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri Jun 4 12:25:52 2010 +0200

    gl: Add a gradient texture cache
    
    For firefox-planet-gnome, 19135 times a gradient gets rendered using
    only 10 different gradients. So we get a 100% hit rate in the cache.
    Unfortunately, texture upload is not the biggest problem of this test,
    as the performance increase is only moderate - at least on i965:
    34.3s => 33.5s

 src/cairo-gl-device.c           |   12 +++++++-
 src/cairo-gl-gradient-private.h |   18 ++++++++----
 src/cairo-gl-gradient.c         |   58 +++++++++++++++++++++++++++++++++++++--
 src/cairo-gl-private.h          |    2 ++
 4 files changed, 81 insertions(+), 9 deletions(-)

commit 932ab2641ea3183171c3b5699c96c4709fc6bd49
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jun 3 18:54:18 2010 +0200

    device: flush before setting finished
    
    Otherwise APIs critical for flushing - in particular acquiring the
    device - do not work.

 src/cairo-device.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 35e219d08f1c202399655db183ca0105a1c2166f
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jun 3 17:50:59 2010 +0200

    gl: Make gradient textures a separate object
    
    This is necessary so we can do proper refcounting and don't delete the
    gradient texture prematurely.

 src/Makefile.sources            |    4 +-
 src/cairo-gl-composite.c        |  156 +++------------------------
 src/cairo-gl-gradient-private.h |   80 ++++++++++++++
 src/cairo-gl-gradient.c         |  223 +++++++++++++++++++++++++++++++++++++++
 src/cairo-gl-private.h          |    9 +-
 5 files changed, 327 insertions(+), 145 deletions(-)

commit 9c17a477d29f633a4850ef8b458cbca82a19afc4
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jun 3 17:40:56 2010 +0200

    gl: Use the generic functions for filter/extend in gradients

 src/cairo-gl-composite.c |   26 ++++++++------------------
 src/cairo-gl-private.h   |    2 ++
 2 files changed, 10 insertions(+), 18 deletions(-)

commit df93802765afcf883abef5549bd5dff3465e2d79
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu Jun 3 17:38:28 2010 +0200

    gl: Create separate functions for setting extend and filter

 src/cairo-gl-composite.c |   47 +++++++++++++++++++++++++++-------------------
 1 file changed, 28 insertions(+), 19 deletions(-)

commit 10e71806d2e1929aa127642a397fa6ccef434b5b
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 20:04:57 2010 +0200

    gl: Switch to deferred rendering
    
    1) call _cairo_gl_composite_flush() or cairo_surface_flush() where
       needed
    2) Destroy texture operands when necessary
    3) get rid of _cairo_gl_composite_end()
    
    With this patch, vertices are not flushed immediately anymore, but only
    when needed or when a new set of vertices is emitted that requires an
    incompatible setup. This improves performance a lot in particular for
    text. (gnome-terminal-vim gets 10x faster)

 src/cairo-gl-composite.c |   40 ++++++++++++++++++++++------------------
 src/cairo-gl-glyphs.c    |    4 ----
 src/cairo-gl-private.h   |    4 ----
 src/cairo-gl-surface.c   |   12 ++++++------
 4 files changed, 28 insertions(+), 32 deletions(-)

commit f2f79ca1b3455000df4138ab500ae03b6584250c
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 19:57:47 2010 +0200

    gl: Make using shaders an explicit argument
    
    This is preparation for a followup patch

 src/cairo-gl-composite.c |   15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

commit 19c1d8316e22fc37c7cdaf6c3e56519c06d10561
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 18:14:28 2010 +0200

    gl: Special case blend mode for CAIRO_CONTENT_COLOR
    
    This ensures that alpha stays at 1 for RGB in all cases.

 src/cairo-gl-composite.c |    2 ++
 1 file changed, 2 insertions(+)

commit 1f249064cc5c19a39ffe0faaa8825c8f8b6a2175
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 18:11:04 2010 +0200

    gl: rework _cairo_gl_set_operator()
    
    1) store the current operator. This will be useful later to check if the
       operator changed.
    2) pass the context instead of the destination as first argument. The
       destination is known to be the current target.

 src/cairo-gl-composite.c |   16 +++++++++-------
 src/cairo-gl-device.c    |    3 +++
 src/cairo-gl-private.h   |    1 +
 3 files changed, 13 insertions(+), 7 deletions(-)

commit f66500d8b052251ea3ce06f06d2fa4c8dec2ff3b
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 15:53:48 2010 +0200

    gl: Only resetup textures if we need to

 src/cairo-gl-composite.c |   45 +++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 45 insertions(+)

commit d9dcafd61ad6aeecb4538e9fd44e3443a8a50bf1
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 15:26:45 2010 +0200

    gl: Do not reset the current target on release
    
    This now also requires a call to cairo_device_flush().

 src/cairo-gl-device.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce36be5c67fa5b574eb11eb98cdd8c9cd7e09335
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 15:23:57 2010 +0200

    glx: When acquiring device, use the correct drawable

 src/cairo-glx-context.c |   16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit 5819bb07eb7ac64f0e2fbe6a46cc3db0de1d92ce
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed Jun 2 15:23:08 2010 +0200

    gl: Store the vertex offset in the operand

 src/cairo-gl-composite.c |    1 +
 src/cairo-gl-private.h   |    1 +
 2 files changed, 2 insertions(+)

commit c75460c54d88ce9a50ac59c15a10684043ca4b0e
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 30 22:01:10 2010 +0200

    gl: Introduce a temporary texture unit
    
    ...and use it for image uploads. This makes sure that the texture units
    used for SOURCE and MASK get not clobbered when images get uploaded to
    textures.

 src/cairo-gl-composite.c |    2 ++
 src/cairo-gl-device.c    |   17 +++++++++++++++++
 src/cairo-gl-private.h   |    8 +++++++-
 src/cairo-gl-surface.c   |    2 ++
 4 files changed, 28 insertions(+), 1 deletion(-)

commit 1ddff8aba35466fe6689536bc5f2d7eeefaea02c
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 30 21:25:20 2010 +0200

    gl: Only allocate a framebuffer if we need one
    
    This way, we don't clobber the current target when creating textures for
    image surfaces.

 src/cairo-gl-device.c  |   26 ++++++++++++++++++++++++++
 src/cairo-gl-private.h |    2 +-
 src/cairo-gl-surface.c |   20 ++------------------
 3 files changed, 29 insertions(+), 19 deletions(-)

commit 1c15510c3d00553aba9ec4fd4e6764da3cdb0a41
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 30 20:12:31 2010 +0200

    Call cairo_surface_flush() before setting finished
    
    With the current code, the surface will never be flushed as the flush
    function checks if the surface is finished, and if so, doesn't call the
    vfunc. Ooops.

 src/cairo-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 467d5e7f90b9edfb62ca71e67608704424a10aca
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 21:56:57 2010 +0200

    gl: Flush properly in set_destination

 src/cairo-gl-device.c |   33 +++++++++++++++++----------------
 1 file changed, 17 insertions(+), 16 deletions(-)

commit e15348d8d0bbff6968b1f640e63315d159f143f5
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 21:55:26 2010 +0200

    gl: Don't reset vertex size

 src/cairo-gl-composite.c |   10 ++++++----
 src/cairo-gl-device.c    |    1 +
 2 files changed, 7 insertions(+), 4 deletions(-)

commit a8d6ac1efc3f1f5ff4f92f4e7a3492e62518f3f7
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 21:51:08 2010 +0200

    gl: Remove check if we're between begin/end
    
    This will be useless soon, because we will keep the current state alive as
    long as possible.

 src/cairo-gl-composite.c |    1 -
 src/cairo-gl-private.h   |    7 -------
 2 files changed, 8 deletions(-)

commit 8f675fb801f7864aa52778d4d53d7ab68f4e664b
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 21:46:52 2010 +0200

    gl: Stop disabling the vertex array and the array buffer

 src/cairo-gl-composite.c |   12 ++++--------
 src/cairo-gl-device.c    |    4 ++++
 2 files changed, 8 insertions(+), 8 deletions(-)

commit bef0b541497eb5a621df0b5528e08adb0beff961
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 21:08:17 2010 +0200

    gl: Do not reset shaders on _end()
    
    Instead, keep the shader around until cairo_device_flush() is called.

 src/cairo-gl-composite.c |   35 ++++++++++++++++++++++-------------
 src/cairo-gl-device.c    |    3 +++
 src/cairo-gl-private.h   |    6 ++++++
 3 files changed, 31 insertions(+), 13 deletions(-)

commit 534c14729921cbc2f8e24575eb792de9ddb96e23
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 21:06:58 2010 +0200

    region: clarify docs of cairo_region_equal()

 src/cairo-region.c |    9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 0fc6f08981604ffdd0109362dcbbd9773501cd9a
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 20:45:52 2010 +0200

    gl: Make _shader_by_type() a getter
    
    And refactor code to do the current_shader assigning itself.

 src/cairo-gl-composite.c |   16 +++++++++++-----
 src/cairo-gl-private.h   |    5 +++--
 src/cairo-gl-shaders.c   |   13 ++++++++-----
 3 files changed, 22 insertions(+), 12 deletions(-)

commit 2971ca049881298cd171cf27cd3beb49d2c0572f
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 20:39:22 2010 +0200

    gl: bind all shader variables at the same place
    
    Avoids the need to bind the shader when creating it.

 src/cairo-gl-composite.c |   26 ++++++++++++++++++++------
 src/cairo-gl-shaders.c   |   11 -----------
 2 files changed, 20 insertions(+), 17 deletions(-)

commit e11d8370e0503f085beaa355d85fa6991cd497da
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 17:37:19 2010 +0200

    gl: Set GL_BLEND and GL_SCISSOR_TEST globally
    
    Note that we do set them unconditionally in _begin() because a flush
    might have cleared them.

 src/cairo-gl-composite.c |   11 +++--------
 src/cairo-gl-device.c    |    8 ++++++++
 src/cairo-gl-surface.c   |    1 +
 3 files changed, 12 insertions(+), 8 deletions(-)

commit 7747f6d9146c19419fdc4fbbdf72eed42dfa731d
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 17:19:56 2010 +0200

    gl: Introduce flush functions
    
    The flush functions will clear the state that will in the future be kep
    unconditionally.

 src/cairo-gl-composite.c |    6 +++---
 src/cairo-gl-device.c    |   22 +++++++++++++++++++++-
 src/cairo-gl-private.h   |    4 ++++
 src/cairo-gl-surface.c   |   36 ++++++++++++++++++++++++++++++++----
 4 files changed, 60 insertions(+), 8 deletions(-)

commit 5c74beaaa5dedd82f891f1cc109142f7b6e222a8
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 17:19:45 2010 +0200

    docs: fix typo

 src/cairo-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 92d7b1eee96e6b1448aaf3c95a44238fa0eeff48
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 16:19:12 2010 +0200

    device: Make flush vfunc return a cairo_status_t
    
    Mirror the behavior of the surface flush vfunc: Make it return a status
    and if it's an error set it on the device.

 src/cairo-device-private.h |    2 +-
 src/cairo-device.c         |    9 +++++++--
 src/cairo-xml-surface.c    |    4 +++-
 3 files changed, 11 insertions(+), 4 deletions(-)

commit 63e3cf3888d5b55295a04c4af28e876c04245b85
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 15:09:23 2010 +0200

    gl: Move unsetting the state into the operand destroy function

 src/cairo-gl-composite.c |   43 +++++++++++++++++++++++++++++--------------
 1 file changed, 29 insertions(+), 14 deletions(-)

commit b9b85dbf3706fe9e50f40b5fda655e71931c2d7f
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 13:42:11 2010 +0200

    gl: get rid of the operand's pattern variable
    
    Now someone just needs to teach cairo-gl to not use
    cairo_pattern_acquire_surface() and we could avoid the nasty hack in
    cairo_gl_operand_destroy().

 src/cairo-gl-composite.c |   21 ++++++++++-----------
 src/cairo-gl-private.h   |    2 --
 2 files changed, 10 insertions(+), 13 deletions(-)

commit ae9517a39fdddec389553a64116140e222970ef0
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 13:18:28 2010 +0200

    gl: Check mask's attributes for component alpha
    
    ... and don't duplicate that information into the cairo_gl_composite_t

 src/cairo-gl-composite.c |   14 ++++++++------
 src/cairo-gl-private.h   |    1 -
 2 files changed, 8 insertions(+), 7 deletions(-)

commit f72afc09d0b99030f5766e7bbbb05f6db606e195
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 13:14:09 2010 +0200

    gl: Merge fixed function setup into general texture setup

 src/cairo-gl-composite.c |   84 +++++++++++++++++++---------------------------
 1 file changed, 34 insertions(+), 50 deletions(-)

commit dd1faaf02e2a75ca8b9c484abd15726f5c6d3ac4
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 12:54:54 2010 +0200

    gl: Move function
    
    I wanna use it elsewhere and keep the diff small.

 src/cairo-gl-composite.c |   58 +++++++++++++++++++++++-----------------------
 1 file changed, 29 insertions(+), 29 deletions(-)

commit d03800313623fb2b9e7d15c6a659ceaaee2882e8
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 12:51:08 2010 +0200

    gl: Simplify mask operand setup code
    
    Component alpha just has one different value

 src/cairo-gl-composite.c |   40 +++++++---------------------------------
 1 file changed, 7 insertions(+), 33 deletions(-)

commit e20261dddaa194ab4e980da8681e9378d7fd7ef1
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 12:48:59 2010 +0200

    gl: Get rid of operand argument to emit functions

 src/cairo-gl-composite.c |   34 +++++++++++++++-------------------
 src/cairo-gl-glyphs.c    |    2 +-
 src/cairo-gl-private.h   |    2 --
 src/cairo-gl-surface.c   |   11 +++--------
 4 files changed, 19 insertions(+), 30 deletions(-)

commit 8062fb352e6cd1d961f0fbc660779f4ad94c7508
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 11:03:09 2010 +0200

    gl: Add an enum for tex units
    
    Instead of hardcoding 0 for source and 1 for mask, use an enum. It's
    also clearer when functions take a cairo_gl_tex_t argument instead of a
    GLuint.

 src/cairo-gl-composite.c |   20 ++++++++++----------
 src/cairo-gl-private.h   |    5 +++++
 src/cairo-gl-shaders.c   |   34 ++++++++++++----------------------
 3 files changed, 27 insertions(+), 32 deletions(-)

commit 5db362dd6792af20282e0e9a2805ee6f1b921e44
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 28 10:24:33 2010 +0200

    gl: Keep a copy of the current operand in the context
    
    Note that they are currently only valid as long as the
    cairo_gl_composite_t exists, but that will be changed soon.

 src/cairo-gl-composite.c |   20 ++++++++++++++++----
 src/cairo-gl-private.h   |    2 ++
 2 files changed, 18 insertions(+), 4 deletions(-)

commit a05f062c806ac014d0daffa1d74bdb0dd90a8a26
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 19:23:18 2010 +0200

    gl: Move struct definitions in header

 src/cairo-gl-private.h |   66 ++++++++++++++++++++++++------------------------
 1 file changed, 33 insertions(+), 33 deletions(-)

commit 85d4c6c55b85c52d8f86247f00659e37354abd49
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 21:23:40 2010 +0200

    gl: operand->texture.surface cannot be NULL

 src/cairo-gl-composite.c |   10 +++-------
 1 file changed, 3 insertions(+), 7 deletions(-)

commit 9486ad5fbdad047b5194f6bed68a08bb4c594610
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 19:16:41 2010 +0200

    gl: Remove composite_t argument from _flush() function

 src/cairo-gl-composite.c |   17 +++++++----------
 src/cairo-gl-glyphs.c    |    2 +-
 src/cairo-gl-private.h   |    3 +--
 3 files changed, 9 insertions(+), 13 deletions(-)

commit 16e420b4dca5325ab295a27103299a916f334b05
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 19:13:53 2010 +0200

    gl: Remove dependency on composite_t in draw function

 src/cairo-gl-composite.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e46215ec6b94355b741acf5dfdd264d6396b4bc8
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 18:44:20 2010 +0200

    gl: Remove unneeded and broken workaround
    
    We now ensure the values are properly zeroed when setting the operator.

 src/cairo-gl-composite.c |   14 +-------------
 1 file changed, 1 insertion(+), 13 deletions(-)

commit b2d709b5c7e463437189b8e4a2c53a3317437825
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 17:41:01 2010 +0200

    gl: Switch src alpha handling to a tiny on/off function
    
    Instead of doing setup every time, we just set this one flag. Much
    nicer.

 src/cairo-gl-composite.c |   22 +++++++---------------
 1 file changed, 7 insertions(+), 15 deletions(-)

commit 53fd451f85974d2ed0d6f29a0a0549fd4c7035fe
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 17:32:14 2010 +0200

    gl: Avoid redundant mask setup
    
    The mask doesn't change, so no need to set it up twice

 src/cairo-gl-composite.c |    2 --
 1 file changed, 2 deletions(-)

commit 1b3675fc4b9c7f6ad4d9edd9b27bee10c2502b81
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 17:28:05 2010 +0200

    gl: Split fixed-function operand setup into own function

 src/cairo-gl-composite.c |  151 +++++++++++++---------------------------------
 1 file changed, 42 insertions(+), 109 deletions(-)

commit 02da871050f6be02ba0231e545d6613a42c3a7e6
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 17:02:29 2010 +0200

    gl: Unify fixed function setup code

 src/cairo-gl-composite.c |   15 ++++-----------
 1 file changed, 4 insertions(+), 11 deletions(-)

commit 74f9094162fba54c29859e25ad5be085604aa0b6
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 15:46:39 2010 +0200

    gl: switch OPERAND0 and OPERAND1 in the fixed function path
    
    This should not change anything as we multiply the values.
    But it allows unifying parts of the code, which will happen in another
    patch.

 src/cairo-gl-composite.c |   42 +++++++++++++++++++++---------------------
 1 file changed, 21 insertions(+), 21 deletions(-)

commit c6aac5d0134f1473d3867c1b6a4b40753700ffcb
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 15:42:56 2010 +0200

    gl: Move the pre shader to the context, too
    
    It's required when flushing, too.

 src/cairo-gl-composite.c |   10 +++++-----
 src/cairo-gl-private.h   |    2 +-
 2 files changed, 6 insertions(+), 6 deletions(-)

commit 61bc3067ca5fa4aeaef537c397c37826facc7621
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 15:28:32 2010 +0200

    gl: Store the clip region in the context
    
    This is necessary because we want to get rid of keeping the composite
    stuff around.

 src/cairo-gl-composite.c |   15 ++++++++++-----
 src/cairo-gl-device.c    |    2 ++
 src/cairo-gl-private.h   |    1 +
 3 files changed, 13 insertions(+), 5 deletions(-)

commit db79880d9a836d50e9202caa5c73e22a2b6b97b3
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 13:03:12 2010 +0200

    gl: Make gl_composite_begin() acquire the context
    
    Also remove the previous places for context acquisition. This completes
    fixing the potential ABBA deadlock I talked about a few commits ago.

 src/cairo-gl-composite.c |   21 +++++++++++++++++----
 src/cairo-gl-glyphs.c    |    7 ++++++-
 src/cairo-gl-private.h   |    4 ++--
 src/cairo-gl-surface.c   |   26 +++++---------------------
 4 files changed, 30 insertions(+), 28 deletions(-)

commit 1320a168fa5b73fd42438040a4bf8ee9ad222a0e
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 12:26:49 2010 +0200

    gl: Remove unused code
    
    We don't need to acquire/release the context, we're not using it.

 src/cairo-gl-glyphs.c |   11 +----------
 1 file changed, 1 insertion(+), 10 deletions(-)

commit 8f5c3b706b5bad6b0851a3e27752f7d1a3ca8a72
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 12:16:01 2010 +0200

    gl: Make composite_set_clip_region not require the context

 src/cairo-gl-composite.c |    3 +--
 src/cairo-gl-glyphs.c    |    2 +-
 src/cairo-gl-private.h   |    3 +--
 src/cairo-gl-surface.c   |    2 +-
 4 files changed, 4 insertions(+), 6 deletions(-)

commit ac6abcbac7f79e5717c44e251135dcba8ab00b27
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 12:14:24 2010 +0200

    gl: Make composite_set_source/mask/mask_spans not require a context

 src/cairo-gl-composite.c |   77 ++++++++++++++++++++++++----------------------
 src/cairo-gl-glyphs.c    |    5 ++-
 src/cairo-gl-private.h   |    9 ++----
 src/cairo-gl-surface.c   |   13 ++++----
 4 files changed, 51 insertions(+), 53 deletions(-)

commit 88a70d66fcdbca7e489baa48cd145bb69c3e28e0
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 11:59:36 2010 +0200

    gl: Add API for querying if we need GL_TEXTURE_RECTANGLE_EXT
    
    We need to do that querying outside of taking the lock, so we want to be
    able to query the device, not the context.

 src/cairo-gl-composite.c |   11 +++++------
 src/cairo-gl-glyphs.c    |    2 +-
 src/cairo-gl-private.h   |    6 ++++++
 3 files changed, 12 insertions(+), 7 deletions(-)

commit 9c6e1338a1c7d61b4cc84bcdc5c38573a34cd561
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 26 11:36:22 2010 +0200

    gl: Make cairo_gl_composite_t not require a gl context anymore
    
    First patch in a series.
    
    The idea is to make all gl operations in Cairo work like this:
    1) prepare cairo_gl_composite_t
    2) acquire device
    3) begin composite operation
    4) emit vertexes
    5) end operation
    6) release device
    7) cleanup composite operation
    
    This both reduces the time required with the device locked, cleans the
    API and more importantly avoids ABBA deadlocks, as we currently call
    acquire_pattern() with the device lock held.

 src/cairo-gl-composite.c |    6 ++----
 src/cairo-gl-glyphs.c    |    7 +++----
 src/cairo-gl-private.h   |    6 ++----
 src/cairo-gl-surface.c   |   19 ++++++++-----------
 4 files changed, 15 insertions(+), 23 deletions(-)

commit 60f0cb9c60556f94af903dd6f9da0628a05a1f7f
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 22 18:42:44 2010 +0200

    gl: Flush surface at the right times

 src/cairo-gl-composite.c |    2 ++
 src/cairo-gl-device.c    |    2 ++
 src/cairo-gl-surface.c   |    2 ++
 3 files changed, 6 insertions(+)

commit ffeeae462ea0f8c7af326f3bcc66b88881bd8fdd
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun Jun 6 16:50:34 2010 +0100

    Revert "gstate: reduce a couple more operators"
    
    This reverts commit a85c6c1e36273d534f01ade0714b0592b6bed5ab.
    
    Soeren found that this introduced a regression when displaying pages in
    evince, and since I'm not overly enthralled at the added complexity here
    for very little gain, remove the reduction and leave it clear for a more
    complete solution in the future.

 src/cairo-gstate.c |   15 +--------------
 1 file changed, 1 insertion(+), 14 deletions(-)

commit 44e628a6f4e6b9b21ad67b08869186a779d0db5a
Author: Makoto Kato <m_kato@ga2.so-net.ne.jp>
Date:   Mon May 31 18:22:40 2010 +0900

    openvg: fix build break

 src/cairo-vg-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cc080a1e2731a42045709d789587070da944145c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 27 20:51:55 2010 +0100

    gl: Unmap the vertex buffer prior to using in DaawArrays()
    
    "It is an INVALID_OPERTION error to source data from a buffer object
    that is currently mapped."
    
    mesa is currently lax in this regard, but the Nvidia libGL conforms to
    the spec and thus was causing failures.

 src/cairo-gl-composite.c |   23 ++++++++++++-----------
 1 file changed, 12 insertions(+), 11 deletions(-)

commit b3e15bd5c307352065555c6c3ae5f0bd15b9a791
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 27 18:43:03 2010 +0100

    gl: _cairo_set_shader_by_type() cannot return UNSUPPORTED
    
    So remove the superfuous test.

 src/cairo-gl-composite.c |    7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 59bd34e6a3661483f60bb01be8b406a5c38e1131
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 27 18:35:40 2010 +0100

    gl: Check for an error device when creating surfaces.

 src/cairo-gl-surface.c |    3 +++
 1 file changed, 3 insertions(+)

commit 53f086105975c1c2bd4c43a1b0613ebde3580e95
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 27 18:27:53 2010 +0100

    gl: Make _cairo_gl_shader_(init|compile) static
    
    Only used within _cairo_gl_shaders.c, so remove the private symbol.

 src/cairo-gl-private.h |   10 ----------
 src/cairo-gl-shaders.c |   41 +++++++++++++++++++++++++----------------
 2 files changed, 25 insertions(+), 26 deletions(-)

commit dd0866cdc878a0be438a117051ccc64f12f81970
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 27 17:52:11 2010 +0100

    boilerplate: Exercise RENDER capable windows.
    
    Ensure that the drivers actually work when rendering to a normal window.

 boilerplate/cairo-boilerplate-xlib.c |  107 ++++++++++++++++++++++++++++++++++
 1 file changed, 107 insertions(+)

commit 2dc42af9422a15f902934a53c074e4194991a9e4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 17 16:32:20 2010 +0100

    script: Update csi-exec to match new interface.

 util/cairo-script/csi-exec.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 2f0f4ed0e2ae5657dedfe180b7be3a2496753ba8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 20 21:54:51 2010 +0100

    freed-pool: Don't access beyond the end of the array.
    
    Argh. This bug has been here for quite some time and only showed itself
    with a corrupt pointer on ppc32. Since the erroneous write is inside the
    block, it remained undetected by valgrind.

 src/cairo-freed-pool-private.h |    8 +++++---
 src/cairo-freed-pool.c         |    4 +++-
 2 files changed, 8 insertions(+), 4 deletions(-)

commit 97b4aeba44e5f4b23b3ed417b991570b46d4736e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 20 21:54:16 2010 +0100

    atomic: Add memory barriers if required for intel primitives

 src/cairo-atomic-private.h |   16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit 24e684c267404528b40fa49b55272d73bd44167d
Author: Benjamin Otte <otte@gnome.org>
Date:   Thu May 20 22:37:18 2010 +0200

    gl: spans need the dummy texture
    
    Thanks Eric. That took me half a day.

 src/cairo-gl-composite.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d7a564d8eed32b4417fdb4c8c5d91467e4ae1019
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 20 22:10:06 2010 +0200

    gl: Don't set is_clear
    
    1) It's wrong.
    2) The core functions set the flag correctly already.

 src/cairo-gl-surface.c |    2 --
 1 file changed, 2 deletions(-)

commit f9cf07b126293d00df085d4fbfa337e1132e0258
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 20 16:08:38 2010 +0200

    gl: Fix coverage passing for spans not being endian safe.

 src/cairo-gl-composite.c |   29 ++++++++++++++++-------------
 src/cairo-gl-private.h   |    2 +-
 src/cairo-gl-surface.c   |    4 ++--
 3 files changed, 19 insertions(+), 16 deletions(-)

commit 2a0f34c6da2eb4f10b198d04894fc1413352e041
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 20 11:23:18 2010 +0200

    gl: Allow NONE and SPANS sampler for source, too

 src/cairo-gl-shaders.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 1586f7740ad436447ac75c6b869da7446172a63c
Author: Benjamin Otte <otte@gnome.org>
Date:   Thu May 20 13:17:52 2010 +0200

    gl: Refactor fixed function setup code
    
    In particular get rid of the _cairo_gl_set_tex_combine_constant_color()
    function by inlining it and move common glTexEnv calls out of the
    switch statement.

 src/cairo-gl-composite.c |  130 ++++++++++++++++------------------------------
 1 file changed, 46 insertions(+), 84 deletions(-)

commit 4889090c76bdab5e4eb887593caf5d5a34f90864
Author: Benjamin Otte <otte@gnome.org>
Date:   Thu May 20 12:13:43 2010 +0200

    gl: set the active texture before fiddling with with glTexEnv
    
    fixes the fixed function pipeline

 src/cairo-gl-composite.c |    8 ++++++++
 1 file changed, 8 insertions(+)

commit 3cff2da912150868390bf4b9df166c88b3dfcf2e
Author: Benjamin Otte <otte@gnome.org>
Date:   Thu May 20 12:03:18 2010 +0200

    gl: Remove unused variables

 src/cairo-gl-composite.c |    9 ---------
 1 file changed, 9 deletions(-)

commit 4c7dd1be4526c85b47f1fe1d4663e7fbec0926b1
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 22:03:18 2010 +0200

    gl: Move vertex array setup code into the texture setup code

 src/cairo-gl-composite.c |   35 ++++++++++++++---------------------
 1 file changed, 14 insertions(+), 21 deletions(-)

commit d9d5976bdf333a5a7ea7707bc3076696f3c079d2
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 21:54:32 2010 +0200

    gl: Add an assertion that a context cannot call _begin() twice
    
    Evert _begin() call must be followed by an _end() call to avoid any
    nastiness. Just like GL. :)

 src/cairo-gl-composite.c |    2 ++
 src/cairo-gl-private.h   |    7 +++++++
 2 files changed, 9 insertions(+)

commit 5b8b1fe1cb692530b40db330c3040cd85a8b6bd7
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 21:10:26 2010 +0200

    gl: Move vertex buffer handling from setup into context
    
    We can only emit one vertex buffer at a time anyway.

 src/cairo-gl-composite.c |   34 ++++++++++++++++++----------------
 src/cairo-gl-private.h   |    8 ++++----
 2 files changed, 22 insertions(+), 20 deletions(-)

commit 0d5f2eab77f055b063538dcd345a1e0db480f3bc
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 20:49:49 2010 +0200

    gl: Actuall do fall back to fixed function paths.
    
    Previously we were just returning UNSUPPORTED all the time. I guess that
    explains why my code got so slow...

 src/cairo-gl-composite.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit bb7ca71c1af416ca084f03089f5fe762403635dd
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 20:47:31 2010 +0200

    gl: Don't store the shader in the composite_t anymore
    
    Now that we have ctx->current_shader, there's no need to keep it in the
    composite setup code.

 src/cairo-gl-composite.c |   30 ++++++++++++++----------------
 src/cairo-gl-private.h   |   10 ++++------
 src/cairo-gl-shaders.c   |   16 ++++++----------
 3 files changed, 24 insertions(+), 32 deletions(-)

commit 6c477b4a945a8f8b866bb2f5e125d4a0328d05f4
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 20:10:19 2010 +0200

    gl: Move shader checking in the TexEnv setup code
    
    As the previously generic setup code only contains non-shader code now,
    we can check in advance that no shader is in use and do all the other
    stuff without checks.

 src/cairo-gl-composite.c |  208 ++++++++++++++++++++++------------------------
 1 file changed, 101 insertions(+), 107 deletions(-)

commit 73262edd8201de8ab8a01e01f83af5b5d6470f9e
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 19:25:03 2010 +0200

    gl: Move texture setup code into its own file
    
    This ensures textures don't need to be (re)set when doing component
    alpha and running 2 shaders.

 src/cairo-gl-composite.c |  208 ++++++++++++++++++++--------------------------
 1 file changed, 92 insertions(+), 116 deletions(-)

commit 970c879dd897019f90b0c8ff5a18781be4935c55
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 18:34:00 2010 +0200

    gl: Binding variables only works for the current shader
    
    So make the code reflect that.

 src/cairo-gl-composite.c |   27 ++++++++++++---------------
 src/cairo-gl-private.h   |    6 ------
 src/cairo-gl-shaders.c   |   22 ++++++++--------------
 3 files changed, 20 insertions(+), 35 deletions(-)

commit 065969d78f23c634ebcb2b931cbb1fe184f2cedf
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 18:21:06 2010 +0200

    gl: Separate binding to shaders from setting operands
    
    That way we only need to bind to shaders when creating them, but not
    everytime we switch shaders on text output.

 src/cairo-gl-composite.c |  156 +++++++++++++++++++++++-----------------------
 src/cairo-gl-shaders.c   |    2 +-
 2 files changed, 79 insertions(+), 79 deletions(-)

commit c53f7778bcf274f64f801ef9ee1641a088842f60
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 16:50:57 2010 +0200

    gl: Use the mask, not the source
    
    Not that we'd ever have constant color component-alpha masks, but that's
    an entirely different topic.

 src/cairo-gl-composite.c |    8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 26e8e506b66022910c262da0618ef5be8c5a080e
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 13:19:56 2010 +0200

    gl: Add _cairo_gl_surface_is_texture()
    
    It's more explicit then just checking surface->fb != 0
    Also, it makes improving that check easier.

 src/cairo-gl-device.c  |    4 ++--
 src/cairo-gl-private.h |    6 ++++++
 src/cairo-gl-surface.c |   11 ++++++-----
 3 files changed, 14 insertions(+), 7 deletions(-)

commit e4cb46b50015f792b0e8c7b49f3b42f2c3c0ad00
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 12:10:10 2010 +0200

    gl: Implement texture upload to window with composite()
    
    Instead of custom code that does basically the same thing, use
    a temporary surface and _cairo_gl_surface_composite() to upload images.

 src/cairo-gl-shaders.c |    2 +-
 src/cairo-gl-surface.c |  129 ++++++++++++++++++------------------------------
 2 files changed, 48 insertions(+), 83 deletions(-)

commit 7c8759e279f51ea722c07e4b0c70f4a49f34393d
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 11:46:12 2010 +0200

    gl: cache the current shader in the context

 src/cairo-gl-private.h |    4 +++-
 src/cairo-gl-shaders.c |    7 +++++++
 2 files changed, 10 insertions(+), 1 deletion(-)

commit 6864ca6c25aa8147a562d7f693a95025dde807a8
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 19 11:10:11 2010 +0200

    gl: Move _cairo_gl_set_operator() to the file it's used in
    
    Also make it a private function.

 src/cairo-gl-composite.c |   57 ++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-gl-private.h   |    4 ----
 src/cairo-gl-surface.c   |   57 ----------------------------------------------
 3 files changed, 57 insertions(+), 61 deletions(-)

commit 0d2d4c59026c31da084e6797d109a230341b396d
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 21:56:55 2010 +0200

    gl: Detect color-pattern clears of surfaces
    
    ... and use glClear() there.
    
    The common case here is a solid color and OPERATOR_OVER.

 src/cairo-gl-private.h |    3 ---
 src/cairo-gl-surface.c |   38 +++++++++++++++++++++++++++++---------
 2 files changed, 29 insertions(+), 12 deletions(-)

commit b70eb275c4aa54f7c90a985b5de67da12ac08a30
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 21:56:18 2010 +0200

    gl: detect image uploads and fast-path them

 src/cairo-gl-surface.c |   23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit 8adbf3aa19fd9fb8200973ecd72cdebfd9a5364d
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 20:12:44 2010 +0200

    gl: Use _cairo_gl_surface_draw_image() when caching glyphs

 src/cairo-gl-glyphs.c |   47 ++++++++---------------------------------------
 1 file changed, 8 insertions(+), 39 deletions(-)

commit 915aa64ef077fe3b6094d0f1c8bd87ab5acc4868
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 13:01:30 2010 +0200

    gl: Actually check errors for _cairo_gl_composite_begin()

 src/cairo-gl-glyphs.c |    2 ++
 1 file changed, 2 insertions(+)

commit 0222cc7d76b0dc724630b660687f98a2460eb0b9
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 13:00:34 2010 +0200

    gl: Get rid of _cairo_gl_composite_set_mask_texture()
    
    Now that the glyph cache contains real surfaces, there's no longer a
    need to have a special function for it.

 src/cairo-gl-composite.c |   16 ----------------
 src/cairo-gl-glyphs.c    |   15 ++++++++-------
 src/cairo-gl-private.h   |    6 ------
 3 files changed, 8 insertions(+), 29 deletions(-)

commit 208d9f2a7e1f66ff2764c41fe67f65e27279b2ab
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 12:49:59 2010 +0200

    gl: Make glyph cache a real surface
    
    This has the huge advantage that we can use real surface functions on
    it.

 src/cairo-gl-glyphs.c  |   67 ++++++++++++++++++------------------------------
 src/cairo-gl-private.h |    3 +--
 2 files changed, 26 insertions(+), 44 deletions(-)

commit 050117996339cfe35add1f2cd44d0e5578d4a981
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 18 12:02:54 2010 +0200

    surface: Add _cairo_surface_release_device_reference() API
    
    See the API documentation for that function about its intended purpose.

 src/cairo-surface-private.h |    1 +
 src/cairo-surface.c         |   26 +++++++++++++++++++++++++-
 src/cairoint.h              |    3 +++
 3 files changed, 29 insertions(+), 1 deletion(-)

commit c489f67d1d1d6079f9b58b726ed42beea1dfc44e
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 20:45:42 2010 +0200

    gl: Make a bunch of functions static
    
    They are no longer used outside of cairo_gl_composite_t.

 src/cairo-gl-composite.c |    8 ++++----
 src/cairo-gl-private.h   |   16 ----------------
 2 files changed, 4 insertions(+), 20 deletions(-)

commit c8008e118a54d62690d6555c9ffabf734c39e69f
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 19:16:20 2010 +0200

    gl: Don't name the union in cairo_gl_operand_t
    
    Gets rid of ultra-long variable names.

 src/cairo-gl-composite.c |  152 +++++++++++++++++++++++-----------------------
 src/cairo-gl-private.h   |    2 +-
 2 files changed, 77 insertions(+), 77 deletions(-)

commit 53260148ea9abacdc510826765c1d63f486add6c
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Fri May 14 21:04:22 2010 +0200

    quartz: fix repeating radial gradients on 64 bits
    
    Quartz API uses the type CGFloat, which is double on 64 bits,
    float on 32 bits architectures

 src/cairo-quartz-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0104976dc853b60de14080a749a6f729852f1b22
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Fri May 14 21:03:19 2010 +0200

    quartz: silence compiler warnings
    
    All the possible enum values have to be explicitly handled in switch statements.

 src/cairo-quartz-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit ac94a00a4d3acb36f011330b78d1311534fe90e0
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Fri May 14 19:33:15 2010 +0200

    quartz: fallback for A1 images on little endian archs
    
    Quartz uses a bit ordering that is consistent with cairo on big
    endian architectures, but isn't on little endian architectures.
    
    Fixes a1-mask and large-source-roi (on little endian)

 src/cairo-quartz-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit f40e3b09a130a9ccbe310120fd5cfc7ad7828a4d
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu May 13 12:15:19 2010 +0200

    quartz-font: Silence 0x0 CGContext warning
    
    Silence Quartz complaints about operations on empty contexts:
    <Error>: CGContextSetFont: invalid context 0x0
    <Error>: CGContextSetFontSize: invalid context 0x0
    <Error>: CGContextSetTextMatrix: invalid context 0x0
    <Error>: CGContextSetAlpha: invalid context 0x0
    <Error>: CGContextShowGlyphsAtPoint: invalid context 0x0

 src/cairo-quartz-font.c |   77 ++++++++++++++++++++++++++---------------------
 1 file changed, 42 insertions(+), 35 deletions(-)

commit 1687e6169463947554f5476674a577e67e2c543b
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Thu May 13 11:54:32 2010 +0200

    quartz-font: Conform context and antialias handling to quartz-surface
    
    A8 surfaces are now kAlphaOnly surfaces in quartz-font too.
    Subpixel font smoothing can be enabled.

 src/cairo-quartz-font.c |   38 ++++++++++++++++++++++++++++----------
 1 file changed, 28 insertions(+), 10 deletions(-)

commit d68bbc0fe5706634e4c025bdcb311905b7f008e4
Author: Benjamin Otte <otte@gnome.org>
Date:   Mon May 17 20:57:08 2010 +0200

    gl: Add missing NULL-check in non-shader code

 src/cairo-gl-composite.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 7f22372edf10f5eab53ea132d9226f6d5b49eb9a
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 14:20:17 2010 +0200

    gl: Get rid of src and mask argument to composite_init()
    
    This was thought of as a way to detect self-painting, but it's better to
    check that later in _begin() - when we check it.

 src/cairo-gl-composite.c |    2 --
 src/cairo-gl-glyphs.c    |    2 +-
 src/cairo-gl-private.h   |    2 --
 src/cairo-gl-surface.c   |    9 ++++-----
 4 files changed, 5 insertions(+), 10 deletions(-)

commit 75f15babed8409fb1eaae514411de01d57072c80
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 14:17:47 2010 +0200

    gl: Implement fill_rectangles with composite
    
    Tiny performance improvement, but a lot less code.

 src/cairo-gl-surface.c |  204 ++++++++++--------------------------------------
 1 file changed, 41 insertions(+), 163 deletions(-)

commit e7c5b4f79fa24b75026c93bc9244115d2ee23930
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 13:56:22 2010 +0200

    gl: make _set_mask() accept NULL
    
    That way, it can be used to unset the mask.

 src/cairo-gl-composite.c |    3 +++
 src/cairo-gl-surface.c   |   14 ++++++--------
 2 files changed, 9 insertions(+), 8 deletions(-)

commit 145db7a427e594f1d68a6c0f4afe5e365e219cf0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 17 12:37:46 2010 +0100

    gl: Check status after composite_begin
    
    Skip the unnecessary work in _cairo_gl_surface_composite() if we fail
    to setup the GL composite operation.

 src/cairo-gl-surface.c |    2 ++
 1 file changed, 2 insertions(+)

commit 8695c41e80ce932fd5dd434307b92f323a937c7c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 17 12:36:54 2010 +0100

    gl: Throw a _cairo_error when detecting a GLerror
    
    This allows us to easily set an breakpoint and inspect cairo's state
    when we do something illegal.

 src/cairo-gl-private.h |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 1c18ab02c8d41be8e5886cbb34aeda5099189fef
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 17 11:42:26 2010 +0100

    gl: Rename cairo_gl_shader_program_t to cairo_gl_shader_t
    
    And complete the move of the shaders into the cairo_gl_shader namespace.
    Of particular note, the bind_*_to_shader become
    _cairo_gl_shader_bind_*() and have proper types.

 src/cairo-gl-composite.c |  138 ++++++-------
 src/cairo-gl-device.c    |   14 +-
 src/cairo-gl-private.h   |   93 +++++----
 src/cairo-gl-shaders.c   |  508 +++++++++++++++++++++++++---------------------
 src/cairo-gl-surface.c   |   54 ++---
 5 files changed, 424 insertions(+), 383 deletions(-)

commit 2325d755b03958d8ead9a995c0d1d03e4f93af0c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon May 17 10:33:46 2010 +0100

    gl: Pretty print the error GLenum.

 src/cairo-gl-private.h |    3 ++-
 src/cairo-gl-surface.c |   19 +++++++++++++++++++
 2 files changed, 21 insertions(+), 1 deletion(-)

commit 7ef1bd22ded512f4fad3959796d7f40c4ddc5824
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 01:12:34 2010 +0200

    gl: Update copyright statements
    
    - add 2010 Red Hat copyright for my code
    - include myself as author
    - update contributors list

 src/cairo-gl-composite.c |    5 ++++-
 src/cairo-gl-device.c    |    5 ++++-
 src/cairo-gl-glyphs.c    |    5 +++++
 src/cairo-gl-private.h   |    6 ++++--
 src/cairo-gl-shaders.c   |    8 +++++++-
 src/cairo-gl-surface.c   |    5 ++++-
 6 files changed, 28 insertions(+), 6 deletions(-)

commit 0b69e51b526a609a2dc5f1d2fb9c49f240feb57b
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 00:56:21 2010 +0200

    gl: Assert that binding values to shaders never fails
    
    As that would  be a programming error, we can use an assert and get rid
    of return values that we weren't checking anyway.

 src/cairo-gl-composite.c |  129 +++++++++++++++++++---------------------------
 src/cairo-gl-private.h   |   12 ++---
 src/cairo-gl-shaders.c   |  114 ++++++++++++++++------------------------
 src/cairo-gl-surface.c   |   15 +++---
 4 files changed, 111 insertions(+), 159 deletions(-)

commit 0bb11e8f5bcdc8a6f8384197b39c2ad48eaab1cd
Author: Benjamin Otte <otte@redhat.com>
Date:   Mon May 17 00:49:01 2010 +0200

    gl: Use GL_TRIANGLES instead of GL_QUADS
    
    It seems to increase performance by 1-2% on average and up to 30% in
    some cases (on i965).

 src/cairo-gl-composite.c |   16 +++++++++++-----
 1 file changed, 11 insertions(+), 5 deletions(-)

commit 2b771da47a87f86f378314bfe8033874d9444914
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 23:58:47 2010 +0200

    xlib: ensure variable isn't uninitialized

 src/cairo-xlib-surface.c |    4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit b768a33a602942825e5ec651ae7bafd6d5fc33ac
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 21:10:45 2010 +0200

    gl: Set composite->has_component_alpha based on mask
    
    Previously it was set when initing the composite structure, but that
    doesn't allow resetting it when a new mask is used.

 src/cairo-gl-composite.c |    7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit 1cde4601df8a3689450e2a0e15888c53aff12983
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 21:05:16 2010 +0200

    gl: Replace _cairo_gl_operand_init() with setters for src/mask
    
    Now cairo_gl_operand_t is no longer exposed outside of
    cairo-gl-composite.c

 src/cairo-gl-composite.c |   34 +++++++++++++++++++++++++++++++++-
 src/cairo-gl-glyphs.c    |   10 +++++-----
 src/cairo-gl-private.h   |   25 ++++++++++++++++---------
 src/cairo-gl-surface.c   |   26 +++++++++++++-------------
 4 files changed, 67 insertions(+), 28 deletions(-)

commit 6575cb7a95e109ab39eda58603ed6a76581a41b0
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 20:39:00 2010 +0200

    gl: Convert glyphs path to use cairo_gl_composite_t

 src/cairo-gl-composite.c |  122 ++++++++++++-----
 src/cairo-gl-glyphs.c    |  331 ++++++----------------------------------------
 src/cairo-gl-private.h   |   22 +++
 3 files changed, 150 insertions(+), 325 deletions(-)

commit 8937f2b4b5e4bcb8ada1e478df6a7329c0b80a5a
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 13:19:48 2010 +0200

    gl: Require ARB_vertex_buffer_object extension unconditionally
    
    <anholt> we shouldn't bother with non-vbo support. there's no
    justification for a driver not supporting it.

 src/cairo-gl-composite.c |    1 -
 src/cairo-gl-device.c    |    5 +++--
 src/cairo-gl-glyphs.c    |    3 ---
 src/cairo-gl-private.h   |    7 -------
 src/cairo-gl-surface.c   |   12 ++++--------
 5 files changed, 7 insertions(+), 21 deletions(-)

commit 29dfd5b488e16ec8be879b2415635df93b874afc
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 03:36:05 2010 +0200

    gl: Remove unused variables

 src/cairo-gl-surface.c |    7 +------
 1 file changed, 1 insertion(+), 6 deletions(-)

commit 4144488f516214b675d25d48add8cbd83fd17025
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 03:29:04 2010 +0200

    gl: Convert span renderer to use cairo_gl_composite_begin/end()
    
    Adds two new APIs to the composite API:
    - _cairo_gl_composite_set_mask_spans()
      Tells the composite renderer to use the color values for spans.
    - _cairo_gl_composite_set_clip_region()
      Tells the composite renderer to use GL_SCISSORS_TEST to clip when
      drawing. This function is very unperformant, so if it can be avoided,
      it probably shouldn't be used.

 src/cairo-gl-composite.c |   72 +++++++++++++-
 src/cairo-gl-private.h   |   10 ++
 src/cairo-gl-surface.c   |  247 ++++++----------------------------------------
 3 files changed, 110 insertions(+), 219 deletions(-)

commit 6e81d85e3682f14e1c5dbe97dda2cc1fcd32df3a
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 03:27:28 2010 +0200

    gl: Change _cairo_gl_composite_emit_rect()
    
    Two changes:
    - The function now takes x1/y1,x2/y2 instead of x,y,width,height
    - The function takes a color uint32_t. This will be used by spans.

 src/cairo-gl-composite.c |   27 +++++++++++++++------------
 src/cairo-gl-private.h   |    9 +++++----
 src/cairo-gl-surface.c   |   10 ++++++----
 3 files changed, 26 insertions(+), 20 deletions(-)

commit f8398cc2d83eb9ac37874f71d4f8805dbf0df412
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 02:34:18 2010 +0200

    gl: remove unused variables from span renderer

 src/cairo-gl-surface.c |    7 -------
 1 file changed, 7 deletions(-)

commit f5c5077def47b91b57dfbc8c2622b4aaf5ca8fbb
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 02:06:43 2010 +0200

    gl: Support component alpha in gl_composite_t
    
    Use that to get rid of cairo_gl_surface_composite_component_alpha()

 src/cairo-gl-composite.c |  165 +++++++++++++++++++++++++--
 src/cairo-gl-glyphs.c    |    2 +-
 src/cairo-gl-private.h   |    4 +
 src/cairo-gl-surface.c   |  280 +---------------------------------------------
 4 files changed, 167 insertions(+), 284 deletions(-)

commit 88c118f891ca9ba472b8acff33829de845bb507c
Author: Benjamin Otte <otte@redhat.com>
Date:   Sun May 16 00:24:17 2010 +0200

    gl: Implement _composite_emit_rect() and _composite_end()
    
    And use it in cairo_gl_surface_composite()

 src/cairo-gl-composite.c |  164 ++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-gl-private.h   |   19 ++++++
 src/cairo-gl-surface.c   |  107 +++---------------------------
 3 files changed, 192 insertions(+), 98 deletions(-)

commit b96735f7b465a16182c4c8555878ba16b947e8f9
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 22:12:12 2010 +0200

    gl: Add _cairo_gl_composite_begin() function
    
    This is the first step at adding the following function set:
    _cairo_gl_composite_begin()
    _cairo_gl_composite_emit_*()
    _cairo_gl_composite_end()
    which will take care of proiding a unified model for emitting vertexes
    using vbos instead of the 5 different methods we currently have.

 src/cairo-gl-composite.c |   30 ++++++++++++++++++++++++++++++
 src/cairo-gl-private.h   |    6 ++++++
 src/cairo-gl-surface.c   |   22 +---------------------
 3 files changed, 37 insertions(+), 21 deletions(-)

commit 211a8b8234d24dd8e00332cb0b0e625ac1ffef58
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 21:27:58 2010 +0200

    gl: make _cairo_operand_destroy private

 src/cairo-gl-composite.c |    2 +-
 src/cairo-gl-private.h   |    3 ---
 2 files changed, 1 insertion(+), 4 deletions(-)

commit bf1060252abaa97eb5ce149f8b99055b42096c67
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 21:26:55 2010 +0200

    gl: make show_glyphs use the cairo_composite_t API

 src/cairo-gl-glyphs.c |   17 ++++++++++-------
 1 file changed, 10 insertions(+), 7 deletions(-)

commit 948290de12c5f451d361903f0f52e0cde5527180
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 20:33:00 2010 +0200

    gl: Make the span renderer use the new composite APIs

 src/cairo-gl-surface.c |   32 ++++++++++++++++++++------------
 1 file changed, 20 insertions(+), 12 deletions(-)

commit 7ad8c3b45691ce0c8a86180bb3c1117b9a9980c0
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 20:07:44 2010 +0200

    gl: Move composite code into own file
    
    This allows designing a cleaner interface for cairo_composite_t as there
    will not be static functions that get called outside of the "published"
    interfaces.

 src/Makefile.sources     |    3 +-
 src/cairo-gl-composite.c |  898 ++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-gl-private.h   |    8 +
 src/cairo-gl-surface.c   |  851 +------------------------------------------
 4 files changed, 910 insertions(+), 850 deletions(-)

commit 3ff32b00f0f85a853163c20b101ac5dd6a07da77
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 18:20:56 2010 +0200

    gl: cairo_gl_compsite_setup_t => cairo_gl_composite_t

 src/cairo-gl-glyphs.c  |    4 ++--
 src/cairo-gl-private.h |   26 +++++++++++++-------------
 src/cairo-gl-surface.c |   46 +++++++++++++++++++++++-----------------------
 3 files changed, 38 insertions(+), 38 deletions(-)

commit c16edee26fb9f1669ee0ce1a61f0c54d802c6c7b
Author: Benjamin Otte <otte@redhat.com>
Date:   Sat May 15 17:33:24 2010 +0200

    gl: use glBlendFuncSeparate()
    
    This way we can treat alpha-only textures correctly and don't have to
    emit different shaders for it. Also gets rid of
    GL_OPERAND_TEXTURE_ALPHA.

 src/cairo-gl-glyphs.c  |    9 +++------
 src/cairo-gl-private.h |    1 -
 src/cairo-gl-shaders.c |   37 -------------------------------------
 src/cairo-gl-surface.c |   37 +++++++++++++------------------------
 4 files changed, 16 insertions(+), 68 deletions(-)

commit 4f5221a834a883262cce607d247f607d6c200363
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 21:12:37 2010 +0200

    gl: acquire device manually in finish, as the default way will error
    
    We'll get CAIRO_STATUS_DEVICE_FINISHED, d'oh

 src/cairo-gl-device.c |   16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 3f6300444928d12bf4a6e2f6f2c5fec1de7dba8e
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 20:53:20 2010 +0200

    gl: Put shaders into a cache
    
    This allows to grow the complexity of the shaders without enlarging the
    static array to unreasonable sizes.
    
    The cache size of 64 is essentially random.

 src/cairo-gl-device.c  |    2 +
 src/cairo-gl-private.h |    8 ++--
 src/cairo-gl-shaders.c |  111 ++++++++++++++++++++++++++++++++++++++++--------
 3 files changed, 100 insertions(+), 21 deletions(-)

commit 08b04caf52518f1672694341355b5f5418008e78
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 18:10:04 2010 +0200

    gl: Add cairo_gl_composite_setup_init/fini() functions
    
    Simplifies the main code paths, and can be extended to do dest copies.

 src/cairo-gl-private.h |   13 +++++++
 src/cairo-gl-surface.c |   91 +++++++++++++++++++++++++++---------------------
 2 files changed, 65 insertions(+), 39 deletions(-)

commit aa14df0db5e4f236a9668ceda4e148e7d3ba0e9f
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 17:01:47 2010 +0200

    gl: move operator check
    
    component alpha compositing checks the operator itself

 src/cairo-gl-surface.c |    6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit a3ee0a7f113ed38df66580ff7e38a79759b0c933
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 16:57:32 2010 +0200

    gl: Programmatically generate fragment shaders

 src/cairo-gl-shaders.c |  428 +++++++++++++++++++++---------------------------
 src/cairo-gl-surface.c |    6 +-
 2 files changed, 186 insertions(+), 248 deletions(-)

commit fe43b13052f7063f880aeeebda1880a6a2097922
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 13:57:06 2010 +0200

    gl: Automatically generate the vertex shader source
    
    The idea is being able to generate shaders from the given input
    on-demand. This allows creating more advanced shaders, such as those
    that include the destination (for self-painting and
    unsupported-by-blending operator) or painting images in weird formats
    (extra translation step in shader, think YUV).

 src/cairo-gl-device.c  |    2 +-
 src/cairo-gl-private.h |   21 +++---
 src/cairo-gl-shaders.c |  195 +++++++++++++++++++++++++++++-------------------
 src/cairo-gl-surface.c |    3 +-
 4 files changed, 132 insertions(+), 89 deletions(-)

commit 405eee07ad9a5bc325b339b8588facb905fb28f5
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 00:02:28 2010 +0200

    gl: Get rid of cairo_gl_shader_source/mask_t
    
    Use the cairo_gl_operand_type_t instead. Those enums are pretty much
    identical.

 src/cairo-gl-glyphs.c  |   13 ++--
 src/cairo-gl-private.h |   67 ++++++++-------------
 src/cairo-gl-shaders.c |   60 ++++++++++---------
 src/cairo-gl-surface.c |  153 +++++++++++++++++++++++++++++-------------------
 4 files changed, 157 insertions(+), 136 deletions(-)

commit 5149bb87d7b547766ce6ff4976217454adbab562
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 11 21:35:13 2010 +0200

    gl: s/_cairo_gl_set_destination/_cairo_gl_context_set_destination/
    
    It's an operation on the context, so name it accordingly

 src/cairo-gl-device.c  |    2 +-
 src/cairo-gl-glyphs.c  |    2 +-
 src/cairo-gl-private.h |    2 +-
 src/cairo-gl-surface.c |   16 ++++++++--------
 4 files changed, 11 insertions(+), 11 deletions(-)

commit 9f34e403f38192d711304fbde4dedbaa8e15fd6e
Author: Benjamin Otte <otte@redhat.com>
Date:   Tue May 11 13:15:16 2010 +0200

    gl: Share vertex shaders
    
    Previously, we created a new vertex shader for every shader program we
    used. Now the code shares identical vertex shaders between programs.

 src/cairo-gl-device.c  |   17 ++++-
 src/cairo-gl-private.h |   27 ++++++--
 src/cairo-gl-shaders.c |  179 ++++++++++++++++++++++++++++--------------------
 src/cairo-gl-surface.c |    7 +-
 4 files changed, 142 insertions(+), 88 deletions(-)

commit 562c323ae8689907d7a62a7c2f5c10fb8d055608
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun May 16 17:47:13 2010 +0930

    cff: Use correct glyph advance when subsetting cff fonts
    
    Previously the glyph advance in font units was used for the widths in
    the PDF font dictionary. This only works for cff fonts that use a
    [0.001 0 0 0.001 0 0] font matrix.

 src/cairo-cff-subset.c                  |   38 +++++++++++++++++--------------
 src/cairo-pdf-surface.c                 |   19 ++++++++--------
 src/cairo-scaled-font-subsets-private.h |    6 ++---
 3 files changed, 34 insertions(+), 29 deletions(-)

commit edcefa87ed0a8ff59b54ef9251182ce68f9158ba
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed May 12 23:12:55 2010 +0930

    type1: Use correct glyph advance when subsetting type 1 fonts
    
    Previously the glyph advance in font units was used for the widths in
    the PDF font dictionary. This only works for Type 1 fonts that use a
    [0.001 0 0 0.001 0 0] font matrix.
    
    https://bugs.freedesktop.org/show_bug.cgi?id=28061

 src/cairo-pdf-surface.c                 |   23 ++++++++++++-----------
 src/cairo-scaled-font-subsets-private.h |    6 +++---
 src/cairo-type1-fallback.c              |   18 +++++++++---------
 src/cairo-type1-subset.c                |    6 +++---
 4 files changed, 27 insertions(+), 26 deletions(-)

commit 34fd094b3be54138c20ea5c4aab1d9597d056f35
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 16 10:23:30 2010 +0100

    rtree: Actually pin the node when pinning.
    
    How embarrassing.

 src/cairo-rtree-private.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 63062511f6755af9ddd2985250465f94ebc5a3e8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 16 10:15:42 2010 +0100

    boilerplate: Exercise manual double-buffering to a window
    
    Shouldn't possibly go wrong, but the mix of fbo and Window might prove
    interesting.

 boilerplate/cairo-boilerplate-gl.c |  117 ++++++++++++++++++++++++++++++++++++
 1 file changed, 117 insertions(+)

commit 605be3182308ec7dfe15e9d89890c33800b1eea9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 16 10:11:02 2010 +0100

    cairo: Missing private markup for _cairo_format_to_pixman_format

 src/cairoint.h |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 14d6c3e054da89e47fc82ea29a708290eefe1357
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 16 10:07:07 2010 +0100

    configure: Include PTHREAD_CFLAGS in CAIRO_LDFLAGS
    
    Required for successful linking of our programs. I am not sure what the
    impact this has upon other users of Cairo yet, I think we need to export
    the PTHREAD_CFLAGS via cairo.pc as well.

 configure.ac |    1 +
 1 file changed, 1 insertion(+)

commit c3df7e6d58364f883d91567757ed999ea88e10ca
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sun May 16 09:54:04 2010 +0100

    rtree: Replace undeclared TRUE/FALSE with 1/0

 src/cairo-rtree-private.h |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 465ceb330eada9937945f5c4d156169167d4bf8c
Author: Andrea Canciani <ranma42@gmail.com>
Date:   Sun May 16 09:41:12 2010 +0200

    test: improve copyright notices
    
    Conform copyright notices to a1-image-sample.c

 test/dash-offset.c              |   48 ++++++++++++++++-----------------------
 test/linear-gradient-extend.c   |   36 +++++++++++++++--------------
 test/radial-gradient-extend.c   |   36 +++++++++++++++--------------
 test/surface-pattern-operator.c |   36 +++++++++++++++--------------
 4 files changed, 76 insertions(+), 80 deletions(-)

commit e8bc25fdb21340b0a5a25f7193fd0bc5de540a50
Author: Andrea Canciani <ranma42@valium.area51.sns.it>
Date:   Fri May 14 21:40:13 2010 +0200

    test: add linear-gradient-extend and radial-gradient-extend
    
    Check that constant gradient to solid color optimization are only
    applied if the extents permit it.

 test/Makefile.sources               |    2 +
 test/linear-gradient-extend.c       |   90 +++++++++++++++++++++++++++++++++++
 test/linear-gradient-extend.ref.png |  Bin 0 -> 371 bytes
 test/radial-gradient-extend.c       |   90 +++++++++++++++++++++++++++++++++++
 test/radial-gradient-extend.ref.png |  Bin 0 -> 466 bytes
 5 files changed, 182 insertions(+)

commit a9d821b7a0f582b3d1b0175adee3350c81061a94
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 14 21:06:18 2010 +0200

    gl: gl surfaces are only similar when they share the same device
    
    Fixes gl-surface-source test for gl target

 src/cairo-gl-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 435329a70f172c8cec72831dd7a2b2cfc0496342
Author: Richard Procter <richard.n.procter@gmail.com>
Date:   Fri May 14 14:48:46 2010 -0400

    Bug 28100 - Font option CAIRO_HINT_METRICS_OFF unhonoured on win32
    
    Fix typo.  Ouch!

 src/cairo-win32-font.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3a550eb2253588372b2c071b3c3152d5271c1aa2
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 21:17:19 2010 +0200

    gl: Remove gradient optimizations
    
    These optimizations are done in cairo-gstate.c these days.

 src/cairo-gl-surface.c |   31 -------------------------------
 1 file changed, 31 deletions(-)

commit 3b1c0a4bd66660780095e6016e3db451f34503a3
Author: Benjamin Otte <otte@redhat.com>
Date:   Fri May 14 15:56:17 2010 +0200

    fallback: Remove span renderer paths
    
    Those paths were broken, as they didn't properly translate the polygon
    to the destination size. And rather than adding lots of code that allows
    translation, it's easier to just delete this code.
    
    Note that the only user of the code was the GL backend anyway.

 src/cairo-surface-fallback.c |   67 ------------------------------------------
 1 file changed, 67 deletions(-)

commit e3b2212bc5c4884eab356ae263b8318e10c379ac
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 15:14:29 2010 +0200

    build: Fix pthread detection
    
    Incorporate the pthread detection code from the autoconf archive. Should
    fix build on obscure archs that pretend to be UNIXy - like Mac OS X
    Tiger.
    
    http://www.gnu.org/software/autoconf-archive/
    http://www.gnu.org/software/autoconf-archive/ax_pthread.html

 build/ax-pthread.m4           |  283 +++++++++++++++++++++++++++++++++++++++++
 build/configure.ac.system     |   11 --
 configure.ac                  |   14 +-
 util/cairo-sphinx/Makefile.am |    5 +-
 util/cairo-trace/Makefile.am  |    2 +-
 5 files changed, 292 insertions(+), 23 deletions(-)

commit acfbf95a0c7620359fd917224b5b391702740190
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 14:21:21 2010 +0200

    test: Make global variables in new test static
    
    It seems there's no gcc flag that warns about this.

 test/zero-mask.c |    4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c69143e3f9c95ab3937a7efb8e4de170c4edb648
Author: Benjamin Otte <otte@redhat.com>
Date:   Wed May 12 21:14:36 2010 +0200

    gl: Don't keep a temporary surface in the device
    
    We get circular references that way.
    If it turns out later such a cache is critical, we'll need to invent a
    way to avoid circling references. For now, just pretend it's not
    important.

 src/cairo-gl-glyphs.c  |   36 ++++++++----------------------------
 src/cairo-gl-private.h |    1 -
 2 files changed, 8 insertions(+), 29 deletions(-)

commit ec1ca17b71b41159ea8754d42954863b62623536
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 12:07:53 2010 +0200

    gl: Don't create 0x0 surfaces
    
    We get a very annoyed libGL if we try to create 0x0 textures, so we
    return an image surface instead.
    
    Tested by the zero-mask test.

 src/cairo-gl-surface.c |    4 ++++
 1 file changed, 4 insertions(+)

commit 108e3f5031fc16843197382af78af299b19ef290
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 12:01:39 2010 +0200

    Use a solid color for 0xN and Nx0 surfaces
    
    This gets around the need to check for 0-sized surfaces in the backends.

 src/cairo-gstate.c |   15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 18c963824ebbb0e7054e682ecb5664a282a58552
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 11:56:22 2010 +0200

    Make _cairo_color_equal() work for unmultiplied colors, too
    
    Color stop colors are unmultiplied, and we use it there.

 src/cairo-color.c |   10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit 7bd8d0db1f4ac448c93d6d342726f64a0d6300e3
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 11:23:33 2010 +0200

    image: Fix wholly unbounded fixup
    
    Tested by zero-mask test.

 src/cairo-image-surface.c |    2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8aa50b5a7873b8317d0593105497607dbb2fae1d
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 10:27:37 2010 +0200

    cairo_paint_with_alpha(cr, 0.0) is only a noop when bounded by mask

 src/cairo.c |    3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ee32dfb3de035e73cb8c2073c0826daf244e3845
Author: Benjamin Otte <otte@redhat.com>
Date:   Thu May 13 10:04:49 2010 +0200

    test: Add a test for various zero mask operations

 test/Makefile.sources        |    3 +-
 test/zero-mask.c             |  199 ++++++++++++++++++++++++++++++++++++++++++
 test/zero-mask.ref.png       |  Bin 0 -> 402 bytes
 test/zero-mask.rgb24.ref.png |  Bin 0 -> 382 bytes
 4 files changed, 201 insertions(+), 1 deletion(-)

commit 986ae4232067d4f33931d98fb6324871a1025633
Author: Owen W. Taylor <otaylor@fishsoup.net>
Date:   Thu Feb 25 15:18:22 2010 -0500

    language bindings guide: clarify mapping for cairo_pattern_create_rgb[a]
    
    Clarify that cairo_pattern_create_rgb() and cairo_pattern_create_rgba()
    should be be overloaded as a single constructor for SolidPattern, but
    instead should be static methods.

 doc/public/language-bindings.xml |    9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 18b48a6ebc044c07f08bafd0abcb68c595c5746c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 13 10:00:18 2010 +0100

    Make cairo_color_stop_t a unique type.
    
    Hopefully reduce the occurrence of the confusion between the
    premultiplied shorts in cairo_color_t and the non-premultiplied shorts
    in cairo_color_stop_t.
    
    The existence of the two separate types is debatable and open for
    review.

 src/cairo-color.c         |    4 ++--
 src/cairo-gstate.c        |    2 +-
 src/cairo-pattern.c       |    2 +-
 src/cairo-pdf-surface.c   |    9 ---------
 src/cairo-ps-surface.c    |   32 ++------------------------------
 src/cairo-svg-surface.c   |    4 ++--
 src/cairo-types-private.h |   17 ++++++++++++++++-
 src/cairoint.h            |    4 ++--
 8 files changed, 26 insertions(+), 48 deletions(-)

commit dfa2544f158930b002df74e676f3ef7aeeee1bd4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu May 13 09:52:39 2010 +0100

    color: Special case comparing color stops.
    
